/*
 * =================================================================
 * 定数
 * =================================================================
 */

// 処理モード
var MODE = {
    APP_SETTING: 0,     // アプリ設定認証
    TEACHER_MODE: 1,    // 指導者モード切替認証
    CONTENT_AUTH_MODE: 2, // コンテンツ認証
    USE_PLACE_TYPE: 3, //利用場所
    HEADER_TEACHER_MODE: 4, // ヘッダーからの遷移：教師用
    RELEASE_MULTIPLE_LOGIN: 5, // 複数起動の解除
    TRIAL_MODE: 6, // 試用版インストール時(●●日間試用ボタン押下時)
    //DEMO_CODE_MODE: 7, // デモコードモード
    END_TRIAL_MODE: 8, // 試用期間終了
    // *** 年度更新 ***
    REAUTHENTICATION_MODE: 9, // 再認証モード(年度更新後の使用期限切れ)
    // *** 年度更新 ***
};

// アップデート状態
var UPDATE_STATE = {
    UN_UPDATE_MODE: "unUpdate",   // アップデートなし
    UPDATE_MODE: "update",    // アップデートがある
};

var DIALOG_BASE_HEIGHT = 588;
var ADDITIONAL_HEIGHT = 44;
var DIALOG_DESCRIPTION_HEIGHT = 56;
var CONFIRM_BUTTON_MARGIN = 40;
var CONFIRM_BUTTON_WIDTH_TRIAL = 200;
var CONFIRM_BUTTON_WIDTH_NORMAL = 256;


/*
 * =================================================================
 * 変数
 * =================================================================
 */
var current_mode;
var checkAddGrade;
var appSettingType;
var updateStatusType;
var magnification;
var multiInstallFlg;
var successCallback
var mCallbackForDemoDialog;
var mPasswordForDemo;
var mNumbersForInstallGrade;
// *** 年度更新対応 ***
var mBeforeAuthCode;
// *** 年度更新対応 ***

/*
 * =================================================================
 * 関数
 * =================================================================
 */

/*
 * 画面ロード時
 */
$(document).ready(function () {
    // PFの起動状態を取得
    startupMode = getStartupModeByFunc();
    if (startupMode == undefined) {
        // 取得失敗
        return;
    }

    // 画面の設定を取得
    var setDesign = pfDesignDecision();
    magnification = setDesign[0];
    var rate = setDesign[1];
});


/**
 * アプリ設定ダイアログを表示
 */
function pfOpenDialog(mode, contentImg, contentName, checkGrade, updateStatus, multiGradeInstallFlg, dialogContentId, userCallback)
{
    // *** 年度更新対応 ***
    if (mode == MODE.REAUTHENTICATION_MODE) {
        contentId = dialogContentId;
    }
    // *** 年度更新対応 ***

    // スクロール禁止
    $(window).on('touchmove.noScroll', function(e) {
        e.preventDefault();
    });

    
    // ダイアログ表示時にスクロールバーを消す
    $("body").css("overflow", "hidden");

    // Style定義
    var headerStyle = "font-size: 32px;color: #ffa500;font-weight: bold; margin-left: 20px;";
    var descriptionStyle = "font-size: 14px; margin-left: 20px;";

    // モードを退避
    current_mode = mode;
    // 追加する学年を退避
    checkAddGrade = checkGrade;
    // 内容更新
    updateStatusType = updateStatus;
    // 複数更新
    multiInstallFlg = multiGradeInstallFlg;
    // 成功時コールバック
    successCallback = userCallback;

    var res;
    var setTitle = "　";
    var setDetail = "　";
    var setImg = "　";
    var setContentName = "　";

    var authSkipHeight = 0;

    switch (mode)
    {
        case MODE.APP_SETTING:
            /***設定に遷移するときはパスワード入力がいらない ***/
            // アプリ設定画面へ遷移
            pageTransitionAppSettingByFunc();
            return;
            /***************************************/

            // 認証コードが設定されているかチェック
            res = checkAuthenticatedByFunc();
            
            appSettingType = res;
            setTitle = "パスワードの入力";
            setDetail = "設定画面のパスワードを入力してください。";
            if (!res) {
                // 認証コードが未設定の場合
                setTitle = "パスワードの設定";
                setDetail = "任意のパスワードを設定してください。";
            }
            break;
        case MODE.TEACHER_MODE:
            setTitle = "切り替え用パスワードの入力";
            setDetail = "指導者用の切り替えパスワードを入れてください。";
            break;
        case MODE.HEADER_TEACHER_MODE:
            setTitle = "切り替え用パスワードの入力";
            setDetail = "指導者用の切り替えパスワードを入れてください。";
            break;
        case MODE.CONTENT_AUTH_MODE:
        case MODE.END_TRIAL_MODE:
        case MODE.REAUTHENTICATION_MODE:
            if (mode == MODE.CONTENT_AUTH_MODE && PF_STARTUP_MODE.INSTALL_MODE == startupMode) {
                // 管理者権限のチェック
                // コンテンツ略称を取得
                var sname = getContentShortNameByFunc(dialogContentId);

                var shortName = JSON.parse(sname);
                var title = "インストール";
                var message = shortName[0].content_short_name + "をインストールするために，<br />ひまわりポケットの再起動が必要です。<br />再起動後，インストールしてください。";
                var width = 432;
                var isAdmin = checkIsAdmin(title, message, width);

                if (!isAdmin) {
                    return;
                }
            }

            if (mode == MODE.CONTENT_AUTH_MODE) {
                // 認証時
                setTitle = "コンテンツの認証";
                setDetail = "";
            } else if (mode == MODE.REAUTHENTICATION_MODE) {
                // *** 年度更新対応 ***
                setTitle = "コンテンツの認証";
                setDetail = "コンテンツの使用期限が切れています。有効な認証コードを入力して再認証してください。<br />";
                setDetail += "認証コードは，対象教材と一緒にお届けしているデジタル教材のディスク・説明書等に記載されています。";
                // 再認証前の認証コードを持っておく
                mBeforeAuthCode = getAuthCode(contentId, checkGrade);
                // *** 年度更新対応 ***
            } else {
                // 試用期間終了時
                setTitle = "試用期間が終了しました";
                setDetail = "引き続きご利用いただくには，再度認証が必要です。<br>";
            }
            //setDetail = "認証コードを入力してください。認証コードが不明な場合は、(株)光文書院までお問い合わせください。";
            var commonInfo = JSON.parse(getCommonInfoByFunc())[0];
            // *** 年度更新対応 ***
            if (mode != MODE.REAUTHENTICATION_MODE) {
                if (commonInfo.use_place_type == USE_PLACE_TYPE.HOME_MODE) {
                    setDetail += "認証コードを入力してください。認証コードは，学校にお届けしているデジタル教材の説明書(一部商品には同梱されています。)に記載されています。認証コードが不明な場合は，ひまわりICTサポートまでお問い合わせください。(ひまわりポケットの設定画面[その他]の項目からもアクセスいただけます。)";
                } else {
                    setDetail += "認証コードを入力してください。認証コードは，商品と一緒にお届けしているデジタル教材のディスク，説明書等に記載されています。認証コードが不明な場合は，ひまわりICTサポートまでお問い合わせください。(ひまわりポケットの設定画面[その他]の項目からもアクセスいただけます。)";
                }
            }
            // *** 年度更新対応 ***

            if (mode == MODE.CONTENT_AUTH_MODE) {
                // オンラインモードでない場合
                if (!mIsOnlineMode) {
                    // 認証スキップ期間の場合
                    if (isAuthSkipPeriodByFunc(dialogContentId)) {
                        setDetail += "<br>";
                        setDetail += "<span class='authSkip' style='padding-top: " + kbnGetMagnification(12) + ";'>";
                        setDetail += "本コンテンツは，体験版をお試しいただけます。商品を採択・購入いただくことで，試用期間後も引き続き本コンテンツをお使いいただけます。";
                        setDetail += "</span>";
                        authSkipHeight = 36;
                    }
                }
            }

            setImg = "<img src='../../" + replaceImagePath(contentImg) + "' style='width: 100%;' />";
            setContentName = contentName;
            break;

        case MODE.USE_PLACE_TYPE:
            setTitle = "学校コードの確認";
            setDetail = "学校コードを入れてください。";
            break;
        case MODE.RELEASE_MULTIPLE_LOGIN:
            setTitle = "複数起動の解除";
            setDetail = "指導者用の切り替えパスワードを入れてください。";
            break;
    }

    var dialogTranslation;
    var dialogBody;

    // 画面サイズ
    var dw = getTerminalWidth();
    var dh = getTerminalHeight();

    // ダイアログサイズ
    var dialogWidth = 952;
    var dialogHeight = DIALOG_BASE_HEIGHT;
    var discriptonHeight = DIALOG_DESCRIPTION_HEIGHT;
    var additionalHeight = 0;
    if (mode == MODE.CONTENT_AUTH_MODE) {
        additionalHeight = ADDITIONAL_HEIGHT + authSkipHeight;
    }
    if (mode == MODE.END_TRIAL_MODE) {
        additionalHeight = 62;
    }
    dialogHeight = dialogHeight + additionalHeight;
    discriptonHeight = discriptonHeight + additionalHeight;

    //ダイアログの背景設定
    dialogTranslation = createBackgroundDialog();


    //ダイアログ表示領域設定
    var dialogBody = $(document.createElement('div'));
    dialogBody.attr('id', 'dialog-main');
    dialogBody.css('position', 'fixed');
    dialogBody.css('top', ((dh - dialogHeight * magnification) / 2) + "px");
    dialogBody.css('left', ((dw - dialogWidth * magnification) / 2) + "px");
    dialogBody.css('border-radius', '10px');
    dialogBody.css('z-index', 31);
    dialogBody.css('opacity', 1);
    dialogBody.css('background-color', '#fff');

    var alphabetFlg = false;
    if (mode == MODE.APP_SETTING || mode == MODE.USE_PLACE_TYPE || mode == MODE.HEADER_TEACHER_MODE || mode == MODE.RELEASE_MULTIPLE_LOGIN) {
        alphabetFlg = true;
    }

    var numericFont = "";
    // フォントの設定
    if (!alphabetFlg) {
        // 数値の場合
        numericFont = "fontNumeric";
    }

    // 認証ダイアログの作成開始
    //var body = "<div style='width: " + kbnGetMagnification(952) + ";height: " + kbnGetMagnification(588) + "'>";
    var body = "<div class='authDialogWrapper' style='width: " + kbnGetMagnification(dialogWidth) + ";height: " + kbnGetMagnification(dialogHeight) + "'>";

    // 最上段
    body += "<div style='height: " + kbnGetMagnification(24) + ";width:100%;'></div>";

    // 最上段テキスト
    body += "<div style='widht: 100%;padding-bottom:" + kbnGetMagnification(16) + ";margin-left:" + kbnGetMagnification(8) + ";margin-left: " + kbnGetMagnification(40) + ";font-size: " + kbnGetMagnification(28) + ";color: #EB8219;font-weight: bold;'>";
    body += setTitle;
    body += "</div>";

    // 説明テキスト
    body += "<div class='authDialogDescription' style='widht: 100%;padding-bottom:" + kbnGetMagnification(24) + ";font-size: " + kbnGetMagnification(18) + ";line-height: " + kbnGetMagnification(24) + ";color: #302519;margin-left: " + kbnGetMagnification(40) + ";margin-right:" + kbnGetMagnification(40) + "; height:" + kbnGetMagnification(discriptonHeight) + ";'>";
    body += setDetail
    body += "</div>";

    // ==========表示領域===============
    //body += "<div style='width:" + kbnGetMagnification(872) + ";min-height: " + kbnGetMagnification(394) + " ;margin:0 auto;border: 1px solid  blue'>";
    body += "<div style='width:" + kbnGetMagnification(872) + ";min-height: " + kbnGetMagnification(340) + " ;margin:0 auto;'>";
    // ==============空白
    //body += "<div style='height:" + kbnGetMagnification(56) + "'></div>";
    // =============コンテンツ画像
    //body += "<div style='width: " + kbnGetMagnification(208) + ";height: " + kbnGetMagnification(124) + ";float:left;margin-left:" + kbnGetMagnification(8) + ";padding-bottom:" + kbnGetMagnification(8) + ";'>";
    body += "<div style='width: " + kbnGetMagnification(198) + ";height: " + kbnGetMagnification(124) + ";float:left;margin-left:" + kbnGetMagnification(8) + ";padding-bottom:" + kbnGetMagnification(8) + ";'>";
    // 画像がない場合枠線を消す
    if (setImg.trim() != "") {
        body += "<div style='border: 1px solid #8B8682;border-radius:" + kbnGetMagnification(8) + ";height:100%;width:100%;overflow:hidden;'>";
        body += setImg;
        body += "</div>";
    }
    body += "</div>";
    //　==========入力値領域=============
    body += "<div id='dispPass' class='" + numericFont + " dispPass' style='letter-spacing: 0.2em;margin-left:" + kbnGetMagnification(72) + ";float:left;width:" + kbnGetMagnification(380) + ";height: " + kbnGetMagnification(130) + ";background-color:#E5E2E2;border-radius:" + kbnGetMagnification(16) + ";border: 1px solid #302519;font-size:" + kbnGetMagnification(90) + ";line-height:" + kbnGetMagnification(130) + ";text-align: center;'>";

    body += "</div>";

    // ============コンテンツ名表示=============
    body += "<div style='margin-left: " + kbnGetMagnification(9) + ";font-size:" + kbnGetMagnification(16) + ";line-height:" + kbnGetMagnification(20) + ";font-weight: bold;width:100%;float:left;min-height:8px;'>" + setContentName + "</div>";

    // テンキー表示域
    body += "<div style='margin-left:" + kbnGetMagnification(288) + ";clear:both;'>";
    
    if (alphabetFlg) {
        // 設定画面以外の場合、アルファベットボタンの生成
        // セットA(2019年以降)
        body += "<div class='inputBtnSetA'>";
        body += "<img id='alphabet_A' class='numberBtn touchHandler' src='../img/dialog/btn_num-A.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_E' class='numberBtn touchHandler' src='../img/dialog/btn_num-E.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_H' class='numberBtn touchHandler' src='../img/dialog/btn_num-H.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_I' class='numberBtn touchHandler' src='../img/dialog/btn_num-I.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_K' class='numberBtn touchHandler' src='../img/dialog/btn_num-K.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<br />";
        body += "<img id='alphabet_M' class='numberBtn touchHandler' src='../img/dialog/btn_num-M.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_R' class='numberBtn touchHandler' src='../img/dialog/btn_num-R.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_T' class='numberBtn touchHandler' src='../img/dialog/btn_num-T.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_U' class='numberBtn touchHandler' src='../img/dialog/btn_num-U.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_Y' class='numberBtn touchHandler' src='../img/dialog/btn_num-Y.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        // deleteボタン
        body += "<img id='deleteAlpabet' class='touchHandler' src='../img/dialog/btn_num-delete-gray.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        // switchボタン
        body += "<img id='switchAlpabet' class='touchHandler' src='../img/dialog/btn_num-switch.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "</div>";
        // セットB(2018年以前)
        body += "<div class='inputBtnSetB'>";
        body += "<img id='alphabet_A' class='numberBtn touchHandler' src='../img/dialog/btn_num-A.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_B' class='numberBtn touchHandler' src='../img/dialog/btn_num-B.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_C' class='numberBtn touchHandler' src='../img/dialog/btn_num-C.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_D' class='numberBtn touchHandler' src='../img/dialog/btn_num-D.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_E' class='numberBtn touchHandler' src='../img/dialog/btn_num-E.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<br />";
        body += "<img id='alphabet_F' class='numberBtn touchHandler' src='../img/dialog/btn_num-F.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_G' class='numberBtn touchHandler' src='../img/dialog/btn_num-G.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_H' class='numberBtn touchHandler' src='../img/dialog/btn_num-H.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_I' class='numberBtn touchHandler' src='../img/dialog/btn_num-I.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "<img id='alphabet_J' class='numberBtn touchHandler' src='../img/dialog/btn_num-J.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        // deleteボタン
        body += "<img id='deleteAlpabet' class='touchHandler' src='../img/dialog/btn_num-delete-gray.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        // switchボタン
        body += "<img id='switchAlpabet' class='touchHandler' src='../img/dialog/btn_num-switch.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        body += "</div>";
    } else {
        // 設定画面以外の場合、数字ボタンの生成
        for (counter = 1; counter < 10 ; counter++) {
            changeTappingNumber(counter);
            body += "<img id='number_" + counter + "' class='numberBtn touchHandler' src='../img/dialog/btn_key-" + counter + ".svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
            // 数字5で改行
            if (counter == 5) {
                body += "<div style='float:right ; width:" + 64 * magnification + "px;height:" + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'></div>";
                body += "<br />";
            }
        }
        changeTappingNumber(0);
        body += "<img id='number_0' class='numberBtn touchHandler' src='../img/dialog/btn_key-0.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
        // deleteボタン
        body += "<img id='deleteNumber' class='touchHandler' src='../img/dialog/btn_key-delete.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
    }
    
    body += "</div>";
    // テンキー作成ここまで

    // 全部終了↓
    body += "</div>";

    // ボタン表示域
    body += "<div style='width:100%;'>";

    var confirmButtonMargin = CONFIRM_BUTTON_MARGIN;
    var isShowTrial = false;
    
    if (mode != MODE.END_TRIAL_MODE && mode != MODE.REAUTHENTICATION_MODE) {
        // オンラインモードでない場合
        if (!mIsOnlineMode) {
            // 試用期間終了時以外の場合は試用期間内かチェック。試用期間内なら試用ボタンを表示
            if (isAuthSkipPeriodByFunc(dialogContentId)) {
                // 日数を取得
                // H31ひまポケ先行 #253 MOD START
                //var contentMst = JSON.parse(getContentMstByFunc(dialogContentId))[0];
                // ↓
                var contentMst = JSON.parse(getTrialByFunc(dialogContentId))[0];
                // H31ひまポケ先行 #253 MOD END

                body += "<div id='btnTrial' class='" + BUTTON_TYPE.TRIAL + " touchHandler' style='float:right;margin-right: " + kbnGetMagnification(40) + "'>";
                body += contentMst.trial_period + "日間 試用する";
                body += "</div>";
                confirmButtonMargin = 20;
                isShowTrial = true;
            }
        }
    }

    body += "<div id='confirmPass' class='" + BUTTON_TYPE.MAIN + " touchHandler' style='float:right;margin-right: " + kbnGetMagnification(confirmButtonMargin) + "'>";
    body += "確認";
    body += "</div>";

    // H31ひまポケ先行 #253 MOD START
    //body += "<div id='dialogClose' class='" + BUTTON_TYPE.SUB + " touchHandler' style='float:right;margin-right :" + kbnGetMagnification(20) + "'>";
    //↓
    body += "<div id='dialogCancel' class='" + BUTTON_TYPE.SUB + " touchHandler' style='float:right;margin-right :" + kbnGetMagnification(20) + "'>";
    // H31ひまポケ先行 #253 MOD END
    body += "キャンセル";
    body += "</div>";

    body += "</div>";

    $(dialogBody).append(body);
    
    $('body').append(dialogTranslation);
    $('body').append(dialogBody);

    // タップ時の画像変更イベントを登録
    changeTappingAlphabet("A");
    changeTappingAlphabet("B");
    changeTappingAlphabet("C");
    changeTappingAlphabet("D");
    changeTappingAlphabet("E");
    changeTappingAlphabet("F");
    changeTappingAlphabet("G");
    changeTappingAlphabet("H");
    changeTappingAlphabet("I");
    changeTappingAlphabet("J");
    changeTappingAlphabet("K");
    changeTappingAlphabet("M");
    changeTappingAlphabet("R");
    changeTappingAlphabet("T");
    changeTappingAlphabet("U");
    changeTappingAlphabet("Y");

    $(".inputBtnSetB").hide();

    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.MAIN, isShowTrial ? CONFIRM_BUTTON_WIDTH_TRIAL : CONFIRM_BUTTON_WIDTH_NORMAL, "confirmPass");
    // 汎用ボタンのスタイルを適用
    // H31ひまポケ先行 #253 MOD START
    //setCommonButtonStyle(BUTTON_TYPE.SUB, isShowTrial ? 144 : 176, "dialogClose");
    //↓
    setCommonButtonStyle(BUTTON_TYPE.SUB, isShowTrial ? 144 : 176, "dialogCancel");
    // H31ひまポケ先行 #253 MOD END
    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.TRIAL, 200, "btnTrial");

}

/**
 * 選択した数値を表示、格納します。
 */
$(document).on("click", ".numberBtn", function () {

    // 4文字の場合は入力が出来ないようにする。
    if (nowPassWord.length > 3) {
        return false;
    }

    // 押下したボタンのIDを取得
    var numberId = $(this).attr('id');

    var number = numberId.split("_");

    // 現在のパスワードを保存
    nowPassWord += number[1];

    // 表示
    $('#dispPass').text(nowPassWord);

});

/**
 * パスワード認証チェック
 * @return {bool} 結果(true:成功、false:失敗)
 */
$(document).on("click", "#confirmPass", function () {
    return confirmPassword();
});

/**
 * 試用インストール
 * @return {bool} 結果(true:成功、false:失敗)
 */
$(document).on("click", "#btnTrial", function () {
    var tmpMode = current_mode;
    current_mode = MODE.TRIAL_MODE; // モードをコンテンツインストールから、試用インストールに切り替える
    //return confirmPassword();
    confirmPassword();
    // モードを戻す
    current_mode = tmpMode;
    // 内部コードを画面に表示されているコードで上書きする(試用版コードになっている為)
    nowPassWord = $('#dispPass').text();
});


/**
 * 入力されているパスワードを削除
 */
$(document).on("click", "#deleteNumber", function () {
    // 現在のパスワードから末尾の文字を削除
    nowPassWord = nowPassWord.slice(0, -1);

    // 表示
    $('#dispPass').text(nowPassWord);
});

/**
 * 入力されているパスワードを削除:アルファベット
 */
$(document).on("click", "#deleteAlpabet", function () {
    // 現在のパスワードから末尾の文字を削除
    nowPassWord = nowPassWord.slice(0, -1);

    // 表示
    $('#dispPass').text(nowPassWord);
});

/**
 *アルファベットの配列を変更
 */
$(document).on("click", "#switchAlpabet", function () {
    if ($(".inputBtnSetA").css("display") == "none") {
        $(".inputBtnSetB").hide();
        $(".inputBtnSetA").show();
    } else {
        $(".inputBtnSetA").hide();
        $(".inputBtnSetB").show();
    }
});

/**
 * ダイアログを閉じる
 */
$(document).on("click", "#dialogClose", function () {

    // オンラインの場合、トップ画面に戻る
    if (mIsOnlineMode) {
        kbnPageTransition("index.html");
        return;
    }

    closeDialog();

    switch (current_mode) {
        case MODE.TEACHER_MODE:
            // 学習者用に戻す
            revertChildMode();
            break;
        case MODE.USE_PLACE_TYPE:
            // 家庭使用に戻す
            revertHomeMode();
            break;
        case MODE.END_TRIAL_MODE:
            // アンケート確認
            var callback = function () {
                kbnOpenBrowser("https://www.kobun.co.jp/dk/tabid/498/Default.aspx");
            }
            var title = "アンケートのご確認";
            var message = "デジタル教材の利用に関する<br>アンケートにご協力ください。";
            kbnConfirm(title, message, callback, 275);

            break;
    }
});

// H31ひまポケ先行 #253 ADD START
$(document).on("click", "#dialogCancel", function () {

    // オンラインモードをオフラインへ
    mIsOnlineMode = false;

    closeDialog();

    switch (current_mode) {
        case MODE.TEACHER_MODE:
            // 学習者用に戻す
            revertChildMode();
            break;
        case MODE.USE_PLACE_TYPE:
            // 家庭使用に戻す
            revertHomeMode();
            break;
        case MODE.END_TRIAL_MODE:
            // アンケート確認
            var callback = function () {
                kbnOpenBrowser("https://www.kobun.co.jp/dk/tabid/498/Default.aspx");
            }
            var title = "アンケートのご確認";
            var message = "デジタル教材の利用に関する<br>アンケートにご協力ください。";
            kbnConfirm(title, message, callback, 275);

            break;
    }
});
// H31ひまポケ先行 #253 ADD END

function revertChildMode()
{
    $("input[name='mode']").val(["1"]);
    updateAppSettingByFunc("mode", "1");
}

function revertHomeMode()
{
    $("input[name='use_place_type']").val(["2"]);
    updateAppSettingByFunc("use_place_type", "2");
}

// 削除ボタン
$(document).on("mousedown", "#deleteNumber", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete_tap.svg");
});

$(document).on("mouseup", "#deleteNumber", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

$(document).on("mouseout", "#deleteNumber", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

// 削除ボタン:アルファベット削除ボタン
$(document).on("mousedown", "#deleteAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray_tap.svg");
});

$(document).on("mouseup", "#deleteAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

$(document).on("mouseout", "#deleteAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

// アルファベット切り替えボタン
$(document).on("mousedown", "#switchAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch_tap.svg");
});

$(document).on("mouseup", "#switchAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});

$(document).on("mouseout", "#switchAlpabet", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});

// 認証処理
function confirmPassword() {

    var res;
    // 文字列長チェック
    if (nowPassWord.length < 4) {
        res = false;
    }
    var ngTitle;
    switch (current_mode) {
        // 設定認証
        case MODE.APP_SETTING:
            ngTitle = "設定認証";
            // 未設定の場合
            if (!appSettingType) {
                // 入力桁数が足りない場合
                if (nowPassWord.length < 4) {
                    var callback = function () {
                    }
                    playAlertSE();
                    kbnAlert(ngTitle, "パスワードは4桁で入力してください。", callback, 432);
                    return;
                }

                // 入力パスワードの再確認。
                var callback = function () {
                    // パスワードを登録
                    checkAppSettingAuthCodeByFunc(nowPassWord);
                }
                kbnConfirm("確認", "パスワードを設定します。" + nowPassWord + " でよろしいですか？<br>登録後の変更はできません。", callback, 432);
                return;
            }

            // パスワードをチェック
            res = checkAppSettingAuthCodeByFunc(nowPassWord);
            if (!res) {
                // 認証失敗時にスーパーパスワードをチェックする
                superPassword = checkSuperPasswordByFunc(nowPassWord);

                // スーパーパスワードが一致
                if (superPassword) {

                    var message = "スーパーパスワードで認証しました。<br />次回の設定時にパスワードを再登録してください。";
                    var callback = function () {
                        // アプリ設定画面へ遷移
                        pageTransitionAppSettingByFunc();
                    };
                    kbnAlert(ngTitle, message, callback, 432);
                    return;
                }
            }
            break;
            // 指導者モード切替
        case MODE.TEACHER_MODE:
            ngTitle = "指導者用切り替え";
            res = checkTeacherModeAuthCodeByFunc(nowPassWord, false);

            if (res) {
                // ダイアログを閉じる
                closeDialog();
            }

            break;
            // 指導者モード切替:ヘッダー遷移
        case MODE.HEADER_TEACHER_MODE:
            ngTitle = "指導者用切り替え";
            res = checkTeacherModeAuthCodeByFunc(nowPassWord, false);

            if (res) {
                // 成功
                updateAppSettingByFunc("mode", "2");
                // ダイアログを閉じる
                closeDialog();
                // 画面をリフレッシュ
                location.reload();
            } else {
                var commonInfo = JSON.parse(getCommonInfoByFunc())[0];
                if (commonInfo.user_change_type == USE_CHANGE_MODE.ANY_MODE) {
                    // 任意パスワードの場合、スーパーパスワードをチェックする
                    superPassword = checkSuperPasswordByFunc(nowPassWord);
                    // スーパーパスワードが一致
                    if (superPassword) {

                        var message = "パスワードを再設定してください。";
                        ngTitle = "指導者用切り替えパスワードをリセットしました。";
                        var callback = function () {
                            // ダイアログを閉じる
                            closeDialog();
                            // 成功
                            updateAppSettingByFunc("mode", "2");
                            // パスワード再設定
                            openStepFourDialog(OPEN_DIALOG_STATUS.RESET_PASSWORD);
                        };
                        kbnAlert(ngTitle, message, callback, 432);
                        return;
                    }
                }
            }
            break;
        case MODE.CONTENT_AUTH_MODE: // コンテンツの認証モード
        case MODE.END_TRIAL_MODE: // 試用期間終了モード
        case MODE.TRIAL_MODE: // 試用版(体験版)インストールモード
        case MODE.REAUTHENTICATION_MODE: // 再認証モード
            ngTitle = "コンテンツの認証";

            var isDemoCode = false;
            var authenticationType;
            if (current_mode != MODE.TRIAL_MODE) {
                // 試用版(体験版)以外の場合は認証コードチェック
                // 入力桁数が足りない場合
                if (nowPassWord.length < 4) {
                    var callback = function () {
                    }
                    playAlertSE();
                    kbnAlert("認証コードの入力", "認証コードは4桁で入力してください。", callback, 432);
                    return;
                }

                // 認証が必要なコンテンツかチェック
                var authArray = checkAuthenticationTypeByFunc(contentId);
                var auth = JSON.parse(authArray)[0];

                var grade = "";
                var nowAuthenticationType;
                authenticationType = auth.authentication_type;
                if (auth.authentication_type == AUTHENTICATION_TYPE.NO) {
                    // 認証が不要な場合、マスタから取得した学年を設定（後続の有効期限チェックで使用する)
                    grade = auth.grade;
                } else {
                    // 認証が必要な場合はチェック
                    resJson = checkContentAuthCodeByFunc(contentId, nowPassWord);
                    if (resJson != "") {
                        var obj = JSON.parse(resJson);

                        // 期間限定コードの場合、学年入力が必要なコンテンツは学年入力ダイアログを表示
                        if (obj[0].authentication_type == AUTHENTICATION_TYPE.LIMITED_PERIOD) {
                            grade = undefined;
                            isDemoCode = true;
                        } else {
                            grade = obj[0].grade;
                        }
                        nowAuthenticationType = obj[0].authentication_type;
                        nowPassWord = obj[0].authentication_code; // 複数認証コードが存在する為、マスタ上の認証コードで上書きする
                    }
                }
                mIsTrial = false;
            } else {
                nowPassWord = TRIAL_CODE;
                mIsTrial = true;
            }

            // 認証成功時
            //if (resJson != "") {
            if (grade != "") {
                var callback = function (grade, password, isForceGradeUpdate) {

                    res = true;

                    var addGradeFlg = true;
                    var upContentJson = "";

                    if (isForceGradeUpdate) {
                        // インストール学年選択から遷移した場合
                        checkAddGrade = grade;
                    }
                    if (current_mode == MODE.TRIAL_MODE) {
                        // 体験版の場合、既に利用済みかチェックする
                        // H31ひまポケ先行 #253 MOD START
                        //var setting = JSON.parse(getContentSettingByFunc(contentId, grade));
                        //↓
                        var setting = JSON.parse(getUseTrialFlgByFunc(contentId, grade));
                        // H31ひまポケ先行 #253 MOD END
                        if (setting.use_trial_flg == "1") {
                            var callback = function () { };
                            kbnAlert("体験版の利用は1回のみ有効です。", "本コンテンツでは既に体験版を利用しています。<br>引き続き利用する場合は，認証コードを入力し，認証を完了してください。", callback, 630);
                            return;
                        }

                    } else {
                        // 試用版(体験版)以外の場合は認証コードチェック

                        if (!authenticationType || authenticationType != AUTHENTICATION_TYPE.NO) {
                            // 認証が必要なコンテンツの場合
                            // 有効期限内かどうか判定
                            var contentPeriod = JSON.parse(checkContentPeriodByFunc(password));

                            if (contentPeriod[0].cnt == "0") {
                                // 有効期限外の場合
                                var callback = function () { };

                                playAlertSE();
                                var title;
                                var message;
                                if (isDemoCodeContentByFunc(password)) {
                                    // 期間限定コードの場合はコード間違い扱いにする（コードが使えるという事が分かってしまうため)
                                    title = "コンテンツの認証";
                                    message = "認証コードが誤っています。"
                                } else {
                                    title = "使用期間エラー";
                                    message = "本コンテンツは使用期限を過ぎているか，使用期間前です。<br>使用期限を過ぎている場合は，最新のひまわりポケットをご確認ください。<br>使用期間前の場合は，使用可能時期になるまでお待ちください。";

                                }
                                kbnAlert(title, message, callback, 630);
                                return;
                            }

                            // アップデートが必要なコンテンツを取得
                            upContentJson = getUpdateContentByFunc();

                            // 学年追加で選択した学年以外をエラーにする
                            if (checkAddGrade != 0 && grade != checkAddGrade) {
                                if (multiInstallFlg != 1) {
                                    // 複数学年インストールが有効な場合そちらもチェック
                                    addGradeFlg = false;
                                }
                            }

                            // 学年が0または内容更新時
                            if (grade == 0) {
                                addGradeFlg = true;
                            }
                        }

                    }

                    // PFの起動モードをチェックする
                    if (startupMode == 1) {

                        if (current_mode == MODE.CONTENT_AUTH_MODE) {
                            // 通常認証、特殊認証の場合
                            // 認証されたコンテンツがすでにインストール済みの場合にインストールを行わない
                            //var res = getContentInstallationSituationByFunc(contentId, grade);

                            var upFlg = false;
                            // 更新が存在する場合
                            if (upContentJson != "") {
                                var upContent = JSON.parse(upContentJson);
                                for (var val in upContent) {
                                    if (upContent[val].content_id == contentId && updateStatusType == UPDATE_STATE.UPDATE_MODE) {
                                        upFlg = true;
                                        if (grade == upContent[val].grade) {
                                            addGradeFlg = true;
                                            break;
                                        } else {
                                            addGradeFlg = false;
                                        }
                                    }
                                }
                            }

                            //// インストール済みの場合ダウンロード処理を行わない
                            //if (JSON.parse(res)[0].install_flg == 1 && !upFlg) {
                            //    var title = "コンテンツインストール";
                            //    var message = "そのコンテンツはすでにインストールされています。";
                            //    var callback = function () {

                            //    }
                            //    kbnAlert(title, message, callback, 437);
                            //    return;
                            //}
                        }

                        // 認証失敗時
                        if (!addGradeFlg) {
                            var callback = function () {
                            }
                            playAlertSE();
                            kbnAlert(ngTitle, "認証に失敗しました。", callback, 432);
                            return;
                        }

                        // 認証フラグを更新
                        mSpecialAuthCode = undefined;
                        var isSpecialAuthCode = false;
                        if (nowAuthenticationType == AUTHENTICATION_TYPE.SPECIAL) {
                            // 特殊認証の場合は入力した認証コードを更新する
                            isSpecialAuthCode = true;
                        }
                        mCurrentAuthGrade = grade;
                        // 認証コードを更新する
                        clearAuthCodeByFunc(contentId, grade);
                        updateAuthCodeByFunc(contentId, grade, password, isSpecialAuthCode);
                        //var res = updateAuthenticationFlgByFunc(contentId, grade, 1, specialAuthCode);
                    }
                    // ダイアログを閉じる
                    closeDialog();

                    //if (current_mode == MODE.CONTENT_AUTH_MODE) {
                    //    // 教科書・教材設定
                    //    openStandardMaterialDialog(grade, "web", 0, checkAddGrade, false);
                    //} else {
                    //    // コンテンツを起動

                    //    // 表示用コンテンツ情報を取得
                    //    var resJson = getContentDetailInfoByFunc(contentId);
                    //    var obj = JSON.parse(resJson)[0];


                    //    var id = "contentId_" + contentId + "_gradeInputFlg_" + obj.grade_input_flg + "_contentType_" + obj.content_type + "_grade_" + grade;
                    //    startContentCommon(id);
                    //}
                    if (current_mode == MODE.END_TRIAL_MODE) {
                        // 認証コード受領
                        kbnAlert("認証", "認証コードを更新しました。", undefined, 300);

                    }
                    // *** 年度更新対応 ***
                    else if (current_mode == MODE.REAUTHENTICATION_MODE) {
                        // kbnAlertの第３引数にコールバックを入れる
                        // コールバック：コンテンツのバージョンチェック処理
                        var runUpdate = false;
                        
                        upContentJson = getVersionUpInfoByFunc(false);

                        if (upContentJson != "") {
                            var upContent = JSON.parse(upContentJson);
                            for (var val in upContent) {
                                if (upContent[val].content_id == contentId && updateStatusType == UPDATE_STATE.UPDATE_MODE) {
                                    if (grade == upContent[val].grade) {
                                        runUpdate = true;
                                        break;
                                    } else {
                                        runUpdate = false;
                                    }
                                }
                            }
                        }

                        var isOnline = isOnlineContent(contentId, grade);

                        var callback = undefined;
                        if (runUpdate && !isOnline) {
                            callback = function () {
                                setTimeout(function () {
                                    // DBの更新通知バージョンを更新する
                                    mContentId = contentId;
                                    mGrade = grade;
                                    mGradeText = grade;

                                    // 更新
                                    var updateCallback = function () {
                                        mForceUpdate = false; // 強制アップデートするかどうか
                                        openExpiredVersionUpRunningDialog(mContentId, mGrade, mBeforeAuthCode);
                                        mIsVersionUp = true;
                                        mHasNext = versionUpContentByFunc(mContentId, mGrade, mForceUpdate);
                                    }
                                    kbnAlert("", "コンテンツをアップデートします。", updateCallback, 410);
                                }, 200);
                            }
                        }
                        else {
                            callback = function () {
                                location.reload();
                            }
                        }
                        // 通知を出力
                        // 認証コード受領
                        kbnAlert("認証", "認証コードを更新しました。", callback, 300);
                    }
                    // *** 年度更新対応 ***
                    else {
                        // 教科書・教材設定
                        openStandardMaterialDialog(grade, "web", 0, checkAddGrade, false, undefined, undefined, undefined, undefined, undefined, isSpecialAuthCode);
                    }
                };

                mCurrentAuthCode = nowPassWord;

                if (isDemoCode || current_mode == MODE.TRIAL_MODE) {
                    if (!is1DiscId1GradeContentByFunc(contentId)) {
                        // デモ、体験版で学年毎にインストールしない場合(デジ漢など）
                        callback("0", nowPassWord, false);
                    } else {
                        var setting = JSON.parse(getContentSettingByFunc(contentId, checkAddGrade));

                        if (setting.install_date) {
                            // 再認証の場合は元の学年で更新
                            callback(checkAddGrade, nowPassWord, false);
                        } else {
                            // デモ、体験版で学年毎にインストールする場合（デジ理科など）
                            InputGradeForDemoDialog(contentId, nowPassWord, callback);
                        }
                    }
                } else {
                    // 通常、特殊認証の場合
                    callback(grade, nowPassWord, false);
                }

            } else {
                var callback = function () {
                }
                playAlertSE();
                kbnAlert(ngTitle, "認証コードが誤っています。", callback, 432);
                return;
            }

            return;

            break;
        case MODE.USE_PLACE_TYPE:
            // 使用場所切り替え
            ngTitle = "学校コードの確認";
            res = checkTeacherModeAuthCodeByFunc(nowPassWord, true);
            if (res) {
                // ダイアログを閉じる
                closeDialog();
                location.reload();
            }
            break;
            // 複数起動の解除
        case MODE.RELEASE_MULTIPLE_LOGIN:
            ngTitle = "複数起動の解除";
            res = checkTeacherModeAuthCodeByFunc(nowPassWord, false);

            if (res) {
                // 成功
                // ダイアログを閉じる
                closeDialog();

                // 強制フラグとコンテンツを起動する
                if (successCallback) {
                    successCallback();
                }
            }
            break;
    }
    // 認証失敗時
    if (!res) {
        var callback = function () {
        }
        playAlertSE();
        kbnAlert(ngTitle, "認証に失敗しました。", callback, 432);
    }
}

/**
 * デモコード、体験版用の学年入力ダイアログを生成する
 */
function InputGradeForDemoDialog(contentId , password, callback) {

    closeDialog();

    mCallbackForDemoDialog = callback;
    mPasswordForDemo = password;

    inputNumberClear();

    // ダイアログの背景を作成
    var dialog = createBackgroundDialog();

    var gradeFlg = true;

    // 動的にエリアの幅を変える必要がある
    var inputAreaWidth = 380;
    var leftPoint = 25;

    // 画面サイズ
    var dw = getTerminalWidth();
    var dh = getTerminalHeight();

    //ダイアログ表示領域設定
    var dialogBody = $(document.createElement('div'));
    dialogBody.attr('id', 'dialog-grade-input');
    dialogBody.css('position', 'fixed');
    dialogBody.css('top', ((dh - 588 * magnification) / 2) + "px");
    dialogBody.css('left', ((dw - 952 * magnification) / 2) + "px");
    dialogBody.css('border-radius', '10px');
    dialogBody.css('z-index', 31);
    dialogBody.css('opacity', 1);
    dialogBody.css('background-color', '#fff');

    // ===============入力領域のstyle===============
    var inputAreaStyle = "float:left ;height: " + 130 * magnification + "px; border: solid  1px #AEADAD;" +
        "background-color:#E5E2E2 ; font-size: " + 72 * magnification + "px;border-radius:" + 16 * magnification
        + "px; line-height: " + 130 * magnification + "px;";

    var inputTextStyle = "float: left;margin-top: " + 86 * magnification + "px;font-weight: bold; font-size: " + 24 * magnification + "px;margin-left:" + 8 * magnification + "px;margin-right: " + 16 * magnification + "px;";

    var body = "<div style='height: " + 558 * magnification + "px;'>";

    // div
    var spanStyle = " style='padding-left: " + 10 * magnification + "px;'";
    var message = "<span>インストールする学年を入力してください</span>";

    body += "<div class='infoText' style='margin-left: " + 24 * magnification + "px;margin-top: " + 28 * magnification + "px;height:" + 24 * magnification + " px;'>";
    body += "<p style='font-size: " + 24 * magnification + "px;color: #EB8219;font-weight: bold;'>" + message + "</p>";
    body += "</div>";

    // 何もない領域
    body += "<div style='margin-left: " + 32 * magnification + "px;margin-top:" + 24 * magnification + "px;border-top: 1px solid #302519'>";
    body += "</div>";

    // インストールされていない学年を表示する領域
    body += "<div style='height: " + 88 * magnification + "px;'>";
    body += "<div style='font-size: " + 28 * magnification + "px;padding-top:" + 30 * magnification + "px;text-align:center;'>";
    body += "<span id='unGradeInstallTxt'>その学年のコンテンツはありません</span>";
    body += "</div>";
    body += "</div>";

    // ===========入力エリア始まり==============

    body += "<div style='width: 100%;height: " + 130 * magnification + "px;position: relative;'>";
    body += "<div style='height: 130px;float: left;position: relative;left: " + leftPoint + "%;text-align: center'>";
    body += "<div id='gradeDisplayArea' class='fontNumeric addgradeDisplayArea' style='" + inputAreaStyle + "width: " + inputAreaWidth * magnification + "px;'></div>";
    body += "<div class='gradeInputArea' style='" + inputTextStyle + "'>ねん</div>";
    body += "</div>";
    body += "</div>";// 入力エリア終わり

    // ==============数字エリア==============

    // 数字ボタンの表示領域生成
    body += "<div style='padding-bottom: 28px;;clear: both;margin-top: " + 32 * magnification + "px;text-align:center;'>";

    // 数字ボタンの生成
    for (counter = 1; counter < 10 ; counter++) {
        changeTappingNumber(counter);

        var inputBtnDisabled = "";

        // 数値ボタンの表示
        if (counter >= 7) {
            inputBtnDisabled = "opacity: " + mOpacityValue + ";";
        }

        body += "<img id='number_" + counter + "' class='inputNumberBtnForDemo touchHandler' src='../img/dialog/btn_key-" + counter + ".svg' style='" + inputBtnDisabled + " width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";

        // 数字5で改行
        if (counter == 5) {
            body += "<div style='float:right ; width:" + 64 * magnification + "px;height:" + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'></div>";
            body += "<br />";
        }
    }
    changeTappingNumber(0);
    body += "<img id='number_0' class='inputNumberBtnForDemo touchHandler' src='../img/dialog/btn_key-0.svg' style='opacity: 0.4;width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";

    // deleteボタン
    body += "<img id='deleteBtnForDemo' class='touchHandler' src='../img/dialog/btn_key-delete.svg' style='width:" + 64 * magnification + "px;height: " + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
    body += "</div>"; // 数字エリア終わり

    // ==============下の領域================
    body += "<div style='width: " + 952 * magnification + "px;height: " + 80 * magnification + "px;'>";
    body += "<div id='startContentForDemo' class='" + BUTTON_TYPE.MAIN + " touchHandler' style='float:right;margin-right: " + 40 * magnification + "px;margin-top: " + 0 * magnification + "px;'>";
    body += "設定";
    body += "</div>";
    body += "<div id='dialogCloseForDemo' class='returnBtn " + BUTTON_TYPE.SUB + " touchHandler' style='float:right;margin-right: " + 16 * magnification + "px;margin-top:" + 0 * magnification + "px;'>";
    body += "<div style=''>もどる</div>";
    body += "</div>";

    // 全div終了
    body += "</div>";

    $(dialogBody).append(body);

    $('body').append(dialog);
    $('body').append(dialogBody);

    // 一度全ての数値を非活性にする
    setDisableAllNumber();

    // インストール可能な学年だけ活性化する
    setEnableInstallNumber(contentId);

    // エラーメッセージを非表示に
    $("#unGradeInstallTxt").hide();

    $("#gradeDisplayArea").css("border", "solid  2px #EB8219");

    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.MAIN, 256, "startContentForDemo");
    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.SUB, 176, "dialogCloseForDemo");
}

// 学年入力の数値ボタン押下時
$(document).on("click", ".inputNumberBtnForDemo", function () {

    // 押下したボタンのIDを取得
    var numberId = $(this).attr('id');

    var number = numberId.split("_");

    var spanStyle = " style='padding-left: " + 10 * magnification + "px;'";

    // 各入力表示域に表示する
    if ($("#gradeDisplayArea").text().length == 0) {
        $("#gradeDisplayArea").text(number[1]);
        nowInputGrade += number[1];
        // 入力エリアの枠色変更
        $("#gradeDisplayArea").css("border", "solid  1px #AEADAD");

        setDisableAllNumber();
    }
});

// 削除ボタン押下時
$(document).on("click", "#deleteBtnForDemo", function () {

    var borderFocus = "solid 2px #EB8219 ";
    var borderDefault = "solid 1px #AEADAD";
    $("#gradeDisplayArea").text("");

    // インストール可能な学年だけ活性化する
    setEnableInstallNumber();

    // 入力エリアの枠色変更
    $("#gradeDisplayArea").css("border", borderFocus);
});

// ボタンの活性・非活性を設定
function setOpacityNumberButton(numbers, opacity) {

    for (var i = 0; i < numbers.length; i++) {
        var $elem = $("#number_" + numbers[i]);
        $elem.css("opacity", opacity.toString());
        if (opacity == 1) {
            // 活性状態
            $elem.removeAttr("disabled");
            $elem.css("pointer-events", "auto");
        } else {
            // 非活性状態
            $elem.attr("disabled", "disabled");
            $elem.css("pointer-events", "none");
        }
    }
}

$(document).on("mousedown", "#deleteBtnForDemo", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete_tap.svg");
});

$(document).on("mouseup", "#deleteBtnForDemo", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

$(document).on("mouseout", "#deleteBtnForDemo", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

$(document).on("click", "#startContentForDemo", function () {
    var inputGrade = $("#gradeDisplayArea").text();

    // 入力チェック
    var isValid = true;
    if ($("#gradeDisplayArea").length > 0 && inputGrade.length == 0) {
        // 学年が未入力
        isValid = false;
    }

    // 未入力がある場合
    if (!isValid) {
        var callback = function () {
        }
        playAlertSE();
        kbnAlert("入力エラー", "インストールする学年を入力してください。", callback, 432);
        return;
    }

    closeDialog('dialog-grade-input');

    // コールバックを実行する
    current_mode = MODE.TRIAL_MODE;
    mCallbackForDemoDialog(inputGrade, mPasswordForDemo, true);
});


$(document).on("click", "#dialogCloseForDemo", function () {
    closeDialog('dialog-grade-input');
});

// 全ての番号を非活性にする
function setDisableAllNumber() {
    var numbers = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
    setOpacityNumberButton(numbers, mOpacityValue);
}

// インストール可能な番号（学年）だけ活性化する
function setEnableInstallNumber(contentId) {
    if (contentId) {
        // コンテンツIDが指定されていない場合(2回目以降)は前回の情報で活性化する
        var contentSetting = JSON.parse(getContentInfoByContentIdByFunc(contentId));
        mNumbersForInstallGrade = new Array();
        for (var i = 0; i < contentSetting.length; i++) {
            // 未インストールの学年のみ追加
            if (contentSetting[i].install_flg == "0") {
                mNumbersForInstallGrade.push(contentSetting[i].grade);
            }
        }
    }
    setOpacityNumberButton(mNumbersForInstallGrade, 1);
}