
/*
 * =================================================================
 * 定数
 * =================================================================
 */

// アップデート状態
var UPDATE_STATE = {
    UN_UPDATE_MODE: "unUpdate",   // アップデートなし
    UPDATE_MODE: "update",    // アップデートがある
    ADD_OR_DELETE_MODE: "addOrDelete",  // 追加・削除モード
};

// コンテンツタイプ
var CONTENT_TYPE = {
    STANDARD: 1, // HTML/CSS
    EXTERNAL_APP: 2, // 外部アプリ
    INTRODUCTION: 3, // 紹介コンテンツ
    URL_SCHEME: 4 // 外部アプリ(URLスキーム)
};

// インストール方法
var INSTALL_TYPE = {
    ROM_INSTALL: "rom",　// ROMインストール
    WEB_INSTALL: "web"　// WEBインストール
};

var ERROR_MESSAGE = {
    CAPACITY_ERROR : "capacity",
    UNAUTHENTICATION_ERROR : "UnauthorizedAccess"
};

// コンテンツ起動方法
var PF_STARTUP_TYPE = {
    INSTALL: 1,         // インストール可
    ROM_ONLY: 2,        // ROM起動のみ
    INSTALL_ONLY: 3,    // インストールのみ
};

// ios標準版インストールフラグ
var IOS_CONTENT_INSTALL = {
    DEMO_INSTALL: 1,         // 標準版インストール
    INSTALL: 2        // インストール
};

/*
 * =====================================================
 * 変数
 * =====================================================
 */
// コンテンツID
var contentId;
// コンテンツ遷移状態
var confirmType;
// コンテンツタイプ
var contentType;
// 起動方法
var startupType;
// 紹介リンク
var externalLink;
// 学年 （グローバル変数とローカル変数がごちゃごちゃになっているので注意！）
var grade;
// コンテンツ画像
var contentImg;
// コンテンツ紹介画像
var contentTestimonials;
// コンテンツ名
var contentName;
// 教材最大表示数
var maxMaterialImg = 6;
// ダイアログ表示フラグ
var displayDialogFlg = 0;
// コンテンツ初期設定格納用
var objContentSetting;
// ビデオ再生初回表示時
var isFirstVideoPlay = true;
// 複数学年インストールフラグ
var multiGradeInstallFlg;
// オリジナルのインストール方法
var originalConfirmType; 
// ROMからインストール時のキャンセルフラグ
var isRomCancel;

/*
 * =================================================================
 * 関数
 * =================================================================
 */

$(window).load(function () {
    //// ios画面のちらつきを制御
    //$(".contents").removeClass("displayNone");
    //$(".platformHeader").removeClass("displayNone");
});


/**
 * 画面ロード時
 */
$(document).ready(function () {

    try
    {
        // 自画面以外から呼び出された場合は処理を抜ける
        if (!checkDisplayFileName("content-detail.html")) {
            return;
        }

        // ローディング画面の表示
        kbnShowLoading();

        setTimeout(function () {
            try {
                // 背景活性
                $(".inactiveDiv").addClass("displayNone");

                // コンテンツIDの受け取り
                var url = location.href;
                var getParam = url.split("?")[1].replace(/\s+/g, "");
                var param = getParam.split("_");
                // コンテンツID
                contentId = param[1];
                // コンテンツ押下時のコンテンツID
                openContentId = param[1];
                checkContentId = param[1];
                confirmType = param[3];
                grade = param[5];
                mSaveGrade = grade;
                updateState = param[7];
                multiGradeInstallFlg = param[9];
                originalConfirmType = confirmType; // トップ画面から渡されたオリジナルのインストール方法

                // PFの起動状態を取得
                var pfStartupType = getStartupModeByFunc();

                var designSetting = pfDesignDecision(); //common.js
                // 倍率
                var magnification = designSetting[0];
                // アス比
                var rate = designSetting[1];
                var bodyWidth;
                // 表示域を設定する
                if (rate == 0) {
                    // アス比4:3
                    bodyWidth = 920;
                    $(".contentsBody").css({ "cssText": "width: " + bodyWidth * magnification + "px !important; " });

                } else {
                    // アス比 16:9
                    bodyWidth = 1046;
                    $(".contentsBody").css({ "cssText": "width: " + bodyWidth * magnification + "px !important; " });
                }
                $(".contentsBody").css("margin-top", 63 * magnification + "px");

                //ヘッダ部分
                var screen_width = getTerminalWidth();
                //固定値は低画質：倍率1倍をもとにしている
                var hedderLogoLeft = (screen_width / 2) - (320 / 2 * magnification);
                $(".indexHeaderText").css("left", hedderLogoLeft);

                // 指導者用の表示
                if (commonModeType == OPERATION_MODE.TEACHER_MODE) {
                    var teacherModeLeft = hedderLogoLeft - (84 * magnification);
                    $(".indexHeaderTeacherMode").css("left", teacherModeLeft);
                    $(".indexHeaderTeacherMode").css("top", (18 * magnification));
                    $(".indexHeaderTeacherMode").show();
                } else {
                    $(".indexHeaderTeacherMode").hide();
                }

                // 戻るボタンエリア設定
                $(".returnBtnArea").css("padding-top", 16 * magnification + "px");
                $(".returnBtnArea").css("padding-bottom", 32 * magnification + "px");

                // 戻るボタンに汎用ボタンスタイルを適用
                $(".returnBtnBody").addClass(BUTTON_TYPE.SUB);
                setCommonButtonStyle(BUTTON_TYPE.SUB, 112, "returnBtnBody");

                $(".returnBtnBody > span").css("font-size", 18 * magnification + "px");
                $(".returnBtnBody > img").css("width", 20 * magnification + "px");

                // 戻る先を設定
                $(".returnBtnBody").click(function () {
                    kbnPageTransition("index.html");
                });

                // 関連コンテンツエリア作成
                createRelationContentArea(contentId);

                // コンテンツ情報エリア
                $(".operationArea").css("height", 225 * magnification + "px");
                $(".operationArea").css("padding-bottom", 24 * magnification + "px");
                $(".operationRight").css("margin-right", 16 * magnification + "px");

                $(".imgWrapper").css("width", 288 * magnification + "px");
                $(".imgWrapper").css("height", 180 * magnification + "px");
                $(".imgWrapper").css("border-radius", 8 * magnification);
                $(".imgWrapper").css("border-color", "#8B8682");

                $("#contentNameTxt").css("font-size", 26 * magnification + "px");
                $("#contentNameTxt").css("padding-top", 12 * magnification + "px");
                // 画面中央のボタン設定
                $(".btnArea").css("height", 96 * magnification);

                $(".detailBtnStyle").css("margin-right", 32 * magnification);

                // 対応教材表示エリア
                //$(".materialArea").css("height", 195 * magnification);
                //$(".materialArea").css("height", 222 * magnification);

                $(".materialWrapper").css("margin-top", 12 * magnification);
                $(".materialWrapper").css("margin-left", 16 * magnification);

                $(".materialImgArea").css({
                    "padding-top": kbnGetMagnification(5),
                    "padding-left": kbnGetMagnification(85),
                });

                // コンテンツ紹介エリア
                $(".descriptionArea").css("width", bodyWidth * magnification);

                $("#contentDescImg").css("width", 888 * magnification);
                $("#contentDescImg").css("padding-left", 16 * magnification);
                $("#contentDescImg").css("padding-right", 16 * magnification);
                $("#contentDescImg").css("padding-bottom", 16 * magnification);
                $("#contentDescImg").css("padding-top", 16 * magnification);
                $("#contentDescription").css("margin-top", 16 * magnification);

                // 関連コンテンツエリア
                if (kbnCheckTerminalType()) {
                   $(".relContentArea").css({
                       "margin-top": kbnGetMagnification(10),
                       "padding-left": kbnGetMagnification(25),
                   });
                   $(".relContentWrapper").css({
                        "width": kbnGetMagnification(250),
                        "padding-left": kbnGetMagnification(20),
                        "padding-right": kbnGetMagnification(20),
                   });
                } else {
                   $(".relContentArea").css({
                        "margin-top": kbnGetMagnification(10),
                        "padding-left": kbnGetMagnification(40),
                   });
                   $(".relContentWrapper").css({
                        "width": kbnGetMagnification(260),
                        "padding-left": kbnGetMagnification(30),
                        "padding-right": kbnGetMagnification(30),
                   });
                }
                $(".relContentImgWrapper").css({
                    "width": kbnGetMagnification(240),
                    "height": kbnGetMagnification(184),
                });

                $(".relContentWrapper .description").css({
                    "padding-left": kbnGetMagnification(8),
                    "padding-right": kbnGetMagnification(8),
                    "font-size": kbnGetMagnification(16),
                });
                $("#relationContent").css("margin-top", 16 * magnification);

                // 教材、コンテンツ紹介、関連コンテンツエリア共通
                $(".materialTitle, .descriptionTitle, .relContentTitle").css({
                    "font-size": 15 * magnification,
                });
                $(".materialArea, #contentDescription, #relationContent").css({
                    "padding": kbnGetMagnification(10),
                });

                $(".titleDescription").css({
                    "padding-left": kbnGetMagnification(25),
                    "font-size": kbnGetMagnification(13),
                });

                // 画面下のマージン
                var bottomElem;
                if ($("#relationContent").css("display") == "none") {
                    bottomElem = $("#contentDescription");
                } else {
                    bottomElem = $("#relationContent");
                }
                bottomElem.css("margin-bottom", 64 * magnification);
                   
                // 表示用コンテンツ情報を取得
                var resJson = getContentDetailInfoByFunc(contentId);
                  
                // コンテンツに関連する教材情報
                var resMaterial = getMaterialImageByFunc(contentId);
                   
                var obj = JSON.parse(resJson);
                   
                // 教材がない場合表示しない
                if (resMaterial.trim().length != 0) {
                   var objMaterial = JSON.parse(resMaterial);
                }
                contentType = obj[0].content_type;
                contentImg = obj[0].content_image_path;
                contentTestimonials = obj[0].content_testimonials_path;
                contentName = obj[0].content_name;
                externalLink = obj[0].external_link;

                // コンテンツインストール種別がひまわり先生の場合、ROM扱いしない
                if (obj[0].content_install_type == CONTENT_INSTALL_TYPE.HIMAWARI_SENSEI) {
                    confirmType = INSTALL_TYPE.WEB_INSTALL;
                }

                //contentDemoImg = contentImg.replace(".png", "") + "_demo.PNG";
                // 動画パスから動画サムネイルパスを取得
                contentDemoImg = "";
                if (obj[0].content_video_path.length > 0) {
                    var imgFolderPath = contentImg.substr(0, contentImg.lastIndexOf("/"));
                    var imgPath = obj[0].content_video_path.replace(".mp4", ".PNG");
                    contentDemoImg = imgFolderPath + "/" + "contents_btn_" + imgPath.substr(imgPath.lastIndexOf("/") + 1);
                }

                startupType = obj[0].startup_type;

                $(".iosDemoInstall").hide();
                $(".addOrDeleteBtn").hide();
                $(".openAppStore").hide();
                $(".onlineMode").hide();
                $(".romInstallBtn").hide();
                $(".romOnlineBtn").hide();

                if (kbnCheckTerminalType()) {
                    $("#installBtn").text("教材対応版をインストールする");
                }
                if (updateState == UPDATE_STATE.UN_UPDATE_MODE) {
                    // 通常
                    $("#updateContents").hide();
                    $(".addOrDeleteBtn").hide();
                    if (kbnCheckTerminalType() && contentType != CONTENT_TYPE.INTRODUCTION) {
                        // iOSで紹介コンテンツで無い場合
                        $(".iosDemoInstall").show();
                    }
                } else if (updateState == UPDATE_STATE.ADD_OR_DELETE_MODE) {
                    // コンテンツ追加・削除
                    $("#updateContents").hide();
                    $(".installBtn").hide();
                } else {
                    // 後期の追加
                    $(".installBtn").hide();
                    $(".addOrDeleteBtn").hide();
                }
                $(".openContent").hide();
                $(".introductionBtn").hide();
                // ROMから開くボタンを非表示に
                if (confirmType == INSTALL_TYPE.WEB_INSTALL) {
                    $("#openRomData").hide();
                }
                // コンテンツ設定情報を取得
                var objContentSetting = JSON.parse(getContentInfoByContentIdByFunc(contentId, grade))[0];

                // 分割インストール区分＝個別でインストール済みの場合は追加・削除ボタンを表示
                var splitInstallType = getSplitInstallTypeByFunc(contentId);
                if (splitInstallType == SPLIT_INSTALL_TYPE.INDIVIDUAL &&
                    objContentSetting.install_flg == "1") {
                    // ROM押下でそのコンテンツがオンラインの場合
                    if (!(confirmType == INSTALL_TYPE.ROM_INSTALL && isOnlineContent(contentId, grade))) {
                        $(".addOrDeleteBtn").show();
                        // ダイアログを出力
                        addOrDeleteContent();
                    }
                }

                // ボタンの切り替え
                installInfoBtnChange();

                // コンテンツ名 
                $("#contentNameTxt").text(contentName.replace("<br>", " "));
                // コンテンツ画像
                $("#contentImg").attr("src", "../../" + replaceImagePath(contentImg));
                // コンテンツ紹介画像
                $("#contentDescImg").attr("src", "../../" + replaceImagePath(contentTestimonials));

                //コンテンツ詳細のVideoタグをimgタグに仕様変更
                $(".videoWrapper").css("width", 400 * magnification);
                $(".videoWrapper").css("height", 225 * magnification);

                //動画イメージスタイル設定   
                $("#demoVideoImage").css("width", 400 * magnification);
                $("#demoVideoImage").css("height", 225 * magnification);

                //動画イメージ設定
                $("#demoVideoImage").attr("src", "../../" + replaceImagePath(contentDemoImg));
                $("#demoVideoImage").error(function() {
                    $(this).attr('src', "../../" + replaceImagePath(contentDemoImg.replace(".PNG", ".png")));
                });

                // プレイボタンスタイル設定
                $("#demoVideoPlayButton").css("width", 48 * magnification);
                $("#demoVideoPlayButton").css("height", 48 * magnification);
                $("#demoVideoPlayButton").css("top", -136.5 * magnification);   //(動画イメージ高さ/2) + (playボタンの高さ/2)  
                $("#demoVideoPlayButton").css("left", 176 * magnification);     //(動画イメージ幅/2) - (playボタンの幅/2)

                var tappingFlag = false;
                //playボタンのタップ時イベント
                $(".videoWrapper").mousedown(function () {
                    $("#demoVideoPlayButton").attr("src", "../img/content-detail/video-center-play-tap.svg");
                    tappingFlag = true;
                });
                $(".videoWrapper").mouseup(function () {
                    $("#demoVideoPlayButton").attr("src", "../img/content-detail/video-center-play.svg");
                    tappingFlag = false;
                });
                $(".videoWrapper").mouseout(function () {
                    if (tappingFlag) {
                        $("#demoVideoPlayButton").attr("src", "../img/content-detail/video-center-play.svg");
                        tappingFlag = false;
                    }

                });
                if (obj[0].content_video_flg == 0) {
                    // 動画を表示しない場合
                    $(".videoWrapper").empty();
                } else {
                    // 動画パーツ適用
                    var config = {
                        autoplay: true,
                        loop: false,
                        volume: 0.5,
                        visibleToolbar: true,
                        path: "../../" + obj[0].content_video_path
                    };

                    //動画エリアタップ時にvideoを作成してフルスクリーン表示する。
                    $(".videoWrapper").click(function () {
                        kbnPlayVideo(config);
                    });

                    // 動画ファイルの存在チェック
                    var video = document.createElement('video');
                    var onError = function () {
                        // 存在しない場合は再生ボタンを隠す
                        //$("#demoVideoPlayButton").hide();
                        //$(".videoWrapper").off("click");
                        //video.removeEventListener('error', onError, true);
                        // 存在しない場合は動画エリアを隠す
                        $(".videoWrapper").hide();
                        $(".videoWrapper").off("click");
                        video.removeEventListener('error', onError, true);
                    };
                    video.addEventListener('error', onError, true);
                    $(video).attr("src", "../../" + obj[0].content_video_path);
                }

                var matImgArea;
                var count = 0;

                // 教材画像を表示
                if (objMaterial) {
                    // 対象教材がある場合
                    for (var val in objMaterial) {
                        // 最大表示数を超えた場合ループ停止
                        if (count > maxMaterialImg) {
                            break;
                        }

                        matImgArea = "<div class='materialImgWrapper'"
                            + " style='width:" + 120 * magnification + "px; height: " + 120 * magnification + "px;border-radius:"
                            + 8 * magnification + "px;padding-top:" + 12 * magnification + "px;'>";
                        // 最後の教材以外はマージンをつける
                        if (count < 4) {
                            if (rate == 0) {
                                // アス比4:3
                                matImgArea += "<div style='margin-right:" + 48 * magnification + "px;width: " + 120 * magnification + "px; height: " + 120 * magnification + "px;border-radius:" + 8 * magnification + "px;border-color: #8B8682'>";
                            } else {
                                // アス比 16:9
                                matImgArea += "<div style='margin-right:" + 77.8 * magnification + "px;width: " + 120 * magnification + "px; height: " + 120 * magnification + "px;border-radius:" + 8 * magnification + "px; border-color: #8B8682'>";
                            }
                        } else {
                            matImgArea += "<div style='width: " + 120 * magnification + "px; height: " + 120 * magnification + "px;border-radius:" + 8 * magnification + "px;border-color: #8B8682;'>";
                        }
                        matImgArea += "<img class='materialImg' style='border-radius:" + kbnGetMagnification(8) + "' src='../../" + replaceImagePath(objMaterial[val].material_image_path) + "' data-external-link='" + objMaterial[val].external_link + "'>";
                        matImgArea += "</div>";
                        matImgArea += "<div style='width:" + 120 * magnification + "px; border:0px;text-align: left;color:#302519; font-size: "
                            + 11 * magnification + "px;line-height: " + 14 * magnification + "px;margin-top:" + 4 * magnification + "px;'>" + objMaterial[val].detail_display_name + "</div>";
                        matImgArea += "</div>";

                        $(".materialImgArea").append(matImgArea);
                        count++;
                    }
                    // 画像のサイズを取得後Styleを書き換える
                    $(".materialImg").bind("load", function () {
                        var imgHeight = $(this).height();
                        var imgWidth = $(this).width();

                        if (imgHeight > imgWidth) {
                            // 縦長の画像
                            $(this).css("height", "100%");
                        }
                        else {
                            // 横長の画像
                            $(this).css("width", "100%");

                            // 中央を求める
                            var mt = ((120 - $(this).height() * magnification) / 2);
                            // 中央に配置する
                            $(this).css("top", mt);

                        }
                    });

                    // 教材画像クリックイベント
                    $(".materialImg").bind("click", function () {
                        var link = $(this).data("external-link");
                        if (link) {
                            // 外部リンクが指定されている場合は外部ブラウザで開く
                            kbnOpenBrowser(link);
                        }
                    });

                } else {
                    // 対象教材が無い場合は非表示にする
                    $(".materialArea").hide();
                }

                // 学年追加で遷移してきた場合
                if (grade != "0" && INSTALL_TYPE.WEB_INSTALL == confirmType && updateState != UPDATE_STATE.ADD_OR_DELETE_MODE) {
                    checkContentAuthCode();
                }

                // コンテンツタイプが紹介またはROM起動時にROM収録コンテンツ以外を表示した場合は紹介ボタンのみ表示する
                var showIntroduction = false;
                if (contentType == CONTENT_TYPE.INTRODUCTION) {
                    showIntroduction = true;
                } else {
                    if (pfStartupType == PF_STARTUP_MODE.ROM_MODE && confirmType == INSTALL_TYPE.WEB_INSTALL) {
                        showIntroduction = true;
                    }
                }
                if (obj[0].content_install_type == CONTENT_INSTALL_TYPE.HIMAWARI_SENSEI) {
                    showIntroduction = false;
                }

                if (showIntroduction) {
                    $(".introductionBtn").show();
                    $("#updateContents").hide();
                    $(".openContent").hide();
                    $("#openRomData").hide();
                    $(".installBtn").hide();
                    $(".pfCopyFolder").hide();
                }

                // H31ひまポケ #276 ADD START
                // H31ひまポケ ボタン文言変更によりコメントアウト
                //if (pfStartupType == PF_STARTUP_MODE.INSTALL_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
                //    $("#installBtn").text("ディスクから追加する");
                //}

                if (pfStartupType == PF_STARTUP_MODE.INSTALL_MODE && confirmType == INSTALL_TYPE.WEB_INSTALL && !kbnCheckTerminalType()) {
                    $("#installBtn").text("インストールして使う");
                }
                // H31ひまポケ #276 ADD END

                // PFがROM起動の場合
                //if (pfStartupType == PF_STARTUP_MODE.ROM_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
                    // コピーして使うを表示
                    // H31ひまポケ ボタン文言変更によりコメントアウト
                    //$(".pfCopyFolder").show();
                    //// H31ひまポケ #276 ADD START
                    //$("#installBtn").text("インストールして使用する");
                    //// H31ひまポケ #276 ADD END
                //} else {
                $(".pfCopyFolder").hide();
                //}

                // 起動方法が3:インストール起動のみの場合
                if (startupType == PF_STARTUP_TYPE.INSTALL_ONLY) {
                    $("#openRomData").hide();
                }
                   
                // コンテンツタイプが外部(URLスキーム)の場合
                if (contentType == CONTENT_TYPE.URL_SCHEME) {
                   $(".openAppStore").show();
                   $(".introductionBtn").hide();
                   $("#openRomData").hide();
                   $(".iosDemoInstall").hide();
                   $(".installBtn").hide();
                   $(".openContent").hide();
                   $("#updateContents").hide();
                   $(".addOrDeleteBtn").hide();
                   $(".pfCopyFolder").hide();
                }

                // WEB起動が有効であり、ROM起動でない場合
                if (objContentSetting.web_startup_path && confirmType != INSTALL_TYPE.ROM_INSTALL) {
                    $(".onlineMode").show();
                } else if (objContentSetting.web_startup_path &&
                        pfStartupType == PF_STARTUP_MODE.INSTALL_MODE &&
                        confirmType == INSTALL_TYPE.ROM_INSTALL) {
                    // ひまポケインストール済でROM起動の場合
                    $(".romOnlineBtn").show();
                    $(".openRomData").hide();
                    // デグレが怖いので、以下の場合はWeb版インストールしないで使う非表示
                    if (!(confirmType == INSTALL_TYPE.ROM_INSTALL && isOnlineContent(contentId, grade))) {
                        if (objContentSetting.install_flg == FLG_STATUS.ON) {
                            // Web版インストールしないで使う非表示
                            $(".romOnlineBtn").hide();
                        }
                    }
                } else if (pfStartupType == PF_STARTUP_MODE.ROM_MODE &&
                        confirmType == INSTALL_TYPE.ROM_INSTALL) {
                    // ROMからROM起動
                    $(".romInstallBtn").show();
                    $(".installBtn").hide();
                    if (objContentSetting.web_startup_path) {
                        // オンラインの場合のみ
                        $(".romOnlineBtn").show();
                        $(".openRomData").hide();
                    }
                }

                // オフラインの場合、非表示
                if (objContentSetting.web_startup_path &&
                    objContentSetting.startup_path &&
                    objContentSetting.web_startup_path != objContentSetting.startup_path) {
                    $(".onlineMode").hide();
                }

                //　各ボタンのデザイン反映
                $(".installBtn").addClass(BUTTON_TYPE.MAIN);
                $(".openContent").addClass(BUTTON_TYPE.MAIN);
                $(".openRomData").addClass(BUTTON_TYPE.MAIN);
                $(".updateContents").addClass(BUTTON_TYPE.MAIN);
                $(".addOrDeleteBtn").addClass(BUTTON_TYPE.MAIN);
                $(".pfCopyFolder").addClass(BUTTON_TYPE.MAIN);
                $(".iosDemoInstall").addClass(BUTTON_TYPE.MAIN);
                $(".onlineMode").addClass(BUTTON_TYPE.MAIN);
                $(".romInstallBtn").addClass(BUTTON_TYPE.MAIN);
                $(".romOnlineBtn").addClass(BUTTON_TYPE.MAIN);

                // 汎用ボタンのスタイルを適用
                if (kbnCheckTerminalType()) {
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 260, "installBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 260, "romInstallBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 260, "romOnlineBtn");
                // H31ひまポケ #276 ADD START
                } else if (pfStartupType == PF_STARTUP_MODE.ROM_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "installBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "romInstallBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "romOnlineBtn");

                // H31ひまポケ #276 ADD END
                } else {
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 200, "installBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "romInstallBtn");
                    setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "romOnlineBtn");
                }
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 200, "openContent");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "openRomData");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 200, "updateContents");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 200, "addOrDeleteBtn");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 200, "pfCopyFolder");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 260, "iosDemoInstall");
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "onlineMode");

                // PFをROM起動の際に設定画像を非表示にする
                if (pfStartupType == PF_STARTUP_MODE.ROM_MODE) {
                    $(".appSettingImg").hide();
                }

                $(".introductionBtn").addClass(BUTTON_TYPE.MAIN);
                // 汎用ボタンのスタイルを適用
                setCommonButtonStyle(BUTTON_TYPE.MAIN, 240, "openWebSite");

                if ($.trim(externalLink) == "") {
                    // WEBページがない場合ボタンを削除
                    $(".introductionBtn").hide();
                }
            } finally {
                // ios画面のちらつきを制御
                $(".contents").removeClass("displayNone");
                $(".platformHeader").removeClass("displayNone");

                // ローディング画面を非表示
                kbnHideLoading();
            }
        }, 1);
    } catch (e) {
        alert("contentDetail load:" + e);
    }
});

/*
 * =================================================================
 * ダイアログ
 * =================================================================
 */

/**
 * コンテンツ認証ダイアログを表示
 */
function checkContentAuthCode(isForce){
    //mIsOnlineMode = false;

    // コンテンツの設定情報をクリアする
    clearContentSettingInfoByFunc();

    // オンライン起動
    if (mIsOnlineMode) {
        // 認証ダイアログを表示
        pfOpenDialog(MODE.CONTENT_AUTH_MODE, contentImg, contentName, grade, updateState, multiGradeInstallFlg, contentId); // appSettingDialog.js
        return;
    }

    // H31ひまポケ先行 #278 ADD START
    // ひまわり先生用 .net4.5.2バージョンチェック
    var isNeedDotNetInstallForHimawariSensei = false;
    if (isHimawariSenseiByFunc(contentId)) {
        isNeedDotNetInstallForHimawariSensei = isNeedUpdateDotNetForHimawariSensei();
        if (isNeedDotNetInstallForHimawariSensei) {
            // net4.5.2がインストールされていない場合
            callback = function () {
                kbnOpenBrowser("https://www.microsoft.com/net/download/dotnet-framework-runtime");
            }
            var message = "ひまわり先生の利用には，Microsoft .net flamework 4.5.2  以降が必要です。インストールしてください。<br>" +
                            "([OK]を選択すると，ブラウザでMicrosoftダウンロードセンターを表示します。) ";
            kbnConfirm(undefined, message, callback, 520);
            return;
        }
    }
    // H31ひまポケ先行 #278 ADD END

    if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
        if (!isForce && !isAdministratorsMemberByFunc()) {
            // 実行ユーザーが標準ユーザーの場合
            var yesCallback = function () {
                // 通常インストールを選択した場合
                checkContentAuthCode(true);
            };
            var noCallback = function () {
                // コピーして利用するを選択した場合
                pfCopy();
            };
            var massage = "Windowsのアカウントの種類が標準ユーザーです。<br>" +
                          "端末の設定によっては，インストールの際，管理者アカウントのパスワードが必要な場合があります。<br>" +
                          "管理者のアカウントのパスワードが不明等でご利用いただけない場合は，[コピーして使用する]をお試しください。";
            kbnConfirm(undefined, massage, yesCallback, 520, "通常インストール", "コピーして利用する", true, noCallback);
            return;
        } else {
            // 管理者または通常インストールを選択した場合
            // ROM内のコンテンツ照合
            var res = checkRomInstallContentByFunc(contentId);

            // ROM内のコンテンツではない場合
            if (!res) {
                // コンテンツ略称を取得
                var sname = getContentShortNameByFunc(contentId);

                var shortName = JSON.parse(sname);

                // インストール確認
                checkAndkickInstaller(shortName[0].content_short_name);

                return;
            }
        }
    }

    // インストール方法判定
    if (confirmType == INSTALL_TYPE.ROM_INSTALL) {
        // ROMからインストール時キャンセルフラグ初期化
        isRomCancel = false;
        // 教科書・教材設定

        if(PF_STARTUP_MODE.INSTALL_MODE == startupMode){
            // 管理者権限のチェック
            if (!isForce && !checkAndConfirmAdmin(contentId)) {
                return;
            }
        }

        displayDialogFlg = 0;

        //// 認証フラグを更新
        //updateAuthenticationFlgByFunc(contentId, grade, 1);

        // 準拠設定
        // クロス利用の標準版かどうかチェック
        if (isCrossUseNormalByFunc(contentId, grade)) {
            // クロス対象ROMインストールポップアップを表示
            if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
                // ROMの場合、遅らせて表示する
                setTimeout(function () {
                    // コピーして利用するを選択した場合
                    contentCrossUse(contentId, confirmType);
                }, 800);
            } else {
                contentCrossUse(contentId, confirmType);
            }
        } else {
            openStandardMaterialDialog(grade, confirmType, 0, 1, false);
        }

    } else if(confirmType == INSTALL_TYPE.WEB_INSTALL) {
        // WEBインストール

        if (originalConfirmType == INSTALL_TYPE.ROM_INSTALL) {
            // ROM経由でダウンロードするコンテンツは認証不要とする。（ひまわり先生対応）
            var authInfos = JSON.parse(checkAuthenticationTypeByFunc(contentId));
            var authInfo = _.find(authInfos, function (info) {
                return info.authentication_type != AUTHENTICATION_TYPE.ANOTHER_DL;
            });
            var defaultPassword = authInfo.authentication_code;
            setAuthCodeForRomByFunc(defaultPassword);
            nowPassWord = defaultPassword;
            current_mode = MODE.CONTENT_AUTH_MODE;
            confirmPassword();
            return;
        }

        // 認証が必要なコンテンツかチェック
        var authArray = checkAuthenticationTypeByFunc(contentId);
        var auth = JSON.parse(authArray)[0];

        if (auth.authentication_type == AUTHENTICATION_TYPE.THERE || auth.authentication_type == AUTHENTICATION_TYPE.ANOTHER_DL) {
            // 認証が必要な場合
            // 認証ダイアログを表示
            pfOpenDialog(MODE.CONTENT_AUTH_MODE, contentImg, contentName, grade, updateState, multiGradeInstallFlg, contentId); // appSettingDialog.js
        } else {
            // 認証が必要ない場合
            //nowPassWord = "0000"; // ダミーの認証コードを設定(後続処理の改修を行わない為)
            // 該当するダミー認証コードを設定
            nowPassWord = auth.authentication_code;
            current_mode = MODE.CONTENT_AUTH_MODE;
            confirmPassword();
        }

    }
}

/**
 * コンテンツ追加・削除
 */
function addOrDeleteContent() {
    try {
        // 管理者権限のチェック
        if (!checkAndConfirmAdmin(contentId)) {
            return;
        }

        // 準拠、教材設定を取得
        var json = getContentInfoByContentIdByFunc(contentId, grade);
        var obj = JSON.parse(json)[0];

        var materialId = obj.material_id;
        var standardId = obj.standard_id;

        // インストール設定画面を開く
        var returnBackParameter = {};
        returnBackParameter.screenType = SCREEN_TYPE.CONTENT_DETAIL;
        returnBackParameter.isCopy = false;
        openInstallSettingDialog(contentId, grade, materialId, standardId, confirmType, returnBackParameter, RUN_TYPE.RUN_WEB);
    } catch (e) {
        alert(e);
    }
}

// PFをコピーして使うを押下時
function pfCopy() {
    var callback = function () {
        // コンテンツの設定情報をクリアする
        clearContentSettingInfoByFunc();
        // 準拠設定
        // クロス利用の標準版かどうかチェック
        if (isCrossUseNormalByFunc(contentId, grade)) {
            // クロス利用の標準版の場合、標準版しか選択できない
            openStandardMaterialDialog(grade, INSTALL_TYPE.ROM_INSTALL, 0, 1, true, undefined, undefined, undefined, true);
        } else {
            openStandardMaterialDialog(grade, INSTALL_TYPE.ROM_INSTALL, 0, 1, true);
        }
    };
    var title = undefined;
    var massage = "コピー完了後，ひまわりポケットを終了します。<br>"
                + "コピー先のフォルダ内にある[Start.bat]を選択すると<br>"
                + "ひまわりポケットが起動します。<br>"
                + "<br>"
                + "コピー先を指定する際，Program Filesや管理者権限が<br>"
                + "必要な領域にコピーすると，動作しない場合があります。";
    kbnConfirm(title, massage, callback, 480, "続ける", "キャンセル");
}

/**
 * PFをコピーする
 */
function pfCopyFolder () {

    // フォルダ選択ダイアログを出力
    var path = openDirectrySelectDialogByFunc();

    if (path.length <= 0) {
        // キャンセル押下
        return;
    }

    // ローディング画像を表示する
    kbnShowLoading();

    // フォルダをコピーする
    var res = copyPlatformFolderByFunc(contentId, grade, path);
}

/**
 * コピー完了後のコールバック
 */
function pfCopyFolderCallback(res) {
    var title = "";
    var message = "";
    var callback

    if (res) {
        // 成功
        title = "完了";
        massage = "コピーが完了しました。";
        callback = function () {
            // PFを終了させる
            CloseViewertByFunc();
        };
    } else {
        // 失敗
        playAlertSE();
        title = "失敗";
        massage = "コピーに失敗しました。";
        callback = function () {
            // 何もしない
        };
    }

    // ローディング画像を非表示にする
    kbnHideLoading();

    // アラートを表示
    kbnAlert(title, massage, callback, 432);
}

/**
 * インストール中のダイアログを表示
 */
function openInstallRunningDialog() {

    createInstallRunningDialog();

    /**
     * コンテンツのダウンロードをキャンセル
     */
    $(document).on("click", "#cancelDownload", function () {
        
        cancelContentDownloadByFunc();

        // ダイアログを閉じる
        closeDialog();
        // 認証フラグを0に更新
        if (startupMode == PF_STARTUP_MODE.INSTALL_MODE) {
            // WEBインストールの場合
            var res = updateReturnConentsInfoByFunc(contentId, grade);
            // トップ画面から遷移した時の学年を復元しておく(続けて別学年をインストールする際に失敗する為)
            grade = mSaveGrade;
        }

        // ROMのキャンセルフラグを立てる
        isRomCancel = true;

        // クロス利用の場合、トップ画面へ遷移
        if (mIsGoingTopForCrossUse) {
            kbnPageTransition("index.html");
            mIsGoingTopForCrossUse = false;
        }
    });
}

/**
 * ROMでインストールして使うダイアログ
 */
function openRomInstallDialog() {
    var yesCallback = function () {
        // インストールするを選択した場合
        checkContentAuthCode();
    };
    var noCallback = function () {
        setTimeout(function () {
            // コピーして利用するを選択した場合
            pfCopy();
        }, 800);
    };
    var massage = "インストーラーを起動できない場合は，ファイルコピーでインストールしてください。";
    kbnConfirm(undefined, massage, yesCallback, 500, "インストールする", "ファイルコピーする", true, noCallback);
}

/**
 * ROMでインストールしないで使うダイアログ
 */
function openRomOnlineDialog() {
    var yesCallback = function () {
        // ROMから起動
        openRomContentBtn();
    };
    var noCallback = function () {
        setTimeout(function () {
            // 準拠設定
            // クロス利用の標準版かどうかチェック
            if (isCrossUseNormalByFunc(contentId, grade)) {
                // オンラインモードにする
                mIsOnlineMode = true;
                if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
                    // クロス対象ROMインストールポップアップを表示
                    contentCrossUse(contentId, confirmType, true);
                } else {
                    // クロス対象ROMインストールポップアップを表示
                    contentCrossUse(contentId, confirmType, false);
                }
            } else if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
                // Web版使用確認ダイアログ表示
                openRomOnlineConfirmDialog();
            } else {
                // Web版を使用する
                openWebContent();
            }
        }, 800);
    };
    var massage = "※Web版を使用する場合はネットワーク接続が必要です。<br>"
                + "※Web版はひまわりポケットのインストールが必要です。";
    kbnConfirm(undefined, massage, yesCallback, 500, "ROMから起動", "Web版を使用する", true, noCallback);
}

/**
 * ROMでWeb版起動時の確認ダイアログ
 */
function openRomOnlineConfirmDialog(isCrossUse) {
    var yesCallback = function () {
        setTimeout(function () {
            // Web版を使用する
            openWebContent(true, isCrossUse);
            mIsRomOnlineConfrimDialog = true;
        }, 800);
    };
    var massage = "ひまわりポケットのインストール後に，Web版のご利用が可能になります。"
                + "ひまわりポケットのインストールを開始しますか？";
    kbnConfirm(undefined, massage, yesCallback, 500, "はい", "いいえ", true);
}

/**
 * 使用期限切れコンテンツバージョンアップ中のダイアログを表示
 */
function openExpiredVersionUpRunningDialog(cancelContentId, cancelGrade, beforeAuthCode) {

    createInstallRunningDialog();

    /**
     * コンテンツのダウンロードをキャンセル
     */
    $(document).on("click", "#cancelDownload", function () {

        cancelContentDownloadByFunc();

        // ダイアログを閉じる
        closeDialog();
        // 特殊認証コードか？
        var objContentSetting = JSON.parse(getContentInfoByContentIdByFunc(cancelContentId, cancelGrade))[0];
        var isSpecialAuthCode = objContentSetting.special_auth_code ? true : false;

        // 認証コードを認証前のものに更新
        updateAuthCodeByFunc(cancelContentId, cancelGrade, beforeAuthCode, isSpecialAuthCode);
    });
}

/*
 * =================================================================
 * コンテンツインストール
 * =================================================================
 */

/**
 * コンテンツのインストールを行う
 */
function contentInstall(installGrade) {

	//openInstallRunningDialog();

    //grade = installGrade;

    //// インストールの開始
    //installContentByFunc(contentId, grade, IOS_CONTENT_INSTALL.INSTALL);

    var resJson = getContentDetailInfoByFunc(contentId);
    var obj = JSON.parse(resJson)[0];
    if (obj.content_install_type == CONTENT_INSTALL_TYPE.HIMAWARI_SENSEI) {
        // ひまわり先生の場合、インストール先を選択する（2018年度はダウンロードのみ＝ひまわり先生）
        var param = {
            contentId: contentId,
            grade: grade,
        }
        openInstallDestinationConfirmDialog({contentId: contentId, grade: grade});
    } else {
        openInstallRunningDialog();

        grade = installGrade;

        // インストールの開始
        installContentByFunc(contentId, grade, IOS_CONTENT_INSTALL.INSTALL);
    }
}

/**
 * ios標準版をインストールする
 */
function demoVersionInstall () {

    // DB書き込み(標準版)
    updateDemoContentSettingByFunc(contentId, grade);
    // ダイアログ表示
    openInstallRunningDialog();
    // インストールの開始
    installContentByFunc(contentId, grade, IOS_CONTENT_INSTALL.DEMO_INSTALL);
}

/**
 * ダウンロード経過時間を元にプログレスバーを更新
 */
function updateDownloadProgressBar(timePercent, maxPercent)
{
    if (kbnCheckTerminalType()) {
        // iosの場合はキャンセルボタンを表示
        $("#cancelDownload").show();

        timePercent = 0;
        maxPercent = 0;
    }
    $(".installText").text("ダウンロード中...");
    // プログレスバーを更新
    $('#progressBar').progressbar({"value": timePercent});
}

/**
 * インストール経過時間を元にプログレスバーを更新
 * ※同名ファンクションがindex.js、app-setting.jsにもあるので注意
 * 　基本的には呼び出し元のhtmlに対応したjsの処理が呼ばれる模様
 */
function updateInstallProgressBar(currentFileNum, maxFileNum, downloadPath, isSubContent, isFinishInstall)
{
    $(".installText").text("インストール中...");
    
    if (kbnCheckTerminalType()) {
        // iosの場合はキャンセルボタンを非表示にする
        $("#cancelDownload").hide();
    } else {
        // プログレスバーを更新
        $('#progressBar').progressbar(
            { "value": currentFileNum },
            { "max": maxFileNum }
        );
    }

    if (currentFileNum >= maxFileNum) {
        if (isFinishInstall) {

            // インストール終了
            $(".installText").text("インストール終了");

            // コンテンツを移動（ひまわり先生のみ）
            moveFolderAndUpdateDBForHimawariSenseiByFunc(contentId);

            // ダウンロード完了後フォルダの容量をDBに登録する
            updateContentFolderSizeByFunc(contentId, grade, downloadPath);

            // インストール終了後DBを更新
            updateAuthenticationFlgByFunc(contentId, grade, 1);
            var res = updateInstallFlgByFunc(contentId, grade, mIsTrial);

            // H31ひまポケ先行 #253 ADD START
            if (mIsTrial) {
                updateUseTrialFlgByFunc(contentId, grade);
            }
            // H31ひまポケ先行 #253 ADD END

            // インストールするボタンを非表示にする
            $(".installBtn").hide();
            $(".iosDemoInstall").hide();

            // 内容更新時にフラグを更新 
            var res = updateContentUpdateFlgByFunc(contentId, installContentGrade);

            // スタートアップパスを更新
            updateStartupPath(contentId, grade);

            // 内容更新ボタンを非表示に
            $("#updateContents").hide();

            // 表示ボタンの状態変更
            installInfoBtnChange();

            // ダイアログを閉じる
            closeDialog();

            // FlashPlayerのバージョンをチェック
            var needFPInstall = isNeedUpdateFlashPlayer();

            // コンテンツインストール完了
            var callback;
            var title;
            var massage;
            if (needFPInstall) {
                callback = function () {
                    installFlashPlayerByFunc();
                };
                var title = undefined;
                var massage = "コンテンツの利用には，FlashPlayer 11.0以降が必要です。<br> インストールしてください。";
                kbnConfirm(title, massage, callback, 520);
            } else {
                // デジ漢デジ計クロス利用
                var crossUseContentId = getCrossContentId();
                if (crossUseContentId && !mIsSpecialAuthCode) {
                    // クロス利用可能時
                    mIsGoingTopForCrossUse = true;
                    contentCrossUse(crossUseContentId, confirmType);
                } else {
                    callback = function () {
                        // PFインストーラを起動する必要がある場合は起動する
                        if (startInstallerIfNeedByFunc()) {
                            checkAndkickInstaller("");
                            return;
                        }
                        if (mIsGoingTopForCrossUse) {
                            // クロス利用の場合、トップ画面へ遷移
                            kbnPageTransition("index.html");
                            // クロス利用キャンセル時の変数を初期化
                            mIsGoingTopForCrossUse = false;
                        }
                    };
                    var sucTitle = "完了";
                    var sucMassage = "インストールが完了しました。";
                    if (kbnCheckTerminalType()) {
                        sucMassage = "インストールが完了しました。" +
                            "<br />コンテンツを再インストールした場合は，一度ひまわりポケットを終了した後でコンテンツを開いてください。" +
                            "<br />(ホームボタンをすばやく2回押し，ひまわりポケットのプレビューを上にスワイプすると終了できます。)";
                    }
                    kbnAlert(sucTitle, sucMassage, callback, 500);
                }
            }
        }
    }
}

/**
 * ROMダウンロード経過時間を元にプログレスバーを更新
 */
function updateRomDownloadProgressBar(timePercent, maxPercent, contentRootPath, isFinishInstall, isSubContent) {

    if (displayDialogFlg == 0 && INSTALL_TYPE.ROM_INSTALL == confirmType && !isRomCancel) {
        displayDialogFlg = 1;
        openInstallRunningDialog();
    }
    $(".installText").text("インストール中...");
    // プログレスバーを更新
    $('#progressBar').progressbar({ "value": timePercent }, { "max": maxPercent - 10 });
    
    if (timePercent >= maxPercent) {

        if (!isSubContent) {
            // 認証した学年を保持。
            mCurrentAuthGrade = grade;

            // 認証フラグを更新
            updateAuthenticationFlgByFunc(contentId, grade, 1);

            // インストールフラグを更新
            updateInstallFlgByFunc(contentId, grade, mIsTrial);

            // H31ひまポケ先行 #253 ADD START
            if (mIsTrial) {
                updateUseTrialFlgByFunc(contentId, grade);
            }
            // H31ひまポケ先行 #253 ADD END

            // 内容更新時にフラグを更新 
            updateContentUpdateFlgByFunc(contentId, grade);

            // スタートアップパスを更新
            updateStartupPath(contentId, grade);

            // 年度更新対応 認証コードを更新
            var json = checkAuthenticationTypeByFunc(contentId, grade);
            if (json) {
                authCode = JSON.parse(json)[0].authentication_code;
            } else {
                // 更に取得できない場合、コンテンツ認証コードマスタから学年=0で取得する(画面で入力した学年だとマスタに学年=0で登録されているとヒットしない為）
                json = checkAuthenticationTypeByFunc(contentId, "0");
                if (json) {
                    authCode = JSON.parse(json)[0].authentication_code;
                }
            }
            // 認証コードを更新
            updateAuthCodeByFunc(contentId, grade, authCode, false);
        }

        if (isFinishInstall) {
            // ダウンロード完了後フォルダの容量をDBに登録する
            updateContentFolderSizeByFunc(contentId, grade, contentRootPath);

            // インストールするボタンを非表示にする
            $(".installBtn").hide();

            // 内容更新ボタンを非表示に
            $("#updateContents").hide();

            // 表示ボタンの状態変更
            installInfoBtnChange();

            closeDialog();

            // デジ漢デジ計クロス利用
            // クロス対象がインストールされているかチェック
            // 標準版の場合はダイアログを出さない
            if (!isRomCancel) {
                if (!isCrossUseNormalByFunc(contentId, grade)) {
                    var crossUseContentId = getCrossContentId();
                    if (crossUseContentId) {
                        mIsGoingTopForCrossUse = true;
                        contentCrossUse(crossUseContentId, confirmType);
                        // ROM用に初期化
                        displayDialogFlg = 0;
                        isRomCancel = false;
                    }
                }
            }
        }
    }
}

/**
 * コンテンツのインストール状況を取得、ボタンの切り替え
 */
function installInfoBtnChange() {
    var resJson = getContentInstallInfoByFunc(contentId);

    var obj = JSON.parse(resJson);
    var installFlg = true;

    if (INSTALL_TYPE.ROM_INSTALL == confirmType) {
        // ROMインストール
        for (var val in obj) {
            
            if ((grade == "0" || obj[val].grade == grade) && obj[val].install_flg == 0) {
                installFlg = false;
            }
        }

        // インストールされている
        if(installFlg){
            $(".openContent").show();
            $(".openRomData").hide();
            $(".romOnlineBtn").hide();
        }

    }
    else {
        // WEBインストール
        for (var val in obj) {
            if (obj[val].install_flg == "0") {
                installFlg = false;
            } else {
                $(".openContent").show();
            }
        }
    }

    /**
     * コンテンツに未インストールが存在しない場合
     * インストールボタンを非表示
     */
    if (installFlg) {
        $(".installBtn").hide();
        $(".onlineMode").hide();
    }
}

/*
 * =================================================================
 * 更新
 * =================================================================
 */

/**
 * StartupPathの更新
 */
function updateStartupPath(contentId, grade) {
    var res = updateStartupPathByFunc(contentId, grade);
}

/**
 * オンライン用StartupPathの更新
 */
function updateOnlineStartupPath(contentId, grade) {
    var res = updateOnlineStartupPathByFunc(contentId, grade);
}

/**
 * ROMコンテンツを起動する
 */
function openRomContent(startContentId, startGrade, startClass, startNumber, contentType) {
    // コンテンツの準拠、教材が設定されているかチェックする
    var checkResult = checkStandardMaterialParamByFunc(startContentId, startGrade);
    if (!checkResult) {
        // アラートを表示
        playAlertSE();
        var callback = function () { };
        kbnAlert("教科書・教材設定が正しくされていません。", "設定した学年を選択してください。", callback, 432);
        return;
    }

    // 有効期限が切れている場合ダイアログを出す
    if (!checkInvalidContentPeriodAndReAuth(startContentId, startGrade)) {
        return;
    }


    // コンテンツを起動する
    var resJson = openRomContentByFunc(startContentId, startGrade, startClass, startNumber, contentType);
}

/*
 * ROMから実行押下時の処理
 */
function openRomContentBtn() {
    mIsOnlineMode = false;

    // FlashPlayerのバージョンをチェック
    var needFPInstall = isNeedUpdateFlashPlayer();
    var callback;
    var title;
    var massage;
    if (needFPInstall) {
        callback = function () {
            installFlashPlayerByFunc();
        };
        title = undefined;
        massage = "コンテンツの利用には，FlashPlayer 11.0以降が必要です。<br> インストールしてください。<br>インストールの完了後にもう一度、「インストールせず実行する」を押してしてください。";
        kbnConfirm(title, massage, callback, 630);

        return;
    }

    // VisualStudio2013 C++再頒布パッケージのインストール要否チェック＆インストール確認
    if (!checkAndInstallVCRuntime(contentId)) {
        return;
    }

    // クロス利用の標準版かどうかチェック
    if (isCrossUseNormalByFunc(contentId, grade)) {
        // クロス利用の標準版の場合、標準版しか選択できない
        openStandardMaterialDialog(grade, INSTALL_TYPE.ROM_INSTALL, 1, 1, false, undefined, undefined, undefined, true);
    } else {
        openStandardMaterialDialog(grade, INSTALL_TYPE.ROM_INSTALL, 1, 1, false);
    }
}

/**
 * コンテンツ紹介ページを開く
 */
function openBrowser() {
    // コンテンツを起動する
    kbnOpenBrowser(externalLink);
}

/**
 * コンテンツを起動する
 */
function openContentDetailDisplay() {
    mIsOnlineMode = false;

    // コンテンツを起動する
    var res = getGradeInputFlgByFunc(contentId);
    // FlashPlayerのバージョンをチェック
    var needFPInstall = isNeedUpdateFlashPlayer();
    var callback;
    var title;
    var massage;
    if (needFPInstall) {
        callback = function () {
            installFlashPlayerByFunc();
        };
        title = undefined;
        massage = "コンテンツの利用には，FlashPlayer 11.0以降が必要です。<br> インストールしてください。<br>インストールの完了後にもう一度、「コンテンツを開く」を押してしてください。";
        kbnConfirm(title, massage, callback, 630);

        return;
    }

    // VisualStudio2013 C++再頒布パッケージのインストール要否チェック＆インストール確認
    if (!checkAndInstallVCRuntime(contentId)) {
        return;
    }

    if (contentType == CONTENT_START_TYPE.EXTERNALFILE_START) {
        // 外部ファイルの起動
        if (contentId == CONTENT_ID.STOP_WATCH) {
            // ストップウォッチの起動
            runStopwatchFromPF();
        }
        if(JSON.parse(res)[0].grade_input_flg == 0){
            // コンテンツのスタートページを取得
            var path = getContentStartupPathByFunc(checkContentId, grade, "1", "0");

            // コンテンツの初回起動フラグを更新する
            var res = updateContentOpenFlgByFunc(checkContentId);
            
            // 外部ファイルの起動
            openRunExternalFile(checkContentId, grade, path);
            return;
        }else {
            // 学年入力あり
            InputGradeClassNumberDialog(checkContentId, 2);
        }
        
    }else{
        //　学年入力ダイアログ表示チェック
        if (JSON.parse(res)[0].grade_input_flg == 1) {
            // 学年入力する場合
            InputGradeClassNumberDialog(checkContentId);
        } else {
            // 学年入力しない場合
            openContent(contentId, undefined, 1, 1);
        }
    }
}

/*
* ネットワークの接続が確認できない場合に
* コンテンツのインストールをキャンセルする
*/
function networkUnconnected(updateType){
    cancelContentDownloadByFunc();


    // 更新区分がONの場合
//    if (updateType == "1") {
    if (updateType == "1" && contentId) { // コンテンツIDが未設定の場合は処理しない
        // 認証フラグを0に更新
        if (startupMode == PF_STARTUP_MODE.INSTALL_MODE) {
            // WEBインストールの場合
            var res = updateReturnConentsInfoByFunc(contentId, grade);
            // トップ画面から遷移した時の学年を復元しておく(続けて別学年をインストールする際に失敗する為)
            grade = mSaveGrade;
        }
    }

    // ダイアログを閉じる
    closeDialog();

    if (!mIsSkipShowNetworkErrorDialog) {
        setTimeout(function () {
            playAlertSE();

            var title = "ネットワーク接続エラーのためインストールを中断します。";
            var message = "・インターネットに接続されていない，もしくはインターネット接続が制限されている可能性があります。管理者にお問い合わせください。<br>" +
                          "・コンテンツのダウンロードがまだ開始されていない可能性があります。詳しくは光文書院WEBサイトをご覧ください。";
            var callback = function () {

            };
            kbnAlert(title, message, callback, 530);
        }, 800);
    }
}

/**
 * インストール：容量不足でエラーが発生 
 */

function installError(errorMessage){

    cancelContentDownloadByFunc();
     // 認証フラグを0に更新
    if (startupMode == PF_STARTUP_MODE.INSTALL_MODE) {
        // WEBインストールの場合
        var res = updateReturnConentsInfoByFunc(contentId, grade);
        // トップ画面から遷移した時の学年を復元しておく(続けて別学年をインストールする際に失敗する為)
        grade = mSaveGrade;
    }

    // ダイアログを閉じる
    closeDialog();

    playAlertSE();

    var dialogWidth;
    var message;
    var title = "インストール";
    if(errorMessage == ERROR_MESSAGE.CAPACITY_ERROR){
        message = "インストールするための十分な空き容量が足りません。<br />インストールを中断します。";
        dialogWidth = 460;
    }else if(errorMessage == ERROR_MESSAGE.UNAUTHENTICATION_ERROR){
        message = "インストールする権限がありません。<br />インストールを中断します。";
        dialogWidth = 432;
    }
    var callback = function(){
        
    };
    kbnAlert(title, message, callback, dialogWidth);

}

/**
 * AppStoreで開く
 */
function openAppStore() {
    kbnOpenBrowser(externalLink);
}

// 関連コンテンツエリアを表示
function createRelationContentArea(contentId) {
    var json = getRelationContentInfoByFunc(contentId);
    if (!json) {
        // 関連コンテンツが無い場合はエリアを隠す
        $("#relationContent").hide();
        return;
    }

    var relContentList = JSON.parse(json);

    // テンプレート読み込み
    var text = kbnReadTextFile(".\\template\\relationContent.html");
    var template = _.template(text);
    var cnt = 0;
    var line = 1;
    _.each(relContentList, function (relContent) {
        cnt++;

        relContent.content_image_path = "../../" + relContent.content_image_path.replace(".png", "_" + relContent.authentication_flg + ".png");
        var html = template({
            relContent: relContent,
        });

        if (cnt > 3) {
            line++;
            cnt = 0;
        }
        $("#relContentArea" + line).append(html);
    });

    //マウスダウン
    $(".relContentImg").mousedown(function (evt) {
        changeImageTap(evt.currentTarget, true);
        var contentId = $(evt.currentTarget).attr("data-content_id");
    });
    //マウスアップ
    $(".relContentImg").mouseup(function (evt) {
        changeImageTap(evt.currentTarget, false);
    });

    //マウスアウト
    $(".relContentImg").mouseout(function (evt) {
        changeImageTap(evt.currentTarget, false);
    });

    //クリック
    $(".relContentImg").click(function (evt) {
        openRelContent(evt.currentTarget);
    })

    function changeImageTap(elem, isDown) {
        var contentImage = $(elem).attr("src");
        if (isDown) {
            contentImage = contentImage.replace(".png", "_tap.png");
        } else {
            contentImage = contentImage.replace("_tap.png", ".png");
        }
        $(elem).attr("src", contentImage);
    }
}

// 関連コンテンツを開く
function openRelContent(elem) {
    var contentId = $(elem).attr("data-content_id");
    var gradeInputFlg = $(elem).attr("data-grade_input_flg");
    var contentType = $(elem).attr("data-content_type");
    var grade = $(elem).attr("data-grade");
    var authenticationFlg = $(elem).attr("data-authentication_flg");
    var multiGradeInstallFlg = $(elem).attr("data-multi_grade_install_flg");

    if (authenticationFlg == "0") {
        // 未認証コンテンツの場合、詳細画面に遷移
        window.location.href = "../html/content-detail.html?contentId_" + contentId + "_confirmType_web_grade_0_updateFlg_" + UPDATE_STATE.UN_UPDATE_MODE + "_multiInstallFlg_" + multiGradeInstallFlg;
    } else {
        // 承認コンテンツの場合、コンテンツ起動
        // index.jsの機能を呼ぶため、以下のようなIDデータを作成する
        // id='contentId_digikan_inputFlg_0_contentType_2_grade_5
        var id = "contentId_" + contentId + "_inputFlg_" + gradeInputFlg + "_conetntType_" + contentType + "_grade_" + grade;
        startContentCommon(id);
    }
}

// WEBコンテンツ起動
function openWebContent(isRomOnline, isCrossUse) {
    // オンラインモードにする
    mIsOnlineMode = true;

    // 通常のインストールの流れを呼び出す。（内部でオンラインモードの場合はインストールせずに起動するよう分岐する）
    //checkContentAuthCode(true);
    //openStandardMaterialDialog(grade, INSTALL_TYPE.ROM_INSTALL, 0, 1, false);

    if (getStartupModeByFunc() == PF_STARTUP_MODE.ROM_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
        // 教材選択画面へ
        openStandardMaterialDialog(grade, confirmType, 0, 1, false, undefined, undefined, undefined, isCrossUse, isRomOnline);
    } else if (getStartupModeByFunc() == PF_STARTUP_MODE.INSTALL_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
        // 教材選択画面へ
        openStandardMaterialDialog(grade, confirmType, 0, 1, false, undefined, undefined, undefined, isCrossUse, isRomOnline);
    } else {
        // 認証画面へ
        checkContentAuthCode(true);
    }
}

// デジ漢デジ計クロス利用
// クロス対象がインストールされているかチェック
function getCrossContentId() {
    var crossUseContentId = "";
    var contentSetting;
    if (contentId == CONTENT_ID.DIGI_KAN) {
        // デジ漢インストールの場合、デジ計がインストールされているかチェック
        contentSetting = JSON.parse(getAllContentInfoByFunc(CONTENT_ID.DIGI_KEI))[0];
        if (contentSetting.install_flg == FLG_STATUS.OFF) {
            crossUseContentId = CONTENT_ID.DIGI_KEI;
        }
    } else if (contentId == CONTENT_ID.DIGI_KEI) {
        // デジ計インストールの場合、デジ漢がインストールされているかチェック
        contentSetting = JSON.parse(getAllContentInfoByFunc(CONTENT_ID.DIGI_KAN))[0];
        if (contentSetting.install_flg == FLG_STATUS.OFF) {
            crossUseContentId = CONTENT_ID.DIGI_KAN;
        }
    }
    return crossUseContentId;
}

// デジ漢デジ計クロス利用
// クロス利用
function contentCrossUse(crossUseContentId, confirmType, isRomOnline, isRomOnlineCancel) {
    yesCallback = function () {
        if (!mIsCompletedRomOnlineConfirmDialog) {
            // オンラインの場合
            if (mIsOnlineMode) {
                if (isRomOnline) {
                    closeDialog();
                    var isCrossUse = true;
                    setTimeout(function () {
                        mIsCompletedRomOnlineConfirmDialog = true;
                        // Web版使用確認ダイアログ表示
                        if (!mIsRomOnlineConfrimDialog) {
                            openRomOnlineConfirmDialog(isCrossUse);
                        } else {
                            // Web版を使用する
                            openWebContent(true, isCrossUse);
                        }
                    }, 800);
                    contentId = crossUseContentId;
                    return;
                } else {
                    closeDialog();
                    mIsGoingTopForCrossUse = true;
                }
            }
        }
        if (!isCrossUseNormalByFunc(contentId, grade)) {
            mIsCrossUse = true;
        }

        contentId = crossUseContentId;
        // 標準版の認証コードを更新
        updateAuthCodeByFunc(contentId, 0, mCurrentAuthCode, true);
        var isCrossUse = true;
        openStandardMaterialDialog(grade, confirmType, 0, 1, false, undefined, undefined, undefined, isCrossUse);
    };
    noCallback = function () {
        if (!isCrossUseNormalByFunc(contentId, grade) || isRomOnlineCancel) {
            if (getStartupModeByFunc() == PF_STARTUP_MODE.ROM_MODE && confirmType == INSTALL_TYPE.ROM_INSTALL) {
                // コンテンツ略称を取得
                var sname = getContentShortNameByFunc(contentId);
                var shortName = JSON.parse(sname);

                // インストール確認
                checkAndkickInstaller(shortName[0].content_short_name, isRomOnline, contentId);
            }
        }
    };
    var title = "";
    var message;
    if (crossUseContentId == CONTENT_ID.DIGI_KEI) {
        message = "デジ計対象教材のご採択がない場合も，デジ計（標準版）の利用が可能です。デジ計標準版をインストールしますか？" +
            "<br> <br>" +
            "※対象教材のご採択があり，デジ計のROM・認証コードをお持ちの場合は，教材対応版のデジ計をインストールしてください。" +
            "<br>" +
            " （キャンセル→トップページのデジ計アイコン選択→インストール）"
    } else if (crossUseContentId == CONTENT_ID.DIGI_KAN) {
        message = "デジ漢対象教材のご採択がない場合も，デジ漢（標準版）の利用が可能です。デジ漢標準版をインストールしますか？" +
            "<br> <br>" +
            "※対象教材のご採択があり，デジ漢のROM・認証コードをお持ちの場合は，教材対応版のデジ漢をインストールしてください。" + 
            "<br>" + 
            " （キャンセル→トップページのデジ漢アイコン選択→インストール）"
    }
    kbnConfirm(title, message, yesCallback, 500, "利用する", "キャンセル", true, noCallback);
}

