
/*
 * =================================================================
 * 定数
 * =================================================================
 */

/*
 * =================================================================
 * 変数
 * =================================================================
 */

var mInputValue;
var mMode;

/*
 * =================================================================
 * 機能
 * =================================================================
 */

// ダイアログ表示
function openStepFourDialog(mode)
{
    try {   

        mMode = mode;

        mInputValue = "";
        mAuthCode = "";
        // ダイアログ作成
        var dialogHtml = getStepFourDialogContent();
        var dialogBody = createDialogBody('stepFourDialog');

        dialogBody.append(dialogHtml);

        $('body').append(dialogBody);
        $('body').append(createBackgroundDialog());

        setStepFourDialogStyle();

        // 画面表示
        $('#stepFourDialog').removeClass("displayNone");
    } catch (e) {
        alert(e.toString());
    }
}

// イベント処理登録
function stepFourDialogEvent() {
    try { 

        // 戻るボタン
        $(".btnReturn").click(function(event) {
            // ダイアログを閉じる
            closeDialog();
            $("#stepFourDialog").remove();
            if (mMode == OPEN_DIALOG_STATUS.APP_SETTING) {
                // アプリ設定の場合はチェックをもとに戻す
                $("input[name='user_change_type']").val(["1"]);
                updateAppSettingByFunc("user_change_type", "1");
            } else {
                // 初期設定ダイアログの場合ステップ3へ遷移
                openStepThreeDialog();
            }
        });

        // 次へボタン
        $(".btnStart").click(function(event) {
            var title = "任意パスワード入力";
            if (mInputValue.length < 4) {
                var callback = function () {
                    // iosのみスクロールを非活性
                    changeDialogBackgroudStatus(KBN_DIALOG_STATUS.STATUS_SHOW);
                };
                // 文字数が足りていない
                playAlertSE();
                kbnAlert(title, "設定するパスワードは4桁で入力してください。", callback, 432);
                return;
            }

            // ダイアログを閉じる
            closeDialog();
            $("#stepFourDialog").remove();
            if (mMode == OPEN_DIALOG_STATUS.APP_SETTING
                ) {
                // アプリ設定画面の場合:パスワードを更新
                updateAppSettingByFunc("app_setting_auth_code", mInputValue);
            } else if (mMode == OPEN_DIALOG_STATUS.RESET_PASSWORD) {
                // パスワード再設定の場合:パスワードを更新してリロード
                updateAppSettingByFunc("app_setting_auth_code", mInputValue);
                location.reload();
            } else {
                // templateCommonの変数に保存
                mAuthCode = mInputValue;

                // 設定を保存する
                updateStartSetCommonSetting();

                location.reload();
            }
        });

        // アルファベットボタン押下
        $(".alphaBtn").click(function(event) {

            if (mInputValue.length >= 4) {
                // 最大入力文字列数を超えた
                return;
            }

            var btnId = $(this).attr("id");

            // 入力したアルファベットを取得
            var alpha = btnId.split("_")[1];

            //　保持
            mInputValue += alpha;

            // 表示
            $(".wordDisplayArea").text(mInputValue);

        });

        // ×ボタン押下
        $(".deleteBtn").click(function(event) {

            if (mInputValue.length <= 0) {
                // 何も入力されていない
                return;
            }

            // 文字を1つ削る
            mInputValue = mInputValue.slice(0, -1);

            // 表示
            $(".wordDisplayArea").text(mInputValue);
        });

        // 切り替えボタン押下
        $(".switchBtn").click(function (event) {
            if ($(".inputBtnSetA").css("display") == "none") {
                $(".inputBtnSetB").hide();
                $(".inputBtnSetA").show();
            } else {
                $(".inputBtnSetA").hide();
                $(".inputBtnSetB").show();
            }
        });

        // タップ時の画像変更イベントを登録
        changeTappingAlphabet("A");
        changeTappingAlphabet("B");
        changeTappingAlphabet("C");
        changeTappingAlphabet("D");
        changeTappingAlphabet("E");
        changeTappingAlphabet("F");
        changeTappingAlphabet("G");
        changeTappingAlphabet("H");
        changeTappingAlphabet("I");
        changeTappingAlphabet("J");
        changeTappingAlphabet("K");
        changeTappingAlphabet("M");
        changeTappingAlphabet("R");
        changeTappingAlphabet("T");
        changeTappingAlphabet("U");
        changeTappingAlphabet("Y");

        $(".inputBtnSetB").hide();

    } catch (e) {
        alert(e.toString());
    }
}

// ダイアログの中味を取得
function getStepFourDialogContent() {
    //=============================
    // ダイアログ表示
    //=============================

    // テンプレート読み込み
    var text = kbnReadTextFile(".\\template\\stepFourDialog.html");
    var template = _.template(text);
    var dialogHtml = template({
        mode: mMode
    });

    return dialogHtml;
}

function setStepFourDialogStyle() {
    // 各要素に対して倍率をあてる必要がある
    // TODO:指定した要素配下の特定CSSを一括で変更するような仕組みにしたい。
    var $this = $('#stepFourDialog');

    // ボタンのスタイル、タップ時のイベントを設定
    var btnStartWidth = $("#stepFourDialogBtnStart").css("width");
    var btnReturnWidth = $("#stepFourDialogBtnReturn").css("width");

    // サイズを適切に設定
    changeDesignSize(".dialogWrapper");

    if (mMode != OPEN_DIALOG_STATUS.RESET_PASSWORD) {
        // パスワード再設定外の場合(もどるボタンの設定）
        setCommonButtonStyle(BUTTON_TYPE.SUB, btnReturnWidth, "stepFourDialogBtnReturn");
    }
    setCommonButtonStyle(BUTTON_TYPE.MAIN, btnStartWidth, "stepFourDialogBtnStart");

    // イベント処理登録
    stepFourDialogEvent();
}


// 削除ボタン
$(document).on("mousedown", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray_tap.svg");
});

$(document).on("mouseup", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

$(document).on("mouseout", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

// 切り替えボタン
$(document).on("mousedown", ".switchBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch_tap.svg");
});

$(document).on("mouseup", ".switchBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});

$(document).on("mouseout", ".switchBtn　", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});
