
/*
 * =================================================================
 * 定数
 * =================================================================
 */

/*
 * =================================================================
 * 変数
 * =================================================================
 */

 var mInputValue; // アルファベット保持変数

/*
 * =================================================================
 * 機能
 * =================================================================
 */

// ダイアログ表示
function openStepTwoDialog()
{
    try {   

        mInputValue = "";

        // ダイアログ作成
        var dialogHtml = getStepTwoDialogContent();
        var dialogBody = createDialogBody('stepTwoDialog');

        dialogBody.append(dialogHtml);

        $('body').append(dialogBody);
        $('body').append(createBackgroundDialog());

        setStepTwoDialogStyle();

        // 画面表示
        $('#stepTwoDialog').removeClass("displayNone");
    } catch (e) {
        alert(e.toString());
    }
}

// イベント処理登録
function stepTwoDialogEvent() {
    try { 

        // 戻るボタン
        $(".btnReturn").click(function(event) {
            // ダイアログを閉じる
            closeDialog();
            $("#stepTwoDialog").remove();
            // ステップ１へ遷移
            openStepOneDialog(mTeacherAuthCode);
        });

        // 次へボタン
        $(".btnStart").click(function(event) {
            var title = "学校コードの入力";
            var callback = function () {
                // iosのみスクロールを活性化
                changeDialogBackgroudStatus(KBN_DIALOG_STATUS.STATUS_SHOW);
            };

            // 複数学校コード対応｀
            var teacherAuthCodes = mTeacherAuthCode.split(',');

            if (mInputValue.length < 4) {
                // 桁が少ない
                playAlertSE();
                kbnAlert(title, "学校コードは4文字で入力してください。", callback, 432);
                return;
                //} else if (mTeacherAuthCode != mInputValue) {
            } else if (teacherAuthCodes.indexOf(mInputValue) == -1) {

                // スーパーパスワードで認証
                var checkResult = checkSuperPasswordByFunc(mInputValue);
                if (checkResult) {
                    kbnAlert(title, "スーパーパスワードで認証しました。", callback, 432);                    
                    return;
                }

                // パスワードが一致しない場合
                playAlertSE();
                kbnAlert(title, "入力された学校コードが違います。", callback, 432);
                return;
            }

            // ダイアログを閉じる
            closeDialog();
            $("#stepTwoDialog").remove();

            // ステップ３へ遷移
            openStepThreeDialog();
        });

        // アルファベットボタン押下
        $(".alphaBtn").click(function(event) {

            if (mInputValue.length >= 4) {
                // 最大入力文字列数を超えた
                return;
            }

            var btnId = $(this).attr("id");

            // 入力したアルファベットを取得
            var alpha = btnId.split("_")[1];

            //　保持
            mInputValue += alpha;

            // 表示
            $(".wordDisplayArea").text(mInputValue);

        });

        // ×ボタン押下
        $(".deleteBtn").click(function(event) {

            if (mInputValue.length <= 0) {
                // 何も入力されていない
                return;
            }

            // 文字を1つ削る
            mInputValue = mInputValue.slice(0, -1);

            // 表示
            $(".wordDisplayArea").text(mInputValue);
        });

        // 切り替えボタン押下
        $(".switchBtn").click(function (event) {
            if ($(".inputBtnSetA").css("display") == "none") {
                $(".inputBtnSetB").hide();
                $(".inputBtnSetA").show();
            } else {
                $(".inputBtnSetA").hide();
                $(".inputBtnSetB").show();
            }
        });

        // タップ時の画像変更イベントを登録
        changeTappingAlphabet("A");
        changeTappingAlphabet("B");
        changeTappingAlphabet("C");
        changeTappingAlphabet("D");
        changeTappingAlphabet("E");
        changeTappingAlphabet("F");
        changeTappingAlphabet("G");
        changeTappingAlphabet("H");
        changeTappingAlphabet("I");
        changeTappingAlphabet("J");
        changeTappingAlphabet("K");
        changeTappingAlphabet("M");
        changeTappingAlphabet("R");
        changeTappingAlphabet("T");
        changeTappingAlphabet("U");
        changeTappingAlphabet("Y");

        $(".inputBtnSetB").hide();

    } catch (e) {
        alert(e.toString());
    }
}

// ダイアログの中味を取得
function getStepTwoDialogContent() {
    //=============================
    // ダイアログ表示
    //=============================

    // テンプレート読み込み
    var text = kbnReadTextFile(".\\template\\stepTwoDialog.html");
    var template = _.template(text);
    var dialogHtml = template({
        
    });

    return dialogHtml;
}

function setStepTwoDialogStyle() {
    // 各要素に対して倍率をあてる必要がある
    // TODO:指定した要素配下の特定CSSを一括で変更するような仕組みにしたい。
    var $this = $('#stepTwoDialog');

    // ボタンのスタイル、タップ時のイベントを設定
    var btnStartWidth = $("#stepTwoDialogBtnStart").css("width");
    var btnReturnWidth = $("#stepTwoDialogBtnReturn").css("width");

    // サイズを適切に設定
    changeDesignSize(".dialogWrapper");

    setCommonButtonStyle(BUTTON_TYPE.SUB, btnReturnWidth, "stepTwoDialogBtnReturn");
    setCommonButtonStyle(BUTTON_TYPE.MAIN, btnStartWidth, "stepTwoDialogBtnStart");

    // イベント処理登録
    stepTwoDialogEvent();
}

// 削除ボタン
$(document).on("mousedown", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray_tap.svg");
});

$(document).on("mouseup", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

$(document).on("mouseout", ".deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-delete-gray.svg");
});

// 切り替えボタン
$(document).on("mousedown", ".switchBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch_tap.svg");
});

$(document).on("mouseup", ".switchBtn", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});

$(document).on("mouseout", ".switchBtn　", function () {
    $(this).attr("src", "../img/dialog/btn_num-switch.svg");
});
