/*
 * =================================================================
 * 定数
 * =================================================================
 */

//デザイン用
LITTLE_MARGIN = 16;
LARGE_MARGIN = 32;
CONTENT_WIDTH =　272;
CONTENT_HEIGHT = 208;
ADDBUTTON_WIDTH = 104;
ADDBUTTON_HEIGHT = 40;
// *** 年度更新対応 ***
//CONTENT_ADDBUTTON_WIDTH = 200;
CONTENT_ADDBUTTON_WIDTH = 272;
// *** 年度更新対応 ***
CONTENT_ADDBUTTON_HEIGHT = 40;
DOTLINE_HEIGHT = 20;

// js用
ROM = "rom";

/*
 * =================================================================
 * 変数
 * =================================================================
 */
// 処理を行うコンテンツID
var contentId;
// インストールを行う学年のコンテンツ
var installContentGrade;
// コンテンツ情報の取得
var objContentAllInfo;
// コンテンツ表示数判定
var arrContents = [];
// アップデートコンテンツの判定用
var updateContent = [];
// ROM検出判定用
var arrRomDisplay = [];
// ROM複数検出用
var arrRomContentId = [];
// コンテンツ表示数
var contentsDisplayValue = 4;
// 学年入力
var gradeInputType;
// 未認証コンテンツの表示
var displayUnapprovedContent;
// 学習履歴保存タイプ
var commonHistoryType;
// 端末利用者区分
var commonModeType;
// 端末利用者区分(指導者用)
var commonTeacherTerminalType;
// 利用場所区分
var commonUsePlaceType;
// チェック用コンテンツID
var checkContentId = "";
// 入力削除用
var nowInputGrade = "";
var nowInputClass = "";
var nowInputNumber = "";
// 準拠のみ設定フラグ
var updateStandardOnly;
// コンテンツ選択タイプ
var confirmType;
var installConfirmType;
var runType
var contentExternalType;
// PF起動状態
var startupMode;
// 本の認証用：コンテンツの学年チェックに使用
var checkAddGrade;
// 倍率
var magnification;
// アス比
var screenRatio;
// 学年 (使用しないが共通ロジックで参照するので変数だけ定義しておく)
var grade;
// 学年入力しているコンテンツID
var gradeInputContentId;
// コピーして使う判定
var mIsCopy;
// ROMからオンライン判定
var mIsRomOnline;
// 透過
var mOpacityValue = 0.4;
//// 設定(xml)上の学年情報 
//var mXmlGrade = undefined;

var mRomInstallParameterList;
// 特殊認証コードで入力したかどうか
var mIsSpecialAuthCode;

/*
 * =================================================================
 * ページロード時の処理
 * =================================================================
 */

$(window).load(function () {
   //// ios画面のちらつきを制御
   //$(".platformHeader").removeClass("displayNone");
});

$(document).ready(function () {

    // オフラインモード
    mIsOnlineMode = false;

    // 共通情報を取得 (他画面から当ファイルのグローバル変数を見ている為、必ず取得しておく)
    var res = getCommonInfoByFunc();
    var commonInfoObj = JSON.parse(res);
    commonHistoryType = commonInfoObj[0].history_type;
    commonModeType = commonInfoObj[0].mode;
	commonTeacherTerminalType = commonInfoObj[0].teacher_terminal_type;

    var setDesign = pfDesignDecision();
    magnification = setDesign[0];
    screenRatio = setDesign[1];

    // PFの起動状態を取得
    startupMode = getStartupModeByFunc();

    // コンテンツ情報を取得
    var resJson = getAllContentInfoByFunc("");
    obj = JSON.parse(resJson);
    objContentAllInfo = JSON.parse(resJson);

    // 背景活性
    $(".inactiveDiv").addClass("displayNone");

    //======================================================================
    // 自画面以外から呼び出された場合は処理を抜ける
    //======================================================================
    if (!checkDisplayFileName("index.html")) {
        return;
    }

    // ローディング画面の表示
    kbnShowLoading();

    setTimeout(function () {

        try {
            // iOS:初回のみトップページのディレクトリをPFに保存
            setTopPageDirectoryByFunc();
    
            var little_margin = LITTLE_MARGIN * magnification;
            var large_margin = LARGE_MARGIN * magnification;
            var content_width = CONTENT_WIDTH * magnification;
            var content_height = CONTENT_HEIGHT * magnification;
            var addbutton_width = ADDBUTTON_WIDTH * magnification;
            var addbutton_height = ADDBUTTON_HEIGHT * magnification;
            var content_addbutton_width = CONTENT_ADDBUTTON_WIDTH * magnification;
            var content_addbutton_height = CONTENT_ADDBUTTON_HEIGHT * magnification;
            var dotline_height = DOTLINE_HEIGHT * magnification;

            // ROMがない状態の1コンテンツの高さ
            $(".contentsImgArea").css("min-height", kbnGetMagnification(208));
                  
            if (startupMode == undefined) {
                // 取得失敗
                return;
            }

            // PFをROM起動の際に設定画像を非表示にする
            if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
                $(".appSettingImg").hide();
            }
    
            // 操作者の設定を取得
            var res = getAppSettingByFunc();
            if (res == undefined) {
                // 取得失敗
                return;
            }
            var objCommonSetting = JSON.parse(res);

            var htmlTxt = "";
            // 未認証表示フラグ
            var displayUnapprovedContent = getDisplayUnapprovedContentByFunc();

            // 未認証コンテンツの表示/非表示判定用
            commonUsePlaceType = objCommonSetting[0].use_place_type;
            var teacherAutoCode = objCommonSetting[0].teacher_mode_auth_code;

            // アップデートが必要なコンテンツを取得
            var res = getUpdateContentByFunc();
            if (res == undefined) {
                // 取得失敗
                return;
            }

            // アップデート内容がない場合
            if (res == "") {
                updateContent[999] = "dammy";
            } else {

                var objUpdateContent = JSON.parse(res);
                for (var val in objUpdateContent) {
                    updateContent[val] = objUpdateContent[val].content_id;
                }
            }

            // *** 年度更新対応 ***
            var versionInfoList;
            resJson = getVersionUpInfoByFunc(false);
            if (resJson) {
                versionInfoList = JSON.parse(resJson);
            }
            // *** 年度更新対応 ***

            // IOSではない時ROMの検出を開始する
            if (!kbnCheckTerminalType()) {
                window.external.StartRomLoading;
            }
            // コンテンツの初回起動チェック用
            var contentUnOpenList = [];

            // コンテンツごとに1件のみ表示
            var contentUnAuthentication = [];
            var contentAuthentication = [];

            // 学年追加ボタン出力判定
            for (var val in obj)
            {
                // 一度も開いていないコンテンツを格納
                if (obj[val].content_open_flg == 0 && obj[val].install_flg == 1)
                {
                    contentUnOpenList[obj[val].content_id] = obj[val].content_id;
                }
                // 未認証のコンテンツがある場合に配列に格納
                if (obj[val].authentication_flg == 0)
                {
                    contentUnAuthentication[obj[val].content_id] = 0;
                }
                // 認証済みのコンテンツがある場合に配列に格納
                if (obj[val].authentication_flg == 1)
                {
                    contentAuthentication[obj[val].content_id] = 1;
                }
                // 年度更新対応 ROMからインストールした場合の認証コードを更新
                if (obj[val].authentication_flg == 1 && obj[val].content_id != CONTENT_ID.STOP_WATCH) {
                    // 年度更新対応
                    var authCode = getAuthCode(obj[val].content_id, obj[val].grade);
                    if (!authCode) {
                        // ROMからひまポケインストールした場合に、認証コードが入らないため、更新する
                        var setAuthCode;
                        var json = checkAuthenticationTypeByFunc(obj[val].content_id, obj[val].grade);
                        if (json) {
                            setAuthCode = JSON.parse(json)[0].authentication_code;
                        } else {
                            // 更に取得できない場合、コンテンツ認証コードマスタから学年=0で取得する(画面で入力した学年だとマスタに学年=0で登録されているとヒットしない為）
                            json = checkAuthenticationTypeByFunc(obj[val].content_id, "0");
                            if (json) {
                                setAuthCode = JSON.parse(json)[0].authentication_code;
                            }
                        }
                        // 認証コードを更新
                        updateAuthCodeByFunc(obj[val].content_id, obj[val].grade, setAuthCode, false);
                    }
                }
            }

            // *** 年度更新対応 ***
            // コンテンツが認証期間内かどうかチェック
            var resExpiredJson = getContentExpiredByFunc("", "");
            var objExpired = JSON.parse(resExpiredJson);

            // 期限切れコンテンツのリスト
            var contentExpirationDate = []

            for (var val in objExpired) {
                if (objExpired[val].content_id == CONTENT_ID.STOP_WATCH) {
                    continue;
                }

                // 初期値として期限切れフラグを立てる
                if (contentExpirationDate[objExpired[val].content_id + "_all_expired"] == undefined) {
                    contentExpirationDate[objExpired[val].content_id + "_all_expired"] = 1
                }

                // 一つでも期限が有効な学年がある場合、期限切れトップページでは期限切れ画像を被せない
                if (objExpired[val].expired_flg == 0) {
                    contentExpirationDate[objExpired[val].content_id + "_all_expired"] = 0
                }
            }
            // *** 年度更新対応 ***

            var nuAuthenticationCounter = 0;
            var authenticationCounter = 0;
            var contentCounter = 1;
            // コンテンツごとにDIVを生成(最大表示数:contentsDisplayValue)
            for (var val in obj)
            {
                // ROM検出用
                arrRomDisplay["contentId_" + obj[val].content_id + "_grade_" + obj[val].grade] = obj[val].install_flg;
        
                // 操作者モードにより出力有無を判定
                if (commonModeType == OPERATION_MODE.TEACHER_MODE &&
                    obj[val].menu_display_type == MENU_DISPLAY_TYPE.CHILDREN_MODE) {
                    // 教師用モードで児童用しか表示しないコンテンツは読み飛ばす
                    continue;
                }
                if (commonModeType == OPERATION_MODE.CHILDREN_MODE &&
                    obj[val].menu_display_type == MENU_DISPLAY_TYPE.TEACHER_MODE) {
                    // 児童用モードで教師用しか表示しないコンテンツは読み飛ばす
                    continue;
                }
                if (commonUsePlaceType == USE_PLACE_TYPE.HOME_MODE &&
                    obj[val].menu_display_type == MENU_DISPLAY_TYPE.TEACHER_MODE) {
                    // 家庭で使う場合は教師用しか表示しないコンテンツは読み飛ばす
                    continue;
                }
                // *** 年度更新対応 ***
                if (commonModeType == OPERATION_MODE.CHILDREN_MODE &&
                    contentExpirationDate[obj[val].content_id + "_all_expired"] == 1 &&
                    obj[val].content_id != CONTENT_ID.STOP_WATCH) {
                    // 学習者モードで使用期限切れのコンテンツは読み飛ばす
                    continue;
                }
                // *** 年度更新対応 ***

                // コンテンツがすでに表示されている場合に処理を行わない
                if (arrContents[obj[val].content_id] == null)
                {
                    if (obj[val].authentication_flg == 1 || contentAuthentication[obj[val].content_id] == 1)
                    {
                        authenticationCounter++;

                        var content_area_height = (CONTENT_HEIGHT + ADDBUTTON_HEIGHT) * magnification;

                        // 認証コンテンツ
                
                        if (contentCounter <= 3) {
                            htmlTxt = "<div style='display:inline-block; margin-right:" + little_margin + "px;margin-top:" + large_margin + "px;' class='contentsImgArea'>";
                        }
                        else {
                            htmlTxt = "<div style='display:inline-block; margin-right:" + little_margin + "px;margin-top:" + large_margin + "px;'>";
                        }

                        contentCounter++;
                        htmlTxt += "<div id='contentId_" + obj[val].content_id + "_inputFlg_" + obj[val].grade_input_flg + "_contentType_" + obj[val].content_type + "_grade_" + obj[val].grade;
                        htmlTxt += "' class='authenticationArea touchHandler'>";
                
                        var defImageFile = replaceImagePath(obj[val].content_image_path);
            
                        var imageFile = defImageFile.split("/");
                        var count = 0;
                        var contentNewImage = "";
                        while (count < imageFile.length)
                        {
                            // ファイル名の場合NEWを付加
                            if (imageFile.length - 1 == count)
                            {
                                //ストップウォッチ以外の認証済みコンテンツの場合は最後尾に"_1"をつける
                                //if(imageFile[count] != "stop-watch_0.svg"){
                                imageFile[count] = imageFile[count].replace(".png","_1.png");  
                                //}
                        
                            }
                            contentNewImage += imageFile[count] + "/";
                            count++;
                        }

                        // 文字列の最後についている[/]を削除
                        htmlTxt += "<img src='../../" + contentNewImage.slice(0, -1) + "' class='tapableImage' style='width:" + content_width + "px; height:" + content_height + "px;'/>";
                  
                        // htmlTxt += "<img src='../../" + obj[val].content_image_path + "' />";

                        if (contentUnOpenList[obj[val].content_id] == undefined || obj[val].content_type == 3)
                        {
                        }
                        else
                        {
                            // 初回起動前のコンテンツのnew画像を表示する
                            htmlTxt += "<img src='../img/contentImg/content_btn_new.svg' class='newContent' style='width:" + content_width + "px; height:" + content_height + "px;' />";

                        }
                        // 期限切れコンテンツの場合（ストップウォッチ以外）
                        if (obj[val].content_id != "stopwatch") {
                            // 全学年期限切れのコンテンツ
                            if (contentExpirationDate[obj[val].content_id + "_all_expired"] == 1) {

                                // 期限切れ画像を重ねる
                                htmlTxt += "<img src='../img/contentImg/contents_btn_expired.png' class='expiredContent' style='width:" + content_width + "px; height:" + content_height + "px;' />";

                                // クラス名変更(authenticationArea ⇒ expiredContentArea)
                                var baseTxt = "<div id='contentId_" + obj[val].content_id + "_inputFlg_" + obj[val].grade_input_flg + "_contentType_" + obj[val].content_type + "_grade_" + obj[val].grade;
                                var befTxt = baseTxt + "' class='authenticationArea touchHandler'>";
                                var aftTxt = baseTxt + "' class='expiredContentArea touchHandler'>";

                                htmlTxt = htmlTxt.replace(befTxt, aftTxt);
                            } else {

                                // *** オンライン対応 Start ***
                                // オンラインの場合、WEB版アイコンを表示
                                if (isOnlineContent(obj[val].content_id, obj[val].grade)) {
                                    Object.keys(ALL_ONLINE_CONTENT_ID).forEach(function (value) {
                                        if (obj[val].content_id == this[value]) {
                                            htmlTxt += "<img src='../img/contentImg/contents_btn_badge-web-A.png' class='onlineContent' style='width:" + content_width + "px; height:" + content_height + "px;' />";
                                        }
                                    }, ALL_ONLINE_CONTENT_ID)
                                    Object.keys(GRADE_BETSU_ONLINE_CONTENT_ID).forEach(function (value) {
                                        if (obj[val].content_id == this[value]) {
                                            htmlTxt += "<img src='../img/contentImg/contents_btn_badge-web-B.png' class='onlineContent' style='width:" + content_width + "px; height:" + content_height + "px;' />";
                                        }
                                    }, GRADE_BETSU_ONLINE_CONTENT_ID)
                                }
                                // *** オンライン対応 End ***
                            }
                        }
                        // *** 年度更新対応 ***

                        htmlTxt += "</div>";

                        if (commonUsePlaceType == USE_PLACE_TYPE.HOME_MODE ||
                            commonModeType == OPERATION_MODE.TEACHER_MODE) {
                            // 家庭使用または、教師モードの場合

                            // アップデートが必要な場合「内容更新」ボタンを表示
                            if (updateContent.indexOf(obj[val].content_id) != -1 &&
                               ((OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1) ||
                                (USE_PLACE_TYPE.HOME_MODE == commonUsePlaceType || displayUnapprovedContent == 1))) {
                                htmlTxt += "<div id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_web_update' class='updateContent touchHandler'>"
                                    + "<img src='../img/common/btn_add-semester.svg' class='tapableImage' style='width:" + addbutton_width + "px; height:" + addbutton_height + "px;'/>"
                                    + "</div>";
                            }

                            // 未認証のコンテンツが存在する場合に「学年追加」ボタンを表示する
                            //if (contentUnAuthentication[obj[val].content_id] == 0 &&
                            //   ((OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1) ||
                            //    (USE_PLACE_TYPE.HOME_MODE == commonUsePlaceType || displayUnapprovedContent == 1)))
                            // 未認証のコンテンツが存在するか、分割インストールに対応している場合に「追加・変更」ボタンを表示する
                            var splitInstallType = getSplitInstallTypeByFunc(obj[val].content_id);
                            if ((contentUnAuthentication[obj[val].content_id] == 0 ||
                                 splitInstallType == SPLIT_INSTALL_TYPE.MATERIAL_OR_STANDARD ||
                                 splitInstallType == SPLIT_INSTALL_TYPE.INDIVIDUAL) &&
                                ((OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1) ||
                                (USE_PLACE_TYPE.HOME_MODE == commonUsePlaceType || displayUnapprovedContent == 1))) {
								// iosの場合は準拠IDがデモ版の場合は表示しない
                                if (!checkStandardDemoIdByFunc(obj[val].content_id, obj[val].standard_id, obj[val].material_id)) {
                                    // iosの場合は準拠IDがデモ版の場合は表示しない
                                    // オンラインの場合は表示しない
                                    if (!isOnlineContent(obj[val].content_id, obj[val].grade)) {
                                        // *** 年度更新対応 ***
                                        // デジ漢、デジ計以外
                                        if (!((obj[val].content_id == CONTENT_ID.DIGI_KAN || obj[val].content_id == CONTENT_ID.DIGI_KEI) &&
                                            contentExpirationDate[obj[val].content_id + "_all_expired"] == 1)) {
                                            // コンテンツの更新有無でボタンイメージ変更
                                            if (isNeedVersionUpBadge(versionInfoList, obj[val].content_id)) {
                                                // 更新があるコンテンツの場合
                                                htmlTxt += "<div style='float: right; position: relative;' id='contentId_" + obj[val].content_id + "_grade_999_web' class='addGrade touchHandler'>"
                                                    + "<img src='../img/common/btn_add-contents-alert.png' class='tapableImage' style='width:" + content_addbutton_width + "px; height:" + content_addbutton_height + "px;'/>"
                                                    + "</div>";
                                            } else {
                                                // 更新がないコンテンツの場合
                                                htmlTxt += "<div style='float: right; position: relative;' id='contentId_" + obj[val].content_id + "_grade_999_web' class='addGrade touchHandler'>"
                                                    + "<img src='../img/common/btn_add-contents.png' class='tapableImage' style='width:" + content_addbutton_width + "px; height:" + content_addbutton_height + "px;'/>"
                                                    + "</div>";
                                            }
                                        }
                                        // *** 年度更新対応 ***
                                    }
                                }
							}
                        }

                        htmlTxt += "</div>";
                        arrContents[obj[val].content_id] = obj[val].install_flg;

                        $("#authentication_1").append(htmlTxt);

                        //コンテンツタップ時のイベント作成
                        //マウスダウン
                        $("#contentId_" + obj[val].content_id + "_inputFlg_" + obj[val].grade_input_flg + "_contentType_" + obj[val].content_type + "_grade_" + obj[val].grade).mousedown(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,true);
                    
                        });

                        //マウスアップ
                        $("#contentId_" + obj[val].content_id + "_inputFlg_" + obj[val].grade_input_flg + "_contentType_" + obj[val].content_type + "_grade_" + obj[val].grade).mouseup(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,false);

                        });

                        //マウスアウト
                        $("#contentId_" + obj[val].content_id + "_inputFlg_" + obj[val].grade_input_flg + "_contentType_" + obj[val].content_type + "_grade_" + obj[val].grade).mouseout(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,false);

                        });

                        //「内容更新」ボタンタップ時イベント
                        if(updateContent.indexOf(obj[val].content_id) != -1 &&
                           (OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1)){
                            //マウスダウン
                            $(".updateContent").mousedown(function(evt){
                                var id = evt.currentTarget.id;
                                changeImageTap(id,true);
                            });
                            //マウスアップ
                            $(".updateContent").mouseup(function(evt){
                                var id = evt.currentTarget.id;
                                changeImageTap(id,false);
                            });
                            //マウスアウト
                            $(".updateContent").mouseout(function(evt){
                                var id = evt.currentTarget.id;
                                changeImageTap(id,false);
                            });
                        }

                        //「学年追加」ボタンタップ時イベント
                        //if(contentUnAuthentication[obj[val].content_id] == 0 && 
                        //   (OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1)){
                        // 「追加・変更」ボタンタップ時イベント(未認証のコンテンツが存在するか、分割インストールに対応している場合)
                        var splitInstallType = getSplitInstallTypeByFunc(obj[val].content_id);
                        if ((contentUnAuthentication[obj[val].content_id] == 0 ||
                             splitInstallType == SPLIT_INSTALL_TYPE.INDIVIDUAL) &&
                            ((OPERATION_MODE.TEACHER_MODE == commonModeType || displayUnapprovedContent == 1) ||
                            (USE_PLACE_TYPE.HOME_MODE == commonUsePlaceType || displayUnapprovedContent == 1)))
                        {
                            //マウスダウン
                            $(".addGrade").mousedown(function (evt) {
                                var id = evt.currentTarget.id;
                                changeImageTap(id, true);
                            });
                            //マウスアップ
                            $(".addGrade").mouseup(function(evt){
                                var id = evt.currentTarget.id;
                                changeImageTap(id,false);
                            });

                            //マウスアウト
                            $(".addGrade").mouseout(function(evt){
                                var id = evt.currentTarget.id;
                                changeImageTap(id,false);
                            });
                        }
                    } else {
                        // 未認証コンテンツカウント
                        nuAuthenticationCounter++;
                        // 未認証コンテンツ
                        htmlTxt = "<div id='contentId_" + obj[val].content_id + "_grade_0_web' class='unauthenticationArea authAreaFloat touchHandler'>";
                        var defImageFile = replaceImagePath(obj[val].content_image_path);
                        var imageFile = defImageFile.split("/");
                        var count = 0;
                        var contentNewImage = "";
                        // 分解した文字列からファイル名にNEWを付加
                        while (count < imageFile.length)
                        {
                            // ファイル名の場合NEWを付加
                            if (imageFile.length - 1 == count)
                            {
                                //認証済みコンテンツの場合は最後尾に"_1"をつける
                                imageFile[count] = imageFile[count].replace(".png", "_0.png");
                            }
                            contentNewImage += imageFile[count] + "/"
                            count++;
                        }
                        // 文字列の最後についている[/]を削除
                        htmlTxt += "<img src='../../" + contentNewImage.slice(0, -1) + "' class='tapableImage' style='width:" + content_width + "px; height:" + content_height + "px;'/>";

                        // htmlTxt += "<img src='../../" + obj[val].content_image_path + "' style='width:100%;' />";
                        htmlTxt += "</div>";
                        arrContents[obj[val].content_id] = obj[val].install_flg;
                        $("#authentication_" + obj[val].authentication_flg).append(htmlTxt);

                        //コンテンツタップ時のイベント作成
                        //マウスダウン
                        $("#contentId_" + obj[val].content_id + "_grade_0_web").mousedown(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,true);
                    
                        });

                        //マウスアップ
                        $("#contentId_" + obj[val].content_id + "_grade_0_web").mouseup(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,false);
                    
                        });

                        //マウスアウト
                        $("#contentId_" + obj[val].content_id + "_grade_0_web").mouseout(function(evt){
                    
                            var id = evt.currentTarget.id;
                            changeImageTap(id,false);
                    
                        });

                    }
                }
            }

            //if (OPERATION_MODE.CHILDREN_MODE == commonModeType && displayUnapprovedContent == 2)
            if (commonUsePlaceType == USE_PLACE_TYPE.SCHOOL_MODE &&
                OPERATION_MODE.CHILDREN_MODE == commonModeType)
            {
                // 学校で使う場合、学習者モードなら未認証コンテンツ非表示設定時に領域を削除
                nuAuthenticationCounter = 0;
                $("#authentication_0").remove();
            }

            /**
             * ページを離れる際にROM検出を終了する。
             */
            $(window).on('beforeunload', function () {
                // iOSでは使用しない
                if (!kbnCheckTerminalType()) {
                    // ROM検出を終了する
                    window.external.StopRomLoading;
                }
            });


            var changeImageTap = function (parentId, isDown) {
                //parentIdの直下のimgのsrcをとってくる
                var contentImage = $("#" + parentId).find(".tapableImage").attr("src");
                if (isDown) {
                    contentImage = contentImage.replace(".png", "_tap.png");
                    // 何故か複数ある時に一番左だけ2回イベントが走るのを回避
                    if (contentImage.indexOf("tap_tap.png") > -1) {
                        return;
                    }
                }else{
                    contentImage　=contentImage.replace("_tap.png",".png");
                }

                $("#" + parentId).find(".tapableImage").attr("src",contentImage);
            }


            /**
             * 画面のサイズからスタイルを別ける
             */
            //ヘッダ部分

            var screen_width = getTerminalWidth();
            //固定値は低画質：倍率1倍をもとにしている
            var hedderLogoLeft = (screen_width / 2) - (320 / 2 * magnification);
            $(".indexHeaderText").css("left", hedderLogoLeft);

            // 指導者用の表示
            if (commonModeType == OPERATION_MODE.TEACHER_MODE) {
                var teacherModeLeft = hedderLogoLeft - (84 * magnification);
                $(".indexHeaderTeacherMode").css("left", teacherModeLeft);
                $(".indexHeaderTeacherMode").css("top", (18 * magnification));
                $(".indexHeaderTeacherMode").show();
            } else {
                $(".indexHeaderTeacherMode").hide();
            }

            //コンテンツ部分
            var contentBodyWidth;
            //アスペクト比　4：3
            if(screenRatio == 0){
                contentBodyWidth = 864　* magnification;
                //アスペクト比　16：9
            }else if(screenRatio == 1){
                contentBodyWidth = 1152 * magnification;
            }

            $(".contents").css("margin-top", large_margin);

            //8pxはコンテンツ画像のmargin‐left=16 /2pxを考慮した値
            $(".contentsBody").css("width",contentBodyWidth);
            var contentBodyLeft = ((screen_width - contentBodyWidth) / 2) + (8 * magnification);
            $(".contentsBody").css("margin-left", contentBodyLeft);

            // 承認済コンテンツがある場合
            if (authenticationCounter > 0) {
                //区切りドット線の表示位置を指定
                $(".indexLine").css("width", contentBodyWidth - little_margin);
                $(".indexLine").css("height", dotline_height);
                $(".indexLine").css("margin-left", contentBodyLeft);
                $(".indexLine").css("background-size", "auto " + dotline_height + "px");
                $(".indexLine").css("top", little_margin);
            }

            //未認証コンテンツ表示エリア
            //little_margin * 2 = indexLine:top=16px + indexLineとのmargin16px
            $(".authContentArea").css("margin-top", little_margin * 2);
            //$(".authContentArea").css("padding-bottom", 64 * magnification); 

            //コンテンツ画像スタイル
            $(".unauthenticationArea").css("width",content_width);
            $(".unauthenticationArea").css("height",content_height);
            $(".unauthenticationArea").css("margin-right",little_margin);
            $(".unauthenticationArea").css("margin-bottom",large_margin);
            //追加ボタンの位置調整
            $(".updateContent").css("margin-right", 　10 * magnification);
            // *** 年度更新対応 ***
            //$(".addGrade").css("margin-right",　10 * magnification);
            // *** 年度更新対応 ***

            // 未認証コンテンツが存在しない場合ラインを削除
            if(nuAuthenticationCounter == 0){
                $(".indexLine").remove();
            }

            // PF更新後起動確認
            if (isFirstByPFVersionUp()) {
                return;
            }

            // ==============================================================================
            // ここ以下の処理は状態によりアラート表示を行うので表示後はreturnで抜けること
            // ==============================================================================

            if (!kbnCheckTerminalType()) {
                // 表示中のHTMlファイル名を判定
                if (checkDisplayFileName("index.html")) {
                    // 外部からの起動パラメータでコンテンツ起動している場合のエラー表示（あれば）
                    var queryString = getUrlVars();
                    var autoStartContentResult = queryString["autoStartContentResult"];
                    var callback = function () {
                        // 同じページでリロードするともう一度アラート表示されるので、クエリストリングをクリアする
                        location.href = "./index.html";
                    }
                    switch (parseInt(autoStartContentResult)) {
                        case 2:
                            kbnAlert("コンテンツを起動できません。", "本機能の実行には，ひまわりポケットの設定を指導者用に変更する必要があります。<br>トップ画面右上の[学習者用]を選択し，変更してください。", callback, 500);
                            return;
                        case 9:
                            kbnAlert("コンテンツがインストールされていません。", "対象のコンテンツをインストールしてください。", callback, 500);
                            return;
                        default:
                            break;
                    }
                }
            }

            // インストールキーチェック
            if (!isValidInstallKeyByFunc()) {
                var callBack = function () {
                    finishPlatformByFunc();
                }
                kbnAlert("端末認証エラー", "ひまわりポケットを[インストール]，もしくは[コピー]した端末でのみご利用いただけます。<br>本端末でご利用になる場合は，本端末にて再度[インストール]，もしくは[コピー]を行ってください。", callBack, 450);
                return;
            }

            if (commonUsePlaceType.length <= 0 && PF_STARTUP_MODE.INSTALL_MODE == startupMode) {
                // ROMの場合は起動しない
                // 未設定の場合初期設定ダイアログを表示する
                openStepOneDialog(teacherAutoCode);
            } else if (PF_STARTUP_MODE.INSTALL_MODE == startupMode) {
                // 表示中のHTMlファイル名を判定
                if (checkDisplayFileName("index.html")) {
                    // indexの場合
                    // 年度更新通知を確認
                    if (!checkNotificationVersion(NOTIFICATION_TYPE.YEARLY_UPDATE)) {
                        return;
                    }
                    // ひまポケレジストリチェック
                    // 差異があればレジストリ更新
                    if (!checkRegistryHimapokeVersion()) {
                        return;
                    }
                    // 更新通知を確認
                    if (!checkNotificationVersion(NOTIFICATION_TYPE.UPDATE)) {
                        return;
                    }
                }
            }

        } finally {
            // ios画面のちらつきを制御
            $(".platformHeader").removeClass("displayNone");
            $(".contents").removeClass("displayNone");

            // ローディング画面を非表示
            kbnHideLoading();
        }
    }, 1);


});

/**
 * スプラッシュ画面を起動用スタブ
 */
function stubOpenSplash()
{
    if (isDebugModeByFunc()) {
        if (kbnCheckTerminalType()) {
            // IOSの場合
            //nativeRequest("stubContents", window.location.pathname);
            
        } else {
            // windowsの場合
            var imagePath = window.external.StubGetValue("contentSplashImagePath");
            var transitionPath = window.external.StubGetValue("topPagePath");
            pfOpenSplash(imagePath, transitionPath);
        }
    }
}

/*
 * =================================================================
 * 各コンテンツ押下時の処理
 * =================================================================
 */

/*
 * 認証コンテンツ押下時
 */
$(document).on("click", ".authenticationArea", function () {
    // 押下したコンテンツのIDを取得
    var id = $(this).attr('id');

    startContentCommon(id);
});

/**
 * 認証コンテンツ：学年追加押下時
 */
$(document).on("click", ".addGrade", function (e) {

    var dialogId = 'dialog-addGrade' + Math.floor($(this).position().left);
    if ($("#" + dialogId).length) {
        $("#" + dialogId).remove();
        return;
    }

    // 押下したコンテンツのIDを取得
    var id = $(this).attr('id');

    var content_id_dammy = id.split("_");

    var content_id = content_id_dammy[1];
    var confirmType = content_id_dammy[4];

    // コンテンツ情報取得
    var resJson = getAllContentInfoByFunc(content_id);

    // 分割インストール区分を取得
    var splitInstallType = getSplitInstallTypeByFunc(content_id);

    // タップした場所
    var x = $(this).position().left;
    var y = $(this).position().top;

    //ダイアログ全体のサイズ取得
    var dialogTranslationWidth = getTerminalWidth();
    var dialogTranslationHeight = getTerminalHeight();

    //ダイアログ表示領域設定
    dialogBody = $(document.createElement('div'));
    dialogBody.attr('id', dialogId);
    dialogBody.css('position', 'absolute');
    dialogBody.css('min-width', kbnGetMagnification(270));
    dialogBody.css('z-index', 4);
    dialogBody.css('opacity', 1);
    dialogBody.css('background-color', '#fff');
    dialogBody.css('top', kbnGetMagnification(35));
    // *** 年度更新対応 ***
    //dialogBody.css('left', kbnGetMagnification(-35));
    // *** 年度更新対応 ***
    dialogBody.css('box-shadow', ' 0px ' + 1 * magnification + 'px ' + 7 * magnification + 'px rgba(0, 0, 0, ' + 0.5 * magnification + ')');
    dialogBody.css("border-radius", kbnGetMagnification(16));

    // 学年追加表示
    var obj = JSON.parse(resJson);

    var multiInstallFlg = obj[0].multi_grade_install_flg;

    var dialog = "<div style='min-width: " + kbnGetMagnification(180) + ";height:auto;'>";

    var trianglePosition = ((270 * magnification) - (35 * magnification)) / 2;

    var triangleClass;
    if (magnification == 1) {
        // 低解像度
        triangleClass = "triangle-topSmall";
    } else if (magnification == 1.5) {
        // 中解像度
        triangleClass = "triangle-topMiddle";
    } else {
        // 高解像度
        triangleClass = "triangle-topLarge";
    }

    // 三角のスタイル
    dialog += "<div class='" + triangleClass + "' style='margin-top: -" + kbnGetMagnification(12.5) + ";margin-left: " + trianglePosition + "px;padding-bottom:" + kbnGetMagnification(12.5) + ";'></div>";

    dialog += "<table style='width: 100%;'>";
    var tableTdAlign = "align='center' valign='middle'";

    // *** 年度更新対応 ***
    var resExpiredJson = getContentExpiredByFunc(content_id, "");
    var objExpired = JSON.parse(resExpiredJson);
    // *** 年度更新対応 ***

    // テーブルのスタイル
    var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;";
    var discId = [];
    var counter = 1;
    if (multiInstallFlg == 0) {

        var isAdd = false;
        // 通常の表示
        // 2016年対応:デジ漢は吹き出しを表示しない
        // 2017年対応:デジ計は吹き出しを表示しない
        // TODO:正式には1ディスクIDで6学年あれば当条件に該当
        if (content_id == "digikan" ||
            content_id == "digikei") {
            var confirmType = "web";
            var grade = 0;
            var multiInstall = 0;
            setTimeout(function () {
                window.location.href = "../html/content-detail.html?contentId_" + content_id + "_confirmType_" + confirmType + "_grade_" + grade + "_updateFlg_addOrDelete_multiInstallFlg_" + multiInstall;
            }, 100);
            return;
        } else {
            for (var val in obj) {
                // 最後の場合
                if (counter != 1) {
                    var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;border-top: " + 1 + "px solid #98928C;";
                } else {
                    var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;";
                }

                dialog += "<tr>";
                if (obj[val].authentication_flg == 0) {
                    // 未認証
                    dialog += "<td " + tableTdAlign + " style='color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "' class='unauthenticationArea addGradeArea touchHandler'>" + obj[val].grade;
                    dialog += "年を追加</td>";
                } else {
                    // 認証済み
                    // *** 年度更新対応 ***
                    // 期限切れフラグ
                    var expiredFlg = false;
                    // ここでコンテンツID、学年で使用期限をチェックしにいく
                    for (var expiredVal in objExpired) {
                        // 対象の学年でない場合は読み飛ばす
                        if (objExpired[expiredVal].grade != obj[val].grade) {
                            continue;
                        }

                        // DBから取得した期限切れフラグがONの場合、フラグON
                        if (objExpired[expiredVal].expired_flg == 1) {
                            expiredFlg = true;
                        }
                    }

                    if (!expiredFlg) {
                        // 認証済み
                        if (splitInstallType != SPLIT_INSTALL_TYPE.INDIVIDUAL) {
                            // 認証済み
                            dialog += "<td " + tableTdAlign + " style='color: #1A1A1A; " + tableTdStyle + "font-size: " + kbnGetMagnification(16) + ";'>" + obj[val].grade + "年" + ":インストール済み</td>";
                        } else {
                            // 分割インストール対応の場合は詳細画面へのリンクを付ける
                            dialog += "<td " + tableTdAlign + " style='color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "' class='contentAddOrDeleteArea addGradeArea touchHandler'>" + obj[val].grade;
                            dialog += "年:内容・機能追加/削除</td>";
                        }
                    } else {
                        // 使用期限切れの学年
                        dialog += "<td " + tableTdAlign + " style='padding-top: " + kbnGetMagnification(14) + "; padding-bottom: " + kbnGetMagnification(7) + "; color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "' class='expiredContentGradeArea addGradeArea touchHandler'>"
                        dialog += "<img src = '../img/contentImg/label_expired_m.png' class='' align='center' valign='middle' style='padding-bottom: " + kbnGetMagnification(1) + "; width:" + magnification * 110 + "px; height:" + magnification * 27 + "px;' >"
                        dialog += "<br>";
                        dialog += obj[val].grade + "年:更新する</td>";
                    }
                    // *** 年度更新対応 ***
                }
                dialog += "</tr>";
                counter++;
            }
        }
    } else {
        // 複数学年がインストール可能なコンテンツ
        // 最後の場合
        if (counter == obj.length) {
            var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;";
        }

        var contentDiscList = [];
        // ディスクIDを参照
        for (var val in obj) {
            if (discId[obj[val].disc_id] == obj[val].disc_id) {
                contentDiscList[obj[val].disc_id] += "・" + obj[val].grade;
            } else {
                contentDiscList[obj[val].disc_id] = obj[val].grade;
                discId[obj[val].disc_id] = obj[val].disc_id;
            }
        }

        var discId = [];
        // 通常の表示
        for (var val in obj) {
            // 最後の場合
            if (counter != 1) {
                var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;border-top: " + 1 * magnification + "px solid #302519;";
            } else {
                var tableTdStyle = "height: " + kbnGetMagnification(60) + "; width: 100%;";
            }

            dialog += "<tr>";
            if (obj[val].authentication_flg == 0) {
                // 未認証
                if (discId[obj[val].disc_id] != obj[val].disc_id) {
                    dialog += "<td " + tableTdAlign + " style='color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "_1" + "' class='unauthenticationArea addGradeArea touchHandler'>" + contentDiscList[obj[val].disc_id];
                    dialog += "年を追加</td>";
                }
            } else {
                // 認証済み
                // *** 年度更新対応 ***
                // 期限切れフラグ
                var expiredFlg = false;
                // ここでコンテンツID、学年で使用期限をチェックしにいく
                for (var expiredVal in objExpired) {
                    // 対象の学年でない場合は読み飛ばす
                    if (objExpired[expiredVal].grade != obj[val].grade) {
                        continue;
                    }

                    // DBから取得した期限切れフラグがONの場合、フラグON
                    if (objExpired[expiredVal].expired_flg == 1) {
                        expiredFlg = true;
                    }
                }
                // *** 年度更新対応 ***

                // *** 年度更新対応 ***
                if (!expiredFlg) {
                    //dialog += "<td " + tableTdAlign + " style='color: #1A1A1A; " + tableTdStyle + "font-size: " + kbnGetMagnification(16) + ";'>" + obj[val].grade + "年" + ":インストール済み</td>";
                    if (splitInstallType == SPLIT_INSTALL_TYPE.NONE) {
                        // 認証済み
                        dialog += "<td " + tableTdAlign + " style='color: #1A1A1A; " + tableTdStyle + "font-size: " + kbnGetMagnification(16) + ";'>" + obj[val].grade + "年" + ":インストール済み</td>";
                    } else {
                        // 分割インストール対応の場合は詳細画面へのリンクを付ける
                        dialog += "<td " + tableTdAlign + " style='color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "_1" + "' class='contentAddOrDeleteArea addGradeArea touchHandler'>" + contentDiscList[obj[val].disc_id];
                        dialog += "年:コンテンツの追加・削除</td>";
                    }
                } else {
                    dialog += "<td " + tableTdAlign + " style='padding-top: " + kbnGetMagnification(14) + "; padding-bottom: " + kbnGetMagnification(7) + "; color: #EB8219 ;cursor: pointer;" + tableTdStyle + "font-size: " + kbnGetMagnification(20) + ";' id='contentId_" + obj[val].content_id + "_grade_" + obj[val].grade + "_" + confirmType + "' class='expiredContentGradeArea addGradeArea touchHandler'>"
                    dialog += "<img src = '../img/contentImg/label_expired_m.png' class='' align='center' valign='middle' style='padding-bottom: " + kbnGetMagnification(1) + "; width:" + magnification * 110 + "px; height:" + magnification * 27 + "px;' >"
                    dialog += "<br>";
                    dialog += obj[val].grade + "年:更新する</td>";
                }
                // *** 年度更新対応 ***
            }
            dialog += "</tr>";
            counter++;
            discId[obj[val].disc_id] = obj[val].disc_id;
        }

    }

    dialog += "</table>";

    dialog += "</div>";

    $(dialogBody).append(dialog);
    //$('body').append(dialogBody);
    $(e.currentTarget).append(dialogBody);
});

/**
 * 認証コンテンツ：内容更新押下時
 */
$(document).on("click", ".updateContent", function () {

    // 押下した学年を取得
    var id = $(this).attr('id');
    var dammy_id = id.split("_");

    // 押下したコンテンツ、学年を判定
    var content_id = dammy_id[1];
    var grade = dammy_id[3];
    var confirmType = dammy_id[4];
    var updateFlg = dammy_id[5];

    window.location.href = "../html/content-detail.html?contentId_" + content_id + "_confirmType_" + confirmType + "_grade_" + grade + "_updateFlg_" + updateFlg;

});

/**
 * 未認証コンテンツ押下時の処理
 */
$(document).on("click", ".unauthenticationArea", function (evt) {

    // 押下した学年を取得
    var id = $(this).attr('id');
    var dammy_id = id.split("_");

    // 押下したコンテンツ、学年を判定
    var content_id = dammy_id[1];
    var grade = dammy_id[3];
    var confirmType = dammy_id[4];
    var multiInstall = dammy_id[5];

    // H31ひまポケ #273 ADD START
    // 過去年度のROMからのコンテンツ追加の配慮対応
    if (ROM == confirmType) {
        if (isPastYearRomByFunc(content_id, grade)) {
            kbnAlert("確認","過去年度のROMはご利用できません。");
            return;
        }
    }
    // H31ひまポケ #273 ADD END

    setTimeout(function () {
        window.location.href = "../html/content-detail.html?contentId_" + content_id + "_confirmType_" + confirmType + "_grade_" + grade + "_updateFlg_unUpdate_multiInstallFlg_" + multiInstall;
    }, 100);

});

/**
 * コンテンツ追加・削除押下時の処理
 */
$(document).on("click", ".contentAddOrDeleteArea", function (evt) {

    // 押下した学年を取得
    var id = $(this).attr('id');
    var dammy_id = id.split("_");

    // 押下したコンテンツ、学年を判定
    var content_id = dammy_id[1];
    var grade = dammy_id[3];
    var confirmType = dammy_id[4];
    var multiInstall = dammy_id[5];
    setTimeout(function () {
        window.location.href = "../html/content-detail.html?contentId_" + content_id + "_confirmType_" + confirmType + "_grade_" + grade + "_updateFlg_addOrDelete_multiInstallFlg_" + multiInstall;
    }, 100);

});

// *** 年度更新対応 ***
/*
 * 使用期限切れコンテンツ押下時
 */
$(document).on("click", ".expiredContentArea", function () {
    // 押下したコンテンツのIDを取得
    var id = $(this).attr('id');
    var dammy_id = id.split("_");

    // コンテンツID
    var content_id = dammy_id[1];
    // 学年入力フラグ
    var gradeInputFlg = dammy_id[3];

    contentExternalType = dammy_id[5];

    checkContentId = content_id;
    contentId = content_id;
    
    if (gradeInputFlg == 0 || content_id == CONTENT_ID.DIGI_KAN || content_id == CONTENT_ID.DIGI_KEI) {
        contentReauthentication(content_id, "")
    } else {
        //startContentCommon(id);
        //closeDialog();
        InputGradeClassNumberDialog(content_id, contentExternalType, true)
    }
    //contentReauthentication(content_id, grade);
});

/**
 * コンテンツ追加・削除ドロップダウン
 * 使用期限切れの学年押下時の処理
 */
$(document).on("click", ".expiredContentGradeArea", function (evt) {

    // 押下した学年を取得
    var id = $(this).attr('id');
    var dammy_id = id.split("_");

    // 押下したコンテンツ、学年を判定
    var content_id = dammy_id[1];
    var grade = dammy_id[3];
    var confirmType = dammy_id[4];
    var multiInstall = dammy_id[5];

    contentReauthentication(content_id, grade);
});

// 使用期限切れコンテンツの再認証
function contentReauthentication(content_id, grade) {

    var resJson = getContentDetailInfoByFunc(content_id);
    var obj = JSON.parse(resJson);

    resJson = getContentSettingByFunc(content_id, grade);
    objSetting = JSON.parse(resJson);

    var contentImg = obj[0].content_image_path;
    var contentName = obj[0].content_name;
    var updateState = "update";
    var multiGradeInstallFlg = objSetting.multi_grade_install_flg;

    pfOpenDialog(MODE.REAUTHENTICATION_MODE, contentImg, contentName, grade, updateState, multiGradeInstallFlg, content_id);
}

/**
 * インストール経過時間を元にプログレスバーを更新
 * ※同名ファンクションがapp-setting.js、content-detail.jsにもあるので注意
 * 　基本的には呼び出し元のhtmlに対応したjsの処理が呼ばれる模様
 */
function updateInstallProgressBar(currentFileNum, maxFileNum, downloadPath, isSubContent, isFinishInstall) {
    $(".installText").text("インストール中...");
    if (kbnCheckTerminalType()) {
        // iosの場合はキャンセルボタンを非表示にする
        $("#cancelDownload").hide();
    } else {
        // プログレスバーを更新
        $('#progressBar').progressbar(
            { "value": currentFileNum },
            { "max": maxFileNum }
        );
    }

    if (currentFileNum >= maxFileNum) {
        if (isFinishInstall) {

            // インストール終了
            $(".installText").text("インストール終了");

            if (mIsVersionUp && mHasNext) {
                // 更に更新がある場合（メイン→サブのような場合）
                versionUpSubContentByFunc(mContentId, mGrade, mForceUpdate);
                mHasNext = false;
            } else {
                // 更新が全て完了した場合
                // ダウンロード完了後フォルダの容量をDBに登録する
                updateContentFolderSizeByFunc(mContentId, mGrade, downloadPath);

                if (mIsVersionUp) {
                    // ローカルのバージョン情報DBを更新する
                    updateVersionUpInfoByFunc(mContentId, mGrade, mForceUpdate);
                }

                // ダイアログを閉じる
                closeDialog();

                if (mIsVersionUp) {
                    // コンテンツインストール完了
                    var callback;
                    var title = "コンテンツの更新";
                    var message = "コンテンツを更新しました。";
                    callback = function () {
                        location.reload();
                    };
                    kbnAlert(title, message, callback, 350);
                }
            }
        }
    }
}
// *** 年度更新対応 ***

/*
 * =================================================================
 * ROMの読み込み
 * =================================================================
 */

/**
 * ROMを読み込んだ際の処理
 */
function pfRomLoading(content_id, grade, deleteId)
{

    var obj = objContentAllInfo;
    var addContentFlg = false;
    var installCount = 0;
    var contentCount = 0;

    // ROM取り出し時
    if (deleteId != "")
    {
        $("[id^=contentId_" + deleteId + "_grade_]").remove();

        // 非表示コンテンツを再表示
        $("[id^=contentId_" + deleteId + "]").show();

        return;
    }
        
    // ROMが挿入されていない場合
    if (content_id == "")
    {
        // ROMコンテンツを削除
        $(".romContentArea").remove();
        // ROM内容更新を削除
        $("[id$=_rom_update]").remove();
        // 非表示コンテンツを再表示
        $("[id^=contentId_]").show();

        // 1コンテンツの高さを元に戻す
        $(".contentsImgArea").css("min-height", kbnGetMagnification(208));

        return;
    }

    // すでにROMからコンテンツが追加されている場合処理を行わない
    if ($("#contentId_" + content_id + "_grade_" + grade + "_rom").size() != 0)
    {
        return;
    }

    // インストール済みコンテンツの判定
    for (count = 1; count <= 6; count++)
    {
        // 学年のインストールされているコンテンツ数を設定
        if (arrRomDisplay["contentId_" + content_id + "_grade_" + count] == 1)
        {
            installCount++;
        }
        // 学年の全コンテンツ数を設定
        if (arrRomDisplay["contentId_" + content_id + "_grade_" + count] != null)
        {
            contentCount++;
        }
    }

    // 学年ごとにコンテンツ画像、インストール状況を取得
    var res = getContentInstallationSituationByFunc(content_id, grade);

    var objContent = JSON.parse(res);

    if (commonUsePlaceType == USE_PLACE_TYPE.HOME_MODE &&
        objContent[0].menu_display_type == MENU_DISPLAY_TYPE.TEACHER_MODE) {
        // 家庭で使う場合、教師用しか表示しないコンテンツは読み飛ばす
        return;
    }

    if (installCount == contentCount)
    {
        // すべてインストール済み
    }
    else if (installCount >= 1)
    {
        // インストールしていない学年がある
        addContentFlg = true;
    }
    else if(installCount == 0)
    {
        // 未インストール
        // 未認証コンテンツリストから削除する
        // クロス利用の標準版かどうかチェック
        if (startupMode == PF_STARTUP_MODE.INSTALL_MODE && isCrossUseNormalByFunc(content_id, grade)) {
            // クロス利用の標準版の場合、未認証コンテンツエリアから非表示にしない
            addContentFlg = true;
        } else {
            $("#contentId_" + content_id + "_grade_0_web").hide();
            addContentFlg = true;
        }
    }

    // オンライン認証済の場合、ROMを表示しない
    if (!isNullOrEmpty(objContent[0].web_startup_path)) {
        if (objContent[0].web_startup_path == objContent[0].startup_path) {
            return;
        }
    }
    // 分割イントール区分を取得
    var splitInstallType = getSplitInstallTypeByFunc(content_id);

    if (commonUsePlaceType == USE_PLACE_TYPE.HOME_MODE ||
        commonModeType == OPERATION_MODE.TEACHER_MODE) {
        // 家庭使用または、教師モードの場合

        // 認証コンテンツに追加
        if (addContentFlg || updateContent.indexOf(content_id) != -1 || splitInstallType == SPLIT_INSTALL_TYPE.INDIVIDUAL) {
            $(".contentsImgArea").css("min-height", kbnGetMagnification(224));

            var romImg = objContent[0].rom_image_path.replace(".png", "_0.png");

            // 標準版の場合、標準版用ROM画像に変更
            if (isCrossUseNormalByFunc(content_id, grade)) {
                romImg = romImg.replace("_0.png", "-hyojun_0.png");
            }

            var html = "<div class='romContentArea' style='float: left;width:" + kbnGetMagnification(272) + ";height: " + kbnGetMagnification(224) + ";margin-top: " + kbnGetMagnification(32) + ";margin-right:" + kbnGetMagnification(16) + ";'>";
            html += "<div id='contentId_" + content_id + "_grade_" + grade + "_rom" + "' class='unauthenticationArea touchHandler'>";
            html += "<img id='" + content_id + "_romImg' class='romImg' src='../../" + romImg + "' style='width:100%;' />";

            // アップデートが必要な場合「内容更新」ボタンを表示
            if (updateContent.indexOf(content_id) != -1) {
                html = "";
                html = "<div class='romContentArea' style='vertical-align: " + kbnGetMagnification(-17) + ";display: inline-block;width:" + kbnGetMagnification(272) + ";height: " + kbnGetMagnification(266) + ";margin-top: " + kbnGetMagnification(32) + ";margin-right:" + kbnGetMagnification(8) + ";'>";
                html += "<div id='contentId_" + content_id + "_grade_" + grade + "_rom" + "' class='unauthenticationArea touchHandler'>";
                html += "<img id='" + content_id + "_romImg' class='romImg' src='../../" + romImg + "' style='width:100%;' />";
                html += "<div id='contentId_" + content_id + "_grade_" + grade + "_rom_update' class='updateContent touchHandler' style='width: " + kbnGetMagnification(104) + ";height: " + kbnGetMagnification(40) + ";'>"
                     + "<img src='../img/common/btn_add-semester.svg'/>"
                     + "</div>";
            }
            //if (objContent[0].install_flg == 1 && updateContent.indexOf(content_id) == -1) {
            //    // 内容追加・削除ボタンを表示
            //    html = "";
            //    html = "<div class='romContentArea' style='vertical-align: " + kbnGetMagnification(-17) + ";display: inline-block;width:" + kbnGetMagnification(272) + ";height: " + kbnGetMagnification(266) + ";margin-top: " + kbnGetMagnification(32) + ";margin-right:" + kbnGetMagnification(8) + ";'>";
            //    html += "<div id='contentId_" + content_id + "_grade_" + grade + "_rom" + "' class='touchHandler'>";
            //    html += "<img id='" + content_id + "_romImg' class='romImg' src='../../" + romImg + "' style='width:100%;' />";
            //    //html += "<div id='contentId_" + content_id + "_grade_" + grade + "_rom_addgrade' class='addGrade touchHandler' style='width: " + kbnGetMagnification(CONTENT_ADDBUTTON_WIDTH) + ";height: " + kbnGetMagnification(CONTENT_ADDBUTTON_HEIGHT) + ";float: right;'>"
            //    //     + "<img src='../img/common/btn_add-contents.svg' class='tapableImage'/>"
            //    //     + "</div>";
            //    //$("#contentId_" + content_id + "_grade_" + grade + "_rom_addgrade");
            //}

            html += "</div>";

            $("#authentication_1").prepend(html);
        }
    }

    // =======ROM画像のタップイベント============

    //マウスダウン
    $(".romImg").mousedown(function (evt) {
        var id = evt.currentTarget.id;
        romImgTapEvent(id, true);
    });

    //マウスアップ
    $(".romImg").mouseup(function (evt) {
        var id = evt.currentTarget.id;
        romImgTapEvent(id, false);
    });

    //マウスアウト
    $(".romImg").mouseout(function (evt) {
        var id = evt.currentTarget.id;
        romImgTapEvent(id, false);
    });

    // =======ROM画像の後期の追加タップイベント============
    if (updateContent.indexOf(content_id) != -1) {
        //マウスダウン
        var romUpdate = $("#contentId_" + content_id + "_grade_" + grade + "_rom_update");
        romUpdate.mousedown(function (evt) {
            var contentImage = romUpdate.find("img").attr("src");
            contentImage = contentImage.replace(".png", "_tap.png");
            romUpdate.find("img").attr("src", contentImage);
        });

        //マウスアップ
        romUpdate.mouseup(function (evt) {
            var contentImage = romUpdate.find("img").attr("src");
            contentImage = contentImage.replace("_tap.png", ".png");
            romUpdate.find("img").attr("src", contentImage);
        });

        //マウスアウト
        romUpdate.mouseout(function (evt) {
            var contentImage = romUpdate.find("img").attr("src");
            contentImage = contentImage.replace("_tap.png", ".png");
            romUpdate.find("img").attr("src", contentImage);
        });
    }

    // =======ROM画像の学年追加のタップイベント============
    if (objContent[0].install_flg == 1 && updateContent.indexOf(content_id) == -1) {
        //マウスダウン
        var romaddGrade = $("#contentId_" + content_id + "_grade_" + grade + "_rom_addgrade");
        romaddGrade.mousedown(function (evt) {
            var contentImage = romaddGrade.find("img").attr("src");
            contentImage = contentImage.replace(".png", "_tap.png");
            romaddGrade.find("img").attr("src", contentImage);
        });

        //マウスアップ
        romaddGrade.mouseup(function (evt) {
            var contentImage = romaddGrade.find("img").attr("src");
            contentImage = contentImage.replace("_tap.png", ".png");
            romaddGrade.find("img").attr("src", contentImage);
        });

        //マウスアウト
        romaddGrade.mouseout(function (evt) {
            var contentImage = romaddGrade.find("img").attr("src");
            contentImage = contentImage.replace("_tap.png", ".png");
            romaddGrade.find("img").attr("src", contentImage);
        });
    }

    // 既にインストールされている場合にROMイメージを非表示にする
    if (objContent[0].install_flg == 1 && updateContent.indexOf(content_id) == -1 && splitInstallType != SPLIT_INSTALL_TYPE.INDIVIDUAL) {
        $("#contentId_" + content_id + "_grade_" + grade + "_rom_update").hide();
        $("#contentId_" + content_id + "_grade_" + grade + "_rom").hide();
        $("#contentId_" + content_id + "_grade_" + grade + "_rom").parent().hide();
    }

}

/*
 * =================================================================
 * ダイアログ
 * =================================================================
 */

/**
 * 学年入力ダイアログを生成する
 */
function InputGradeClassNumberDialog(id, externalType, expiredFlg) {

    gradeInputContentId = id;

    var skipGradeInput = false;
    if (runType == RUN_TYPE.RUN_ROM && is1DiscId1GradeContent(gradeInputContentId)) {
        // ROM起動で、1ディスクIDが1学年のコンテンツは直接コンテンツを起動する
        skipGradeInput = true;
    } else if (gradeInputContentId == CONTENT_ID.DIGI_TOKU) {
        // デジ徳用の特殊処理
        if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
            // PFをROM起動の場合
            skipGradeInput = true;
        } else if (runType == RUN_TYPE.RUN_ROM && mCommonInfo.history_type == HISTORY_TYPE.NON_SAVE_MODE) {
            // インストール済みPFからROM起動する、かつ、学習履歴がOffの場合
            skipGradeInput = true;
        }
    }

    if (skipGradeInput) {
        // XML上の学年を取得
        var xmlGrade = getContentsXmlGradeByFunc(gradeInputContentId);
        // コンテンツ種別を取得
        var cType = getContentTypeByFunc(gradeInputContentId);
        var contentType = JSON.parse(cType)[0].content_type;
        // ROMコンテンツを起動
        openRomContent(gradeInputContentId, xmlGrade, "0", "0", contentType);
        return;
    }

    // 学年が1つのみインストールされている場合はダイアログを省略する
    var contentInfo = undefined;
    var jsonStr = checkInstalledContentCountByFunc(gradeInputContentId);
    if (jsonStr) {
        contentInfo = JSON.parse(jsonStr);
    }

    if (contentInfo != undefined &&
        contentInfo.length == 1 &&
        startupMode == PF_STARTUP_MODE.INSTALL_MODE &&
        installConfirmType != INSTALL_TYPE.ROM_INSTALL
        // *** 年度更新対応 ***
        // 使用期限切れでない場合
        && expiredFlg != true) {
        // *** 年度更新対応 ***
        // デジ社、デジ理科、デジ保、デジ家庭の場合(学習履歴を使うコンテンツはここに入れない）
        if (gradeInputContentId == CONTENT_ID.DIGI_SHAKA ||
            gradeInputContentId == CONTENT_ID.DIGI_RIKA ||
            gradeInputContentId == CONTENT_ID.DIGI_HO ||
            gradeInputContentId == CONTENT_ID.DIGI_KATEI) {
            // 1学年のみインストール済みの場合は直接コンテンツを起動する(ROMコンテンツ起動の場合を除く)
            openContent(gradeInputContentId, contentInfo[0].grade, 1, 1);
            return;
        }
    }

    if (typeof (externalType) != "undefined") {
        contentExternalType = externalType;
    }
    
    inputNumberClear();

    // ダイアログの背景を作成
    var dialog = createBackgroundDialog();

    var gradeFlg = true;
    var classFlg = false;
    var numFlg = false;

    // 動的にエリアの幅を変える必要がある
    var inputAreaWidth = 380;
    var leftPoint = 25;

    //if (!is1DiscId1GradeContent(gradeInputContentId)) {
    // デジ社、デジ理科、デジ保、デジ家庭は組しか入力しない
    if (!(gradeInputContentId == CONTENT_ID.DIGI_SHAKA ||
          gradeInputContentId == CONTENT_ID.DIGI_RIKA ||
          gradeInputContentId == CONTENT_ID.DIGI_HO ||
          gradeInputContentId == CONTENT_ID.DIGI_KATEI)) {
        // 専科の場合は年のみ表示
        if (commonTeacherTerminalType != TEACHER_TERMINAL_TYPE.SPECIALIZED_COURSE && expiredFlg != true) {
            // 「くみ」表示
            if (HISTORY_TYPE.SAVE_MODE == commonHistoryType) {
                classFlg = true;
                inputAreaWidth = 180;
                leftPoint = 25;
                //「ばん」表示
                if (OPERATION_MODE.CHILDREN_MODE == commonModeType) {
                    numFlg = true;
                    inputAreaWidth = 130;
                    leftPoint = 18;
                }
            }
        }
    }

    // 画面サイズ
    var dw = getTerminalWidth();
    var dh = getTerminalHeight();

    //ダイアログ表示領域設定
    var dialogBody = $(document.createElement('div'));
    dialogBody.attr('id', 'dialog-main');
    dialogBody.css('position', 'fixed');
    dialogBody.css('top', ((dh - 588* magnification) / 2) + "px");
    dialogBody.css('left', ((dw - 952 * magnification) / 2) + "px");
    dialogBody.css('border-radius', '10px');
    dialogBody.css('z-index', 31);
    dialogBody.css('opacity', 1);
    dialogBody.css('background-color', '#fff');

    // ===============入力領域のstyle===============
    var inputAreaStyle = "float:left ;height: " + 130 * magnification + "px; border: solid  1px #AEADAD;" +
        "background-color:#E5E2E2 ; font-size: " + 72 * magnification + "px;border-radius:" + 16 * magnification
        + "px; line-height: "+ 130 * magnification + "px;";

    var inputTextStyle = "float: left;margin-top: " +86 * magnification +"px;font-weight: bold; font-size: " + 24 * magnification + "px;margin-left:"+ 8 * magnification + "px;margin-right: " + 16 * magnification +"px;";

    var body = "<div style='height: " + 558 * magnification + "px;'>";

    // div
    var spanStyle = " style='padding-left: " + 10 * magnification + "px;'";
    var message = "<span>はじめに</span><span" + spanStyle + ">ねん</span>";
    if (classFlg) {
        message = message + "<span>、くみ</span>";

        // 指導者モードの場合、「ばん」入力項目を非表示にする
        if (numFlg) {
            message = message + "<span>、ばんごう</span>";
        }
    }
    message = message + "<span>を</span><span" + spanStyle + ">いれてね</span>";

    body += "<div class='infoText' style='margin-left: " + 24 * magnification + "px;margin-top: " + 28 * magnification + "px;height:" + 24 * magnification + " px;'>";
    body += "<p style='font-size: " + 24 * magnification + "px;color: #EB8219;font-weight: bold;'>" + message + "</p>";
    body += "</div>";

    // 何もない領域
    body += "<div style='margin-left: " + 32 * magnification + "px;margin-top:"+ 24 * magnification +"px;border-top: 1px solid #302519'>";
    body += "</div>";

    // インストールされていない学年を表示する領域
    body += "<div style='height: " + 88 * magnification + "px;'>";
    body += "<div style='font-size: " + 28 * magnification + "px;padding-top:" + 30 * magnification + "px;text-align:center;'>";
    body += "<span id='unGradeInstallTxt'>その学年はインストールされていません</span>";
    body += "</div>";
    body += "</div>";

    // ===========入力エリア始まり==============

    body += "<div style='width: 100%;height: " + 130 * magnification + "px;position: relative;'>";
    body += "<div style='height: 130px;float: left;position: relative;left: " + leftPoint + "%;text-align: center'>";
    body += "<div id='gradeDisplayArea' class='fontNumeric addgradeDisplayArea' style='" + inputAreaStyle + "width: " + inputAreaWidth * magnification + "px;'></div>";
    body += "<div class='gradeInputArea' style='" + inputTextStyle + "'>ねん</div>";
    // 学習履歴ありの場合「くみ」の表示
    if (classFlg) {
        body += "<div id='classDisplayArea' class='fontNumeric' style='" + inputAreaStyle + "width: " + inputAreaWidth * magnification + "px;'></div>";
        body += "<div class='classInputArea' style='" + inputTextStyle + "'>くみ</div>";

        // 指導者モードの場合、「ばん」入力項目を非表示にする
        if (numFlg) {
            body += "<div id='numberDisplayArea' class='fontNumeric' style='" + inputAreaStyle + "width: " + 180 * magnification + "px;'></div>";
            body += "<div class='numberInputArea' style='" + inputTextStyle + "'>ばん</div>";
        }
    }
    body += "</div>";
    body += "</div>";// 入力エリア終わり

    // ==============数字エリア==============
    
    // 数字ボタンの表示領域生成
    body += "<div style='padding-bottom: 28px;;clear: both;margin-top: " + 32 * magnification + "px;text-align:center;'>";

    // 数字ボタンの生成
    for (counter = 1; counter < 10 ; counter++) {
        changeTappingNumber(counter);

        var inputBtnDisabled = "";

        // 数値ボタンの表示
        if (counter >= 7) {
            inputBtnDisabled = "opacity: " + mOpacityValue + ";";
        }

        body += "<img id='number_" + counter + "' class='inputNumberBtn touchHandler' src='../img/dialog/btn_key-" + counter + ".svg' style='"+ inputBtnDisabled +" width:" + 64 * magnification + "px;height: "+ 65 * magnification +"px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";

        // 数字5で改行
        if (counter == 5) {
            body += "<div style='float:right ; width:" + 64 * magnification + "px;height:" + 65 * magnification + "px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'></div>";
            body += "<br />";
        }
    }
    changeTappingNumber(0);
    body += "<img id='number_0' class='inputNumberBtn touchHandler' src='../img/dialog/btn_key-0.svg' style='opacity: 0.4;width:" + 64 * magnification + "px;height: "+ 65 * magnification +"px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";

    // deleteボタン
    body += "<img id='deleteBtn' class='touchHandler' src='../img/dialog/btn_key-delete.svg' style='width:" + 64 * magnification + "px;height: "+65 * magnification+"px;margin-right:" + 16 * magnification + "px;margin-bottom: " + 8 * magnification + "px;'>";
    body += "</div>"; // 数字エリア終わり

    // ==============下の領域================
    body += "<div style='width: " + 952 * magnification + "px;height: " + 80 * magnification + "px;'>";
    body += "<div id='startContent' class='" + BUTTON_TYPE.MAIN + " touchHandler' style='float:right;margin-right: " + 40 * magnification + "px;margin-top: " + 0 * magnification + "px;'>";
    body += "はじめる";
    body += "</div>";
    body += "<div id='dialogClose' class='returnBtn " + BUTTON_TYPE.SUB + " touchHandler' style='float:right;margin-right: " + 16 * magnification + "px;margin-top:" + 0 * magnification + "px;'>";
    body += "<div style=''>もどる</div>";
    body += "</div>";
    
    // 全div終了
    body += "</div>";

    $(dialogBody).append(body);

    $('body').append(dialog);
    $('body').append(dialogBody);

    setOpacityStyle(mOpacityValue);

    // エラーメッセージを非表示に
    $("#unGradeInstallTxt").hide();

    $("#gradeDisplayArea").css("border", "solid  2px #EB8219");

    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.MAIN, 256, "startContent");
    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.SUB, 176, "dialogClose");

}

// 始めるボタン押下時
$(document).on("mousedown", "#startContent", function () {

    $(this).removeClass("mainBtnStyle").addClass("tapBtnStyle");
});

$(document).on("mouseup", "#startContent", function () {

    $(this).removeClass("tapBtnStyle").addClass("mainBtnStyle");
});

$(document).on("mouseout", "#startContent", function () {

    $(this).removeClass("tapBtnStyle").addClass("mainBtnStyle");
});

// 戻るボタン押下時
$(document).on("mousedown", ".returnBtn", function () {

    $(this).removeClass("subBtnStyle").addClass("tapBtnStyle");
});

$(document).on("mouseup", ".returnBtn", function () {

    $(this).removeClass("tapBtnStyle").addClass("subBtnStyle");
});

$(document).on("mouseout", ".returnBtn", function () {

    $(this).removeClass("tapBtnStyle").addClass("subBtnStyle");
});



// 教科書・教材設定ダイアログボタン切り替え

/*
 * キャンセルボタン
 */
$(document).on("mousedown", ".cancelImg", function () {

    $(this).removeClass("subBtnStyle").addClass("subBtnTapStyle");
});

$(document).on("mouseup", ".cancelImg", function () {

    $(this).removeClass("subBtnTapStyle").addClass("subBtnStyle");
});

$(document).on("mouseout", ".cancelImg", function () {

    $(this).removeClass("subBtnTapStyle").addClass("subBtnStyle");
});

/**
 * ダウンロードボタン
 */
$(document).on("mousedown", ".downloadImg", function () {

    $(this).removeClass("mainBtnStyle").addClass("mainBtnTapStyle");
});

$(document).on("mouseup", ".downloadImg", function () {

    $(this).removeClass("mainBtnTapStyle").addClass("mainBtnStyle");
});

$(document).on("mouseout", ".downloadImg", function () {

    $(this).removeClass("mainBtnTapStyle").addClass("mainBtnStyle");
});


/**
 * 準拠設定、教材設定のダイアログ
 */
function openStandardMaterialDialog(installGrade, installType, getRunType, checkGrade, isCopy, isReturnBack, romInstallParameterList, romStandardId, isCrossUse, isRomOnline, isSpecialAuthCode) {

    //alert("openStandardMaterialDialog:" + installGrade + " installType:" + installType + " getRunType:" + getRunType + " checkGrade:" + checkGrade + " isCopy:" + isCopy);

    installContentGrade = installGrade;
    installConfirmType = installType;
    runType = getRunType;
    checkAddGrade = checkGrade;
    mIsCopy = isCopy;
    mIsRomOnline = isRomOnline;
    mIsSpecialAuthCode = isSpecialAuthCode;
    grade = installGrade; // 色々な処理でグローバルに使っているのでココで更新しておく
    var romInstallStandardId = romStandardId;
    mRomInstallParameterList = romInstallParameterList;

    // コンテンツの準拠・教材設定有無フラグを見る
    var res = getContentInstallInfoByFunc(contentId);

    var obj = JSON.parse(res);

    var updateDbFlg = false;
    updateStandardOnly = false;

    for (var val in obj) {
        // 準拠・教材の設定がない場合選択を行わず、DBに登録する
        if (obj[val].material_setting_flg == 0 && obj[val].standard_setting_flg == 0) {
        
            // PFがROM起動の場合
            if (startupMode == PF_STARTUP_MODE.ROM_MODE) {

                // PFで保持
                var res = updateRomUnSettingStandardMaterialByFunc(contentId, installGrade);

                if (mIsCopy) {
                    closeDialog();
                    // コピーして使うの場合
                    pfCopyFolder();
                    return;
                }
                
                updateDbFlg = true;
                break;

            // PFがインストール起動の場合
            } else {
                //// 認証されていない場合は処理しない
                //if (obj[val].authentication_flg == 0 && confirmType == INSTALL_TYPE.WEB_INSTALL) {
                //    continue;
                //}

                // DB登録
                var res = updateUnSettingStandardMaterialByFunc(contentId, obj[val].grade, confirmType);
                
                updateDbFlg = true;
            }
        } else if (obj[val].standard_setting_flg == 1 && obj[val].material_setting_flg == 0) {
            // 準拠のみの設定
            updateStandardOnly = true;
        }
    }
    // 準拠・教材の設定がない場合、ダイアログを閉じコンテンツをインストールする(オンラインモードの場合はスルー）
    //if (updateDbFlg) {
    if (updateDbFlg && !mIsOnlineMode) {
        // ダイアログを閉じる
        closeDialog();

        var splitInstallType = getSplitInstallTypeByFunc(contentId);

        if (installConfirmType == INSTALL_TYPE.WEB_INSTALL) {
            //// webコンテンツをインストールする
            //contentInstall(installContentGrade);
            // 分割インストール
            switch (splitInstallType) {
                case SPLIT_INSTALL_TYPE.NONE: // 未対応
                    contentInstall(installContentGrade);
                    break;
                case SPLIT_INSTALL_TYPE.MATERIAL_OR_STANDARD: // 準拠、教材単位
                    // 設定上あり得ないので何も行わない
                    break;
                case SPLIT_INSTALL_TYPE.INDIVIDUAL: // 個別
                    // インストール設定ダイアログを開く
                    // 戻った際に当画面を復元する情報も渡す
                    var returnBackParameter = {};
                    returnBackParameter.screenType = SCREEN_TYPE.CONTENT_DETAIL;
                    returnBackParameter.grade = installContentGrade;
                    returnBackParameter.installType = installConfirmType;
                    returnBackParameter.runType = runType;
                    returnBackParameter.checkAddGrade = checkAddGrade;
                    returnBackParameter.isCopy = false;
                    openInstallSettingDialog(contentId, installContentGrade, undefined, undefined, installConfirmType, returnBackParameter, RUN_TYPE.RUN_WEB);
                    break;
                default:
                    alert("分割インストール区分が取得できませんでした。");
                    break;
            }

        } else {
            // 共通ファンクション
            var nextFunc = function (pRunType, pStartupMode) {
                if (pRunType == RUN_TYPE.RUN_ROM) {
                    // ROMから実行の場合は何もしない
                    return;
                }
                // 分割インストール
                switch (splitInstallType) {
                    case SPLIT_INSTALL_TYPE.NONE: // 未対応
                        // PFがROM起動されている場合のみ
                        if (pStartupMode == PF_STARTUP_MODE.ROM_MODE) {
                            // ROMからインストールの場合
                            // ROM起動の場合レジストリチェック
                            var res = checkInstallRegistry();
                            if (res) {
                                closeDialog();
                                return;
                            }
                        }
                        // romコンテンツのインストール
                        installRomContentByFunc(contentId, installGrade);
                        break;
                    case SPLIT_INSTALL_TYPE.MATERIAL_OR_STANDARD: // 準拠、教材単位
                        // 設定上あり得ないので何も行わない
                        break;
                    case SPLIT_INSTALL_TYPE.INDIVIDUAL: // 個別
                        // インストール設定ダイアログを開く
                        // 戻った際に当画面を復元する情報も渡す
                        var returnBackParameter = {};
                        returnBackParameter.screenType = SCREEN_TYPE.CONTENT_DETAIL;
                        returnBackParameter.grade = installContentGrade;
                        returnBackParameter.installType = installConfirmType;
                        returnBackParameter.runType = runType;
                        returnBackParameter.checkAddGrade = checkAddGrade;
                        returnBackParameter.isCopy = false;
                        openInstallSettingDialog(contentId, installContentGrade, undefined, undefined, installConfirmType, returnBackParameter, RUN_TYPE.RUN_WEB);
                        break;
                    default:
                        alert("分割インストール区分が取得できませんでした。");
                        break;
                }
            };
            if (runType == RUN_TYPE.RUN_ROM) {
                // ROMから実行の場合インストールしないで起動
                // コンテンツの設定値を取得する
                var gradeInput = getGradeInputFlgByFunc(contentId);
                
                var cType = getContentTypeByFunc(contentId);
                
                var contentType = JSON.parse(cType)[0].content_type;

                // 学年入力フラグを参照
                if (JSON.parse(gradeInput)[0].grade_input_flg == 1) {
                    // 学年入力あり
                    InputGradeClassNumberDialog(contentId);
                } else {
                    // 学年入力なし
                    openRomContent(contentId, "0", "0", "0", contentType);
                }
                if (splitInstallType != SPLIT_INSTALL_TYPE.INDIVIDUAL) {
                    // 個別分割インストールに対応していない場合は抜ける
                    return;
                }
            } else {
                // ROMからインストールする場合
                // PFがROM起動されている場合のみ
                if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
                    // 分割インストール区分による処理分け

                    //// ROM起動の場合レジストリチェック
                    //var res = checkInstallRegistry();
                    //if (res) {
                    //    closeDialog();
                    //    return;
                    //}
                }
            }
            //// romコンテンツのインストール
            //installRomContentByFunc(contentId, installGrade);
            // 分割インストール区分による処理分け
            nextFunc(runType, startupMode);
        }

        return;
    }

    // コンテンツの設定値を取得する
    var resJson = getContentUserSettingByFunc(contentId);

    objContentSetting = JSON.parse(resJson);

    // 準拠情報を取得
    var resJson = getStandardInfoByFunc(contentId, DEMO_FLG.DEMO_NONE_DISPLAY);

    var objStandard = JSON.parse(resJson);

    // 教材、準拠
    var objSMInfo = JSON.parse(resJson);

    // ダイアログの背景を作成
    var dialog = createBackgroundDialog();

    var dialogBodyWidth = 952 * magnification;
    var dialogBodyHeight = 588 * magnification;

    // 画面サイズ
    var dw = getTerminalWidth();
    var dh = getTerminalHeight();

    //ダイアログ表示領域を作成
    var dialogBody = $(document.createElement('div'));
    dialogBody.attr('id', 'dialog-main');
    dialogBody.css('position', 'fixed');
    dialogBody.css('top', ((dh - dialogBodyHeight) / 2) + "px");
    dialogBody.css('left', ((dw - dialogBodyWidth) / 2) + "px");
    dialogBody.css('border-radius', 10 * magnification + 'px');
    dialogBody.css('z-index', 31);
    dialogBody.css('opacity', 1);
    dialogBody.css('background-color', '#fff');

    var body = "<div style='width:" + dialogBodyWidth + "px; height:" + dialogBodyHeight + "px;'>";
    // ==========テキスト最上位=========
    body += "<div style='height:"+ 24 * magnification + "px;'></div>";
    body += "<div class='settingDialogHeaderTxt' style='padding-top: " + 24 * magnification + " px;padding-bottom:" + 16 * magnification + "px;margin-left:" + 40 * magnification + "px;font-size:" + kbnGetMagnification(24) + ";'>"
    body += "教科書・教材の設定"
    body += "</div>";
    body += "<div style='height:" + 16 * magnification + "px;'></div>";
    // ==========テキスト最上位========

    body += "<div style='margin-left: " + kbnGetMagnification(40) + ";font-size :"+ kbnGetMagnification(18) +"'>";
    body += "各学年で使用する教材の種類、教科書を指定してください。";
    body += "</div>";
    body += "<div style='height:" + 24 * magnification + "px;'></div>";

    // =========テキスト==========

    //===========中央部=============
    body += "<div style='height:" + 56 * magnification + "px;'></div>";

    body += "<div style='border-bottom:1px dotted;width: " + 744 * magnification + "px;margin:auto;'>";

    // ================教科書リスト作成===========
    body += "<div style='display:inline-block;font-size: " + 15 * magnification + "px;width: " + kbnGetMagnification(127) + ";'>教科書：</div>";
    
    // 教科書リスト処理
    body += "<div style='display:inline-block;width: " + 280 * magnification + "px;padding-bottom: " + 32 * magnification + "px;'><select style='width: " + kbnGetMagnification(280) + ";height :" + kbnGetMagnification(40) + ";font-size: " + kbnGetMagnification(18) + "; padding-left: " + kbnGetMagnification(8) + ";' class='standardChange'>";

    // クロス利用で分岐
    if (isCrossUse) {
        // クロス利用の場合、標準版固定
        body += "<option selected value='" + HYOJUN_STANDARD_ID + "'>" + HYOJUN_STANDARD_NAME + "</option>";
    } else {
        body += "<option value='unSelect'>選択してください</option>";
        // リストに準拠の設定を行う
        for (var val in objStandard) {
            // 設定値との比較
            try {
                if ((startupMode == PF_STARTUP_MODE.INSTALL_MODE && objContentSetting[0].standard_id == objStandard[val].standard_id)
                    || (startupMode == PF_STARTUP_MODE.ROM_MODE && romInstallStandardId == objStandard[val].standard_id)) {
                    body += "<option selected value='" + objStandard[val].standard_id + "'>" + objStandard[val].standard_name + "</option>";
                } else {
                    body += "<option value='" + objStandard[val].standard_id + "'>" + objStandard[val].standard_name + "</option>";
                }
            } catch (e) {
                body += "<option value='" + objStandard[val].standard_id + "'>" + objStandard[val].standard_name + "</option>";
            }
        }
    }
    body += "</select></div>";
    body += "</div>";
    // =============教科書リスト作成終了=============

    // =============教材リスト作成==============
    body += "<div style='width: " + 744 * magnification + "px;margin:auto;padding-top: " + 32 * magnification + "px;min-height: " + kbnGetMagnification(186) +"'>";

    body += "<div class='materialArea dialogMaterialArea'>";

    // 教材リスト処理
    var counter = 1;
    for (var val in objContentSetting) {
        if (counter == 1) {
            body += "<div style='display:inline-block;font-size: " + kbnGetMagnification(15) + ";width: " + kbnGetMagnification(72) + ";'>教材：</div>";
        } else if (counter % 2 != 0) {
            body += "<div style='display:inline-block;font-size: " + kbnGetMagnification(15) + ";width: " + kbnGetMagnification(72) + ";'>　</div>";
        
        }
        body += "<div class='dialogMaterialAreaTxt' style=';display:inline-block;font-size :" + 15 * magnification + "px; '>";
        body += "<div style='padding-left:" + kbnGetMagnification(23) + ";margin-right: " + kbnGetMagnification(8) + "; display: inline-block;padding-bottom: " + kbnGetMagnification(32) + ";'>";
        body += objContentSetting[val].grade + "年";
        body += "</div>";
        body += "<div style='display: inline-block;'>";
        body += "<select id='grade_" + objContentSetting[val].grade + "' style='width: "+ kbnGetMagnification(280) +";height :"+ kbnGetMagnification(40) +";font-size:"+kbnGetMagnification(18)+ "; padding-left: " + kbnGetMagnification(8) + ";'>";
        body += "<option value='0'></option>";
        body += "</select>";
        body += "</div>";
        body += "</div>";
        counter++;
    }
   
    body += "</div>";
    
    body += "</div>";

    // =======画面下部のボタン領域=========
    body += "<div style='margin-top:" + kbnGetMagnification(8) + ";width: 100%;padding-top:" + kbnGetMagnification(16) + "'>";

    //　決定ボタン
    body += "<div id='downloadImg' class='downloadImg arrorButton touchHandler " + BUTTON_TYPE.MAIN + "' style='float: right;margin-right: " + kbnGetMagnification(40) + "'>";

    if (runType == RUN_TYPE.RUN_ROM) {
        // ROMの場合
        body += "決定";
    } else {
        if (isCopy) {
            // コピーの場合
            body += "コピー開始";
        } else {
            // コピー以外の場合
            var splitInstallType = getSplitInstallTypeByFunc(contentId);
            if (splitInstallType == SPLIT_INSTALL_TYPE.INDIVIDUAL) {
                // 分割インストール(個別)の場合
                body += "<span style='font-size:" + kbnGetMagnification(18) + ";'>";
                body += "次へ";
                body += "</span>";
                body += "<img src='../img/common/icon_arrow-next_white.svg' style='width:" + kbnGetMagnification(14) + ";'>";
            } else {
                body += "インストール開始";
            }
        }
    }
    body += "</div>";

    // キャンセルボタン
    body += "<div id='cancelmateiralBtn' class='cancelImg touchHandler " + BUTTON_TYPE.SUB + "' style='float: right;margin-right: " + kbnGetMagnification(16) + ";'>";
    body += "キャンセル";
    body += "</div>";
    body += "</div>";

    body += "</div>"; // 全体終了
    $(dialogBody).append(body);

    $('body').append(dialog);
    $('body').append(dialogBody);

    // 学年追加時準拠リストの設定されているもの以外を削除する
    if (!isReturnBack) {
        if (checkAddGrade != 0) {
            for (var val in objContentSetting) {
                if (objContentSetting[val].standard_id == "") {
                    continue;
                }
                $(".standardChange").children("option:not([value='" + objContentSetting[val].standard_id + "'])").remove();
                break;
            }
        }
    }

    // 教材のリストを削除する
    if (updateStandardOnly) {
        $(".materialArea").remove();
    } else {
        // 教材の初期設定反映
        changeStandardList(isCrossUse);
    }

    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.MAIN, 256, "downloadImg");
    // 汎用ボタンのスタイルを適用
    setCommonButtonStyle(BUTTON_TYPE.SUB, 176, "cancelmateiralBtn");
    setCommonButtonStyle(BUTTON_TYPE.SUB, 176, "cancelCrossBtn");
}

/*
 * =================================================================
 * 入力動作
 * =================================================================
 */

/**
 * 選択した数値を表示、格納
 */
$(document).on("click", ".inputNumberBtn", function () {

    // 押下したボタンのIDを取得
    var numberId = $(this).attr('id');

    var number = numberId.split("_");

    var spanStyle = " style='padding-left: " + 10 * magnification + "px;'";

    var onlyFlg = false;
    // 年のみ
    if (gradeInputContentId == CONTENT_ID.DIGI_SHAKA || gradeInputContentId
            == CONTENT_ID.DIGI_RIKA || CONTENT_ID.DIGI_HO == gradeInputContentId) {
        onlyFlg = true;
    }
    setOpacityStyle(mOpacityValue);

    // 各入力表示域に表示する
    if ($("#gradeDisplayArea").text() == "") {
        // 学年の場合
        if (parseInt(number[1]) > 6 || parseInt(number[1]) == 0) {
            playAlertSE();
            kbnAlert("かくにん", "<span>ねんは</span><span" + spanStyle + ">１から６を<span" + spanStyle + ">いれてね。</span>", function () { }, 432);
            return;
        }
        $("#gradeDisplayArea").text(number[1]);
        nowInputGrade += number[1];
        // 入力エリアの枠色変更
        $("#gradeDisplayArea").css("border", "solid  1px #AEADAD");
        $("#classDisplayArea").css("border", "solid  2px #EB8219");

        // ねんの場合ボタンの色変更
        setOpacityStyle(1);

    } else if (($("#classDisplayArea").text() == "" && HISTORY_TYPE.SAVE_MODE == commonHistoryType) && !onlyFlg) {
        setOpacityStyle(1);
        // クラスの場合
        $("#classDisplayArea").text(number[1]);
        nowInputClass += number[1];
        // 入力エリアの枠色変更
        $("#classDisplayArea").css("border", "solid  1px #AEADAD");
        $("#numberDisplayArea").css("border", "solid  2px #EB8219");
    } else if (($("#numberDisplayArea").text() == ""
        && OPERATION_MODE.CHILDREN_MODE == commonModeType && HISTORY_TYPE.SAVE_MODE == commonHistoryType) && !onlyFlg) {
        // 番号の場合
        $("#numberDisplayArea").text(number[1]);
        nowInputNumber += number[1];

        setOpacityStyle(1);

        //　入力エリアの枠色変更
        $("#classDisplayArea").css("border", "solid  1px #AEADAD");
        $("#numberDisplayArea").css("border", "solid  2px #EB8219");

    } else if ($("#numberDisplayArea").text().length == 1 && OPERATION_MODE.CHILDREN_MODE == commonModeType
        && HISTORY_TYPE.SAVE_MODE == commonHistoryType) {

        setOpacityStyle(1);

        $("#numberDisplayArea").text($("#numberDisplayArea").text() + number[1]);
        nowInputNumber += number[1];

        $("#numberDisplayArea").css("border", "solid  2px #EB8219");
    } else {
        setOpacityStyle(1);
    }
});

// 7～0ボタンの色を透過する(ねんがフォーカスされている場合)
function setOpacityStyle (val) {

    // 履歴を保存しない設定の場合
    if (mCommonInfo.history_type == "2") {
        val = mOpacityValue;
    }

    // 透過
    $("#number_7").css("opacity", val.toString());
    $("#number_8").css("opacity", val.toString());
    $("#number_9").css("opacity", val.toString());
    $("#number_0").css("opacity", val.toString());

    if (val == 1) {
        // 活性状態
        $("#number_7").removeAttr("disabled");
        $("#number_7").css("pointer-events", "auto");
        $("#number_8").removeAttr("disabled");
        $("#number_8").css("pointer-events", "auto");
        $("#number_9").removeAttr("disabled");
        $("#number_9").css("pointer-events", "auto");
        $("#number_0").removeAttr("disabled");
        $("#number_0").css("pointer-events", "auto");
    } else {
        // 非活性状態
        $("#number_7").attr("disabled", "disabled");
        $("#number_7").css("pointer-events", "none");
        $("#number_8").attr("disabled", "disabled");
        $("#number_8").css("pointer-events", "none");
        $("#number_9").attr("disabled", "disabled");
        $("#number_9").css("pointer-events", "none");
        $("#number_0").attr("disabled", "disabled");
        $("#number_0").css("pointer-events", "none");
    }

}

/**
 * 選択されている数値を削除する
 */
$(document).on("click", "#deleteBtn", function () {

    var borderFocus = "solid 2px #EB8219 ";
    var borderDefault = "solid 1px #AEADAD";
    if (nowInputNumber.length > 0 && OPERATION_MODE.CHILDREN_MODE == commonModeType)
    {
        // 現在の番号から末尾の文字を削除
        nowInputNumber = nowInputNumber.slice(0, -1);

        setOpacityStyle(1);

        // 入力エリアの枠色変更
        $("#numberDisplayArea").text(nowInputNumber);
        $("#numberDisplayArea").css("border", borderFocus);

    }
    else if (nowInputClass.length > 0)
    {
        // 現在のクラスから末尾の文字を削除
        nowInputClass = nowInputClass.slice(0, -1);
        $("#classDisplayArea").text(nowInputClass);

        setOpacityStyle(1);

        // 入力エリアの枠色変更
        $("#numberDisplayArea").css("border", borderDefault);
        $("#classDisplayArea").css("border", borderFocus);
    }
    else if (nowInputGrade.length > 0)
    {
        // 現在の学年から末尾の文字を削除
        nowInputGrade = nowInputGrade.slice(0, -1);
        $("#gradeDisplayArea").text(nowInputGrade);

        setOpacityStyle(mOpacityValue);

        // 入力エリアの枠色変更
        $("#gradeDisplayArea").css("border", borderFocus);
        $("#classDisplayArea").css("border", borderDefault);
    }

});


/**
 * 準拠リストの変更時の処理
 */
$(document).on("change", ".standardChange", function () {
    // 教材情報をクリア
    clearContentMaterialIdByFunc(contentId, installContentGrade);
    
    // 教材の選択がない場合
    if (!updateStandardOnly) {
        changeStandardList(false);
    }

});

/**
 * 準拠を選択後に教材をセット
 */
function changeStandardList(isCrossUse) {
    // 教材リストをリセットする
    for (var counter = 1; counter <= 6; counter++) {
        $("#grade_" + counter + " > option").remove();
    }

    var standardId = $(".standardChange").val();

    // コンテンツ設定情報を取得
    var resJson = getContentAuthFlgByFunc(contentId);

    var objContentInfo = JSON.parse(resJson);

    // 教材、準拠を取得
    if (isCrossUse == undefined) {
        isCrossUse = false;
    }
    var resJson = getTeachingMaterialByFunc(contentId, standardId, DEMO_FLG.DEMO_NONE_DISPLAY, isCrossUse);

    var checkJson = resJson.replace(/\s+/g, "");

    var xmlGrade = "0";

    if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
        xmlGrade = getContentsXmlGradeByFunc(contentId);
    }

    // 教材が取得できない場合処理を終了する
    if (checkJson == "") {
        return;
    }
    var objMaterial = JSON.parse(resJson);
    var listCounter = 1;
    var unSelectFlg = true;
    var selectedFlg = false;
    var elementCount = 0;
    var checkGrade = 0;

    // 教材のセット
    for (var val in objMaterial) {

        // ループの初めに現在の学年を格納
        if (val == 0) {
            checkGrade = objMaterial[val].grade;
        }

        // 学年が切り替わったとき
        if (checkGrade != objMaterial[val].grade && val != 0) {
            elementCount++;
            checkGrade = objMaterial[val].grade;
            unSelectFlg = true;
        }

        if (objMaterial[val].grade == 0) {
            if (listCounter == 1) {
                // リストに初期値を設定
                for (var counter = 1; counter <= 6; counter++) {
                    $("#grade_" + counter).append("<option value='unSelect'>選択してください</option>");
                }
                listCounter++;
            }
            // 学年が0の場合全学年のリストに表示
            for (var counter = 1; counter <= 6; counter++) {
                $("#grade_" + counter).append("<option selected value='" + objMaterial[val].material_id + "'>" + objMaterial[val].material_name + "</option>");
                selectedFlg = true;

            }
            unSelectFlg = false;

        } else {
            // ROM起動の場合未認証コンテンツを通常通り表示する
            if (confirmType == INSTALL_TYPE.ROM_INSTALL) {
                if (xmlGrade != "0" && xmlGrade != objMaterial[val].grade) {
                    // 学年のリストに表示
                    if (objContentInfo[elementCount].grade == objMaterial[val].grade && objContentInfo[elementCount].authentication_flg == 0) {
                        if (mCurrentAuthGrade != "0" && mCurrentAuthGrade != objMaterial[val].grade) { // 今、認証した学年であれば選択可とする
                            $("#grade_" + objMaterial[val].grade).append("<option value='0'>未承認</option>");
                            continue;
                        }
                    }
                }

            } else {
                // 学年のリストに表示
                if (!mIsOnlineMode) {
                    if (objContentInfo[elementCount].grade == objMaterial[val].grade && objContentInfo[elementCount].authentication_flg == 0) {
                        if (mCurrentAuthGrade != 0 && mCurrentAuthGrade != objMaterial[val].grade) { // 今、認証した学年であれば選択可とする
                            $("#grade_" + objMaterial[val].grade).append("<option value='0'>未承認</option>");
                            continue;
                        }
                    }
                }
            }

            var length = $("#grade_" + objMaterial[val].grade).children("[value='unSelect']").length;

            if (unSelectFlg && length <= 0) {
                $("#grade_" + objMaterial[val].grade).append("<option value='unSelect'>選択してください</option>");
                unSelectFlg = false;
            }

            // 学年のリストに表示
            $("#grade_" + objMaterial[val].grade).append("<option selected value='" + objMaterial[val].material_id + "'>" + objMaterial[val].material_name + "</option>");

        }
    }

    var eleCount = 0;
    var romMaterialId;
    // プルダウンの初期値を設定
    for (var counter = 0; counter < 6; counter++) {
        
        // 対象の学年が存在する場合、処理を継続する
        if ((counter + 1) != objContentSetting[eleCount].grade) {
            continue;
        }

        // ROMインストール時に教材が復元できる場合は、復元する
        if (mRomInstallParameterList != undefined) {
            romMaterialId = _.where(mRomInstallParameterList, {grade: eleCount + 1})[0].materialId; 
        }

        // 教材の初期設定値をセットする
        if (startupMode == PF_STARTUP_MODE.INSTALL_MODE && objContentSetting[eleCount].material_id != "") {

            // インストールする学年以外は初期選択option以外を削除

            /*var length = $("#grade_" + (counter + 1)).children("[value='" + objContentSetting[eleCount].material_id + "']").length;

            if (installContentGrade != (counter + 1) && length != 0) {
               //$("#grade_" + (counter + 1)).children("option:not([value='" + objContentSetting[eleCount].material_id +"'])").remove();
            }*/

            $('#grade_' + (counter + 1)).val(objContentSetting[eleCount].material_id);

        } else if (romMaterialId != ""){
            $('#grade_' + (counter + 1)).val(romMaterialId);
        } else {
            $('#grade_' + (counter + 1)).val('0');
        }
        
        // 選択されていませんを初期選択する
        if ($('#grade_' + (counter + 1)).val() == null) {
            $('#grade_' + (counter + 1)).val('unSelect');
        }

        eleCount++;

    }


}


/*
 * =================================================================
 * コンテンツ起動
 * =================================================================
 */

/**
 * はじめるボタン押下時の処理
 */
$(document).on("click", "#startContent", function () {
    var inputGrade = $("#gradeDisplayArea").text();
    var inputClass = $("#classDisplayArea").text();
    var inputNumber = $("#numberDisplayArea").text();

    // 入力チェック
    var isValid = true;
    if ($("#gradeDisplayArea").length > 0 && inputGrade.length == 0) {
        // 学年が未入力
        isValid = false;
    } else if ($("#classDisplayArea").length > 0 && inputClass.length == 0) {
        // 組が未入力
        isValid = false;
    } else if ($("#numberDisplayArea").length > 0 && inputNumber.length == 0) {
        // 番号が未入力
        isValid = false;
    }

    // 未入力がある場合
    if (!isValid) {
        var callback = function () {
        }
        playAlertSE();
        kbnAlert("たりない　ぶぶんが　あるよ", "もういちど　いれなおそう", callback, 432);
        return;
    }

    // オンラインかオフラインか判定
    if (!mIsOnlineMode) {
        if (isOnlineContent(checkContentId, inputGrade)) {
            mIsOnlineMode = true;
        }
    }

    if (!mIsOnlineMode) {

        // インストール済みコンテンツかどうか判定する
        var res = checkContentAuthFlgByFunc(checkContentId, inputGrade, confirmType);

        // コンテンツの認証が行われていない場合エラー文を表示
        if (res.length == 0) {
            playAlertSE();
            $("#unGradeInstallTxt").show();
            $("#gradeDisplayArea").css("border", "2px solid #FF145A");
            return;
        }

        // *** 年度更新対応 ***
        // コンテンツが認証が使用期限切れでないかどうかをチェックする
        if (confirmType != INSTALL_TYPE.ROM_INSTALL) {
            var resExpiredJson = getContentExpiredByFunc(checkContentId, inputGrade);
            var objExpired = JSON.parse(resExpiredJson);
        
            // コンテンツIDと学年で取得するため結果は一つ
            if (objExpired[0].expired_flg == 1) {
                closeDialog();
                contentReauthentication(checkContentId, inputGrade);
                return;
            }
        }
        // *** 年度更新対応 ***
    }

    // 多重ログインチェック及びログイン情報の書き込み（学習履歴をサーバに保存している場合のみ)
    if (!checkMultipleLoginAndWriteLoginInfoByFunc(checkContentId, inputGrade, inputClass, inputNumber, confirmType, contentExternalType)) {
        return;
    }

    if (mIsOnlineMode) {
        // オンライン起動でオフラインの場合ダイアログを表示
        if (!isOnlineNetworkByFunc()) {
            // アラートを表示
            var callback = function () { };
            playAlertSE();
            kbnAlert("ネットワーク接続エラー", "ネットワークに接続してWEB版を起動してください。", callback, 432);
            return;
        }

        // コンテンツの準拠、教材が設定されているかチェックする
        var checkResult = checkStandardMaterialParamByFunc(checkContentId, inputGrade);
        if (!checkResult) {
            // アラートを表示
            var callback = function () { };
            playAlertSE();
            kbnAlert("教材が設定されていません。", "コンテンツ設定から設定をしてください。", callback, 432);
            return;
        }
    }

    // コンテンツ起動
    startContent(checkContentId, inputGrade, inputClass, inputNumber, confirmType, contentExternalType);
});

/**
 * コンテンツを開く
 */
function openContent(openContentId, inputGrade, inputClass, inputNumber) {

    // コンテンツの準拠、教材が設定されているかチェックする
    var checkResult = checkStandardMaterialParamByFunc(openContentId, inputGrade);

    if (!checkResult) {
        // アラートを表示
        var callback = function () { };
        playAlertSE();
        kbnAlert("教材が設定されていません。", "コンテンツ設定から設定をしてください。", callback, 432);
        return;
    }

    // 有効期限が切れている場合ダイアログを出す
    if (!checkInvalidContentPeriodAndReAuth(openContentId, inputGrade)) {
        return;
    }

    // コンテンツの有効期限のnヶ月前にアラート表示(PFConstantsに期限を記載) 
    //var res = contentMonthBeforeExpirationByFunc(obj[0].period_to);
    var res = contentMonthBeforeExpirationByFunc(openContentId, inputGrade);

    // コンテンツのスプラッシュ画像パスを取得
    var splashPath = getContentSplashPathByFunc(openContentId, inputGrade);

    if (res && OPERATION_MODE.TEACHER_MODE == commonModeType) {
        // 有効期限nヶ月前のためアラートを出す
        var title = "本コンテンツの使用期限が迫っています。";
        var message = "継続してご利用いただくには，引き続き弊社商品のご採用をお願いいたします。";
        
        var callback = function () {
            // コンテンツのスタートページを取得
            var path = getContentStartupPathByFunc(openContentId, inputGrade, inputClass, inputNumber);
            
            // スタートページのパス
            var transitionPath = path;
            
            // コンテンツ起動
            pfOpenSplash(splashPath, transitionPath);

        };
        kbnAlert(title, message, callback, 432);

    } else {

        if (mIsOnlineMode) {
            // オンラインモード
            // オンラインモードで起動の場合、ネットワーク監視処理を実行する
            networkMonitoringProcessByFunc()
            // コンテンツのスタートページを取得(スタートページは必要無いが、学年等の情報をPF内部に保持しているので呼び出しておく）
            getContentStartupPathByFunc(openContentId, inputGrade, inputClass, inputNumber);

            // PF内部のオンラインモードを設定
            setOnlineModeByFunc(true);

            // コンテンツ設定情報を取得
            var contentSetting = JSON.parse(getContentInfoByContentIdByFunc(openContentId, inputGrade))[0];

            // コンテンツ起動
            pfOpenSplash(splashPath, contentSetting.web_startup_path);
        } else {
            // コンテンツのスタートページを取得
            var path = getContentStartupPathByFunc(openContentId, inputGrade, inputClass, inputNumber);

            // スタートページのパス
            var transitionPath = path;

            // コンテンツの初回起動フラグを更新する
            var res = updateContentOpenFlgByFunc(openContentId);

            // コンテンツ起動
            pfOpenSplash(splashPath, transitionPath);
        }
    }
}

/*
 * =================================================================
 * ボタン押下
 * =================================================================
 */

/**
 * 準拠教材設定ボタン押下処理
 */
$(document).on("click", ".downloadImg", function () {
    var standardId = $(".standardChange").val();
    var isCopy = mIsCopy;
    var isRomOnline = mIsRomOnline;
    var romInstallParameterList = new Array();

    // 全て未選択の場合にアラートを表示
    var updateFlg = false;
    var isNoSettingMaterial = true;
    if (standardId == "unSelect") {
        isNoSettingMaterial = false;
    } else {
        for (var grade = 1; grade <= 6; grade++) {
            var materialVal = $("#grade_" + grade).val();
            if (materialVal != undefined) {
                isNoSettingMaterial = false;
            }
            if (materialVal != "unSelect" && materialVal != null) {
                updateFlg = true;
                break;
            }
        }
    }
    if (!updateFlg && !isNoSettingMaterial) {
        var callback = function () {
        }
        playAlertSE();
        kbnAlert("教科書・教材設定", "最低1つの学年は選択する必要があります。", callback, 432);
        return;
    }
    //----------------------------------------------
    if (updateStandardOnly) {
        // 準拠設定のみ(教材の設定がない)の場合
        var res = updateUnSettingMaterialByFunc(contentId, standardId, confirmType);
        if (isCopy) {
            closeDialog();
            // PFをコピーして使うの場合
            pfCopyFolder();
            return;
        }
    } else {
        // 準拠設定、教材設定を行う場合
        for (var counter = 1; counter <= 6; counter++) {
            // 設定されていない場合は更新しない
            if ($("#grade_" + counter).val() == 0) {
                continue;
            }
            // 準拠、教材を登録
            var materialId = $("#grade_" + counter).val();
            if (materialId == "unSelect") {
                materialId = "";
            }
            var romInstallParameter = {};
            romInstallParameter.grade = counter;
            romInstallParameter.materialId = materialId;
            romInstallParameter.standardId = standardId;
            romInstallParameterList.push(romInstallParameter);
            updateStandardMaterialSettingByFunc(contentId, counter, standardId, materialId);
        }

        // PFがROM起動の際にファイルにコンテンツ設定情報を書き込み保存する
        if (startupMode == PF_STARTUP_MODE.ROM_MODE) {
            writeTempFolderSqlByFunc();
            mIsCancelToInstallFlg = true;
        }

        if (isCopy) {
            closeDialog();
            // PFをコピーして使うの場合
            pfCopyFolder();
            return;
        }
    }
    // 分割インストール区分を取得
    var splitInstallType = getSplitInstallTypeByFunc(contentId);

    // ROM起動からオンライン版認証
    if (isRomOnline) {
        // レジストリをチェック
        var res = checkInstallRegistry(isRomOnline);
        if (res) {
            closeDialog();
            return;
        }
    }

    // ========== ROM起動時の分割インストール対応 : start ===========
    if (!mIsOnlineMode) {
        if (runType != RUN_TYPE.RUN_ROM && INSTALL_TYPE.ROM_INSTALL == confirmType) {
            // ROM起動でインストールする場合
            if (startupMode == PF_STARTUP_MODE.INSTALL_MODE) {
                // インストールモードの場合
                // レジストリをチェック
                var res = checkInstallRegistry();
                if (res) {
                    closeDialog();
                    return;
                }
            } else {
                // PFをROM起動
                // ダイアログを閉じる
                closeDialog();
                // 分割インストール対応
                if (splitInstallType == SPLIT_INSTALL_TYPE.NONE) {
                    // ROM起動の場合レジストリチェック
                    checkRunRomSubContentFolder("");
                } else if (splitInstallType == SPLIT_INSTALL_TYPE.MATERIAL_OR_STANDARD) {
                    // 準拠、教材単位
                    splitInstallByMaterialOrStandard(contentId, installContentGrade, materialId, standardId, installConfirmType, RUN_TYPE.RUN_ROM)
                } else {
                    // インストール設定ダイアログを開く
                    var materialId = $("#grade_" + installContentGrade).val();
                    // 戻った際に当画面を復元する情報も渡す
                    var returnBackParameter = {};
                    returnBackParameter.screenType = SCREEN_TYPE.STANDARD_MATERIAL_DIALOG;
                    returnBackParameter.grade = installContentGrade;
                    returnBackParameter.installType = installConfirmType;
                    returnBackParameter.runType = runType;
                    returnBackParameter.checkAddGrade = checkAddGrade;
                    returnBackParameter.isCopy = false;
                    openInstallSettingDialog(contentId, installContentGrade, materialId, standardId, installConfirmType, returnBackParameter, RUN_TYPE.RUN_ROM, romInstallParameterList);

                }
                return;
            }

        } else if (runType != RUN_TYPE.RUN_ROM && INSTALL_TYPE.WEB_INSTALL == confirmType) {
            // Webインストールの場合
            // レジストリをチェック
            var res = checkInstallRegistry();
            if (res) {
                closeDialog();
                return;
            }
        }
    }
    // ========== ROM起動時の分割インストール対応 : end ===========

    // ダイアログを閉じる
    closeDialog();

    // ROMから実行押下時にはインストールを行わない
    if (runType == RUN_TYPE.RUN_ROM) {
        var gradeInput = getGradeInputFlgByFunc(contentId);
        var contentType = JSON.parse(getContentTypeByFunc(contentId))[0].content_type;
        // 学年入力フラグを参照
        if (JSON.parse(gradeInput)[0].grade_input_flg == 1) {
            // 学年入力あり
            InputGradeClassNumberDialog(contentId);
        }
        else {
            // 学年入力なし
            openRomContent(contentId, "0", "0", "0", contentType);
        }
        return;
    }

    if (mIsOnlineMode) {
        // オンライン起動

        // コンテンツ設定情報を取得
        var contentSetting = JSON.parse(getContentInfoByContentIdByFunc(contentId, 0))[0];
        // 認証フラグ更新
        updateAuthenticationFlgByFunc(contentId, 0, 1);
        // インストールフラグ更新
        updateInstallFlgByFunc(contentId, 0, mIsTrial);
        // オンライン用のスタートアップパスを更新
        updateOnlineStartupPathByFunc(contentId, 0, contentSetting.web_startup_path);
        // コンテンツの初回起動フラグを更新する
        updateContentOpenFlgByFunc(contentId);

        // 学年入力有無情報取得
        var res = getGradeInputFlgByFunc(contentId);

        // クロス利用の場合、トップ画面へ遷移
        if (mIsGoingTopForCrossUse) {
            kbnPageTransition("index.html");
            mIsGoingTopForCrossUse = false;
            return;
        }

        //　学年入力ダイアログ表示チェック
        if (JSON.parse(res)[0].grade_input_flg == 1) {
            // 学年入力する場合
            InputGradeClassNumberDialog(contentId);
        } else {
            // 学年入力しない場合
            openContent(contentId, undefined, 1, 1);
        }

        // クロス利用かどうか
        var crossUseContentId = getCrossContentId();
        if (crossUseContentId) {
            // 特殊認証の場合、クロス利用案内を出さない
            if (mIsSpecialAuthCode) {
                // 処理なし
            } else {
                // クロス利用可能時
                contentCrossUse(crossUseContentId, confirmType);
            }
        }
    } else {
        // インストール
        switch (splitInstallType) {
            case SPLIT_INSTALL_TYPE.NONE: // 未対応
                if (installConfirmType == INSTALL_TYPE.WEB_INSTALL) {
                    // webコンテンツのインストールを開始する
                    contentInstall(installContentGrade);
                } else {
                    // romコンテンツのインストールを開始する
                    installRomContentByFunc(contentId, installContentGrade);
                }
                break;
            case SPLIT_INSTALL_TYPE.MATERIAL_OR_STANDARD: // 準拠、教材単位
                // インストール開始
                splitInstallByMaterialOrStandard(contentId, installContentGrade, materialId, standardId, installConfirmType, RUN_TYPE.RUN_WEB)
                break;
            case SPLIT_INSTALL_TYPE.INDIVIDUAL: // 個別
                // インストール設定ダイアログを開く
                var materialId = $("#grade_" + installContentGrade).val();
                // 戻った際に当画面を復元する情報も渡す
                var returnBackParameter = {};
                returnBackParameter.screenType = SCREEN_TYPE.STANDARD_MATERIAL_DIALOG;
                returnBackParameter.grade = installContentGrade;
                returnBackParameter.installType = installConfirmType;
                returnBackParameter.runType = runType;
                returnBackParameter.checkAddGrade = checkAddGrade;
                returnBackParameter.isCopy = false;

                openInstallSettingDialog(contentId, installContentGrade, materialId, standardId, installConfirmType, returnBackParameter, RUN_TYPE.RUN_WEB);
                break;
            default:
                alert("分割インストール区分が取得できませんでした。");
                break;
        }
    }
});

// キャンセルボタン
$(document).on("click", ".cancelImg", function () {

    // 認証状態をキャンセル
    cancelAuth();

    // クリア
    updateReturnConentsInfoByFunc(contentId, installContentGrade);

    // グローバル変数をクリア(クリアしないと別学年の認証で失敗する)
    grade = 0;

    // ダイアログを閉じる
    closeDialog();

    // オンラインモードをオフラインへ
    mIsOnlineMode = false;

    // ROMからのWeb版インストール初期化
    mIsRomOnlineConfrimDialog = false;

    // クロス利用時はキャンセルボタン押下でインストール開始
    if (mIsCancelToInstallFlg && contentId != openContentId) {
        checkAndkickInstaller("", mIsRomOnline, contentId);
        return;
    }

    // クロス利用の場合、トップ画面へ遷移
    if (mIsGoingTopForCrossUse) {
        kbnPageTransition("index.html");
        mIsGoingTopForCrossUse = false;
    }
});

/**
 * id ： 切り替えたい画像のID
 * flg : 切り替え動作判定
 */
function romImgTapEvent(id, flg) {
    
    var elem = $("#" + id);
    var src = elem.attr("src");

    if (flg) {
        // タップ時の画像に変更
        src = src.replace("_0.png", "_0_tap.png");
    } else {
        src = src.replace("_0_tap.png", "_0.png");
    }

    // 画像変更
    elem.attr("src", src);
}

// 削除ボタン
$(document).on("mousedown", "#deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete_tap.svg");
});

$(document).on("mouseup", "#deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

$(document).on("mouseout", "#deleteBtn", function () {
    $(this).attr("src", "../img/dialog/btn_key-delete.svg");
});

// 学年入力情報をクリアする
function inputNumberClear() {
    nowInputClass = "";
    nowInputGrade = "";
    nowInputNumber = "";
}


// 認証コンテンツ起動（content-detail.jsからも呼び出しているので注意)
function startContentCommon(id) {
    var dammyId = id.split("_");
    // コンテンツID
    var content_id = dammyId[1];
    // 学年入力フラグ
    var gradeInputFlg = dammyId[3];
    // コンテンツ種別
    var contentType = dammyId[5];
    contentExternalType = dammyId[5];
    // 学年
    var grade = dammyId[7];

    var installContentGrade = grade;

    checkContentId = content_id;
    contentId = content_id;

    // Flashが必要なコンテンツの場合、バージョンチェックし、インストールを促す
    if (isNeedUpdateFlashPlayer()) {
        callback = function () {
            installFlashPlayerByFunc();
        };

        var title = undefined;
        var massage = "コンテンツの利用には，FlashPlayer 11.0以降が必要です。<br> インストールしてください。";
        kbnConfirm(title, massage, callback, 520);
        return;
    }

    // VisualStudio2013 C++再頒布パッケージのインストール要否チェック＆インストール確認
    if (!checkAndInstallVCRuntime(contentId)) {
        return;
    }

    if (contentType == CONTENT_START_TYPE.EXTERNALFILE_START) {
        if (contentId == CONTENT_ID.STOP_WATCH) {
            // ストップウォッチの起動
            runStopwatchFromPF();
            return;
        }

        if (gradeInputFlg == 0) {
            // コンテンツのスタートページを取得
            var path = getContentStartupPathByFunc(checkContentId, grade, "1", "0");

            // コンテンツの初回起動フラグを更新する
            var res = updateContentOpenFlgByFunc(checkContentId);

            // 外部ファイルの起動
            openRunExternalFile(checkContentId, grade, path);
            return;

        }
        else {
            // 学年入力あり
            InputGradeClassNumberDialog(checkContentId);
        }


    } else {
        // ファイル起動
        if (gradeInputFlg == 0) {
            // 学年入力なし
            openContent(contentId, grade, "0", "0");

        }
        else {
            // 学年入力あり
            InputGradeClassNumberDialog(checkContentId);
        }
    }
}

// PFバージョンアップ後初回起動時のチェック
function isFirstByPFVersionUp() {
    // 更新結果ファイルをチェック
    var res;
    var title = "ひまわりポケットの更新";
    var message;
    switch (getVersionUpPFResultAndUpdateVersionByFunc()) {
        case VERSION_UP_RESULT.NONE:
            res = false;
            break;
        case VERSION_UP_RESULT.SUCCESS:
            message = "ご利用中のひまわりポケットは最新です。";
            res = true;
            break;
        case VERSION_UP_RESULT.FAIL:
            playAlertSE();
            message = "ひまわりポケットの更新に失敗しました。";
            res = true;
            break;
    }

    if (message) {
        var callback = function () {
            location.reload();
        };
        kbnAlert(title, message, callback, 360);
    }

    return res;
}

// ひまポケレジストリをチェックし、差分がある場合はレジストリ更新
function checkRegistryHimapokeVersion() {
    // DBからひまポケバージョンを取得
    var resJson = getLocalVersionInfoByFunc();
    var localVersion;
    if (resJson) {
        if (kbnCheckTerminalType()) {
            // iOSの場合処理なし
            return true;;
        } else {
            localVersion = _.findWhere(JSON.parse(resJson), { type: 1 });
        }
    }
    // レジストリからバージョン情報取得
    var registryVersion = getRegistryHimapokeVersionByFunc();
    if (registryVersion && localVersion.version) {
        if (localVersion.version != registryVersion) {
            // 差分がある場合
            var title = "";
            var message = "ひまわりポケットの更新をしています。<br />更新を完了させるために，ひまわりポケットの再起動が必要です。<br />再起動しますか。";
            var width = 432;
            // レジストリに書き込めなかった場合、管理者に昇格して再起動
            var isSuccess = writeRegistryVersion(title, message, width, localVersion.version);
            if (!isSuccess) {
                return false;
            }
        }
    }
    return true;
}
